Changelog
*********


Python seguinte
===============

*Data de lançamento: XXXX-XX-XX*


Windows
-------

* gh-149786: Fixes virtual environment launchers on Windows free-
  threaded builds.

* gh-124111: Updated Windows builds to use Tcl/Tk 9.0.3.

* gh-138489: Windows distributions now include a "build-details.json"
  file (see **PEP 739**). The legacy installer does not install it,
  but all other distributions from python.org and all preset
  configurations in the "PC\layout" script will include one.


Testes
------

* gh-149776: Fix test_socket on Linux kernel 7.1 and newer: skip UDP
  Lite tests if it's not supported. Patch by Victor Stinner.


Segurança
---------

* gh-149698: Update bundled libexpat to version 2.8.1 for the fix for
  **CVE 2026-45186**.

* gh-87451: The "ftplib" module's undocumented "ftpcp" function no
  longer trusts the IPv4 address value returned from the source server
  in response to the "PASV" command by default, completing the fix for
  CVE-2021-4189.  As with "ftplib.FTP", the former behavior can be re-
  enabled by setting the "trust_server_pasv_ipv4_address" attribute on
  the source "ftplib.FTP" instance to "True".  Thanks to Qi Deng at
  Aurascape AI for the report.

* gh-149474: Fix the binary writer in "profiling.sampling" not firing
  the audit (**PEP 578**) when creating the output file. The writer
  and the reader now accept any path-like object. Patch by Maurycy
  Pawłowski-Wieroński.

* gh-149486: "tarfile.data_filter()" now validates link targets using
  the same normalised value that is written to disk, strips trailing
  separators from the member name when resolving a symlink's
  directory, and rejects link members that would replace the
  destination directory itself. This closes several path-traversal
  bypasses of the "data" extraction filter.

* gh-149018: Improved protection against XML hash-flooding attacks in
  "xml.parsers.expat" and "xml.etree.ElementTree" when Python is
  compiled with libExpat 2.8.0 or later.


Biblioteca
----------

* gh-149980: Fix "tarfile" so that GNU long-name directory entries
  have all trailing slashes stripped from their names, matching the
  behavior for short-name entries.  Previously, only a single trailing
  slash was removed.

* gh-146452: Fix race condition when pickling dictionaries in free
  threaded builds. Also reduce critical section cover.

* gh-79413: Update "dataclasses.make_dataclass()" to add a *qualname*
  parameter. The *qualname* parameter will be used to set the
  "__qualname__" of the created "dataclass".

* gh-149921: Fix reference leaks in error paths of the
  "_interpchannels" and "_interpqueues" extension modules.

* gh-142349: Add "lazy" to the list of support topic by "help()".

* gh-149816: Fix a race condition in "_random.Random.__init__" method
  in free-threading mode.

* gh-149801: Add IANA registered names and aliases with leading zeros
  before number (like IBM00858, CP00858, IBM01140, CP01140) for
  corresponding codecs.

* gh-149720: Remove support for undotted *ext* in
  "mimetypes.MimeTypes.add_type()".

* gh-149718: Coalesce consecutive identical stack frames in Tachyon,
  so aggregating collectors (pstats, collapsed, flamegraph, gecko)
  receive one collect. Improves sample rate 3x, error rate and missed
  rate drop by 70%. Patch by Maurycy Pawłowski-Wieroński.

* gh-149701: Fix bad return code from Lib/venv/bin/activate if hashing
  is disabled

* gh-149504: Fix "site.addsitedir()" to allow re-entrant calls from
  within startup files.  Previously, a ".pth" file containing an
  "import" line that called "site.addsitedir()" (or a ".start" entry
  point doing the same) could crash with "RuntimeError: dictionary
  changed size during iteration" during site initialization, breaking
  tools such as "uv run --with".

* gh-149634: Remove deprecated and unused "tarfile.TarInfo.tarfile"
  attribute.

* gh-139489: Add "xml.is_valid_text()" to "xml.__all__".

* gh-149614: Fix a regression that broke the ability to deepcopy
  "argparse.ArgumentParser" instances.

* gh-149600: Remove deprecated "asyncio.iscoroutinefunction()"
  function.

* gh-149598: Remove support of deprecated *strm* argument for
  "logging" handlers.

* gh-149595: Remove the "sys._enablelegacywindowsfsencoding()"
  function which has been deprecated since Python 3.13.

* gh-149567: Remove the "shutil.ExecError" exception which has been
  deprecated since Python 3.14.

* gh-112821: In the REPL, autocompletion might run arbitrary code in
  the getter of a descriptor. If that getter raised an exception,
  autocompletion would fail to present any options for the entire
  object.  Autocompletion now works as expected for these objects.

* gh-149436: Improve performance of "inspect.getattr_static()".

* gh-149537: Remove kw parameters from python version of
  "functools.reduce()" function.

* gh-149530: Removed "symtable.Class.get_methods()" which has been
  deprecated since 3.14.

* gh-149528: Remove "annotationlib.ForwardRef._evaludate" deprecated
  method.

* gh-149388: Make "asyncio.windows_utils.PipeHandle" closing
  idempotent.

* gh-149499: Removed the "sysconfig.expand_makefile_vars()" function
  which has been deprecated since Python 3.14. Use the "vars" argument
  of "sysconfig.get_paths()" instead.

* gh-149464: Add "os.pidfd_getfd()" for duplicating a file descriptor
  from another process via a pidfd.  Available on Linux 5.6+. Patch by
  Maurycy Pawłowski-Wieroński.

* gh-148441: "xml.parsers.expat": prevent a crash in
  "CharacterDataHandler()" when the character data size exceeds the
  parser's "buffer size".

* gh-146452: Fix segfault in "pickle" when pickling a dictionary
  concurrently mutated by another thread in the free-threaded build.

* gh-140924: Add "locale.localize()", "locale.delocalize()" and
  platform-specific locale constants from the "_locale" module to
  "locale.__all__".

* gh-140344: The classes "ast.slice", "ast.ExtSlice", "ast.Index",
  "ast.Suite", "ast.AugLoad", "ast.AugStore", and "ast.Param",
  deprecated since Python 3.9, now issue deprecation warnings on use.
  They are now scheduled for removal in Python 3.21.

  The "dims" property of "ast.Tuple" objects, deprecated since Python
  3.9, now issues a deprecation warning when accessed. The property is
  scheduled for removal in Python 3.21. Use the (non-deprecated)
  "elts" property of "ast.Tuple" objects instead.

  The deprecated global names are also no longer imported by "from ast
  import *".

* gh-86533: The "os.makedirs()" function and "pathlib.Path.mkdir()"
  method now have a *parent_mode* parameter to specify the mode for
  intermediate directories when creating parent directories. This
  allows one to match the behavior from Python 3.6 and earlier for
  "os.makedirs()".

* gh-128110: Fix bug in the parsing of "email" address headers that
  could result in extraneous spaces in the decoded text when using a
  modern email policy. Space between pairs of adjacent **RFC 2047**
  encoded-words is now ignored, per section 6.2 (and consistent with
  existing parsing of unstructured headers like *Subject*).

* bpo-45509: Gzip headers are now checked for corrupted NAME, COMMENT
  and HCRC fields.


Núcleo e embutidos
------------------

* gh-149590: Fix crash when faulthandler is imported more than once.

* gh-138325: Speed up converting a list to a tuple in the
  "tuple(genexpr)" fast path and in starred tuple displays (e.g. "(*a,
  *b)") by stealing the list's items into the tuple instead of copying
  them.

* gh-149816: Fix a race condition in "_PyBytes_FromList" in free-
  threading mode.

* gh-149816: Fix a race condition in "memoryview" with free-threading.

* gh-139808: Add branch protections for AArch64 (BTI/PAC) in assembly
  code used by "-X perf_jit" (Linux perf profiler integration).

* gh-149676: Fix "frozendict | frozendict" hash.

* gh-149642: Allow imports inside "exec()" calls within functions
  under "PYTHON_LAZY_IMPORTS=all".

* gh-144957: Fix lazy "from" imports of module attributes provided by
  module-level "__getattr__".

* gh-149459: Fix a crash in the JIT optimizer when a specialized
  "LOAD_SPECIAL" guard deoptimized after inserting the synthetic
  "NULL" stack entry.

* gh-75723: Avoid re-executing ".pth" files when "site.addsitedir()"
  is called for a known directory.


API C
-----

* gh-149725: Add "PySentinel_CheckExact()" for exact "sentinel" type
  tests to accompany the existing "PySentinel_Check()".

* gh-145235: Made "PyDict_AddWatcher()", "PyDict_ClearWatcher()",
  "PyDict_Watch()", and "PyDict_Unwatch()" thread-safe on the *free
  threaded* build.


Construção
----------

* gh-115119: Removed bundled copy of the libmpdec, use system library
  if it's available. Patch by Sergey B Kirpichev.


Python 3.15.0 beta 1
====================

*Release date: 2026-05-07*


Segurança
---------

* gh-149254: Update Android and iOS installer to use OpenSSL 3.5.6.

* gh-149017: Update bundled libexpat to version 2.8.0.

* gh-148252: Fixed string table and sample record bounds checks in
  "_remote_debugging" when decoding certain ".pyb" inputs on 32-bit
  builds. Patch by Maurycy Pawłowski-Wieroński.

* gh-90309: Base64-encode values when embedding cookies to JavaScript
  using the "http.cookies.BaseCookie.js_output()" method to avoid
  injection and escaping.

* gh-148808: Added buffer boundary check when using "nbytes" parameter
  with "asyncio.AbstractEventLoop.sock_recvfrom_into()". Only relevant
  for Windows and the "asyncio.ProactorEventLoop".

* gh-148395: Fix a dangling input pointer in "lzma.LZMADecompressor",
  "bz2.BZ2Decompressor", and internal "zlib._ZlibDecompressor" when
  memory allocation fails with "MemoryError", which could let a
  subsequent "decompress()" call read or write through a stale pointer
  to the already-released caller buffer.

* gh-148252: Fixed stack depth calculation in "_remote_debugging" when
  decoding certain ".pyb" inputs on 32-bit builds. Issue originally
  identified and diagnosed by Tristan Madani (@TristanInSec on
  GitHub).

* gh-148178: Hardened "_remote_debugging" by validating remote debug
  offset tables before using them to size memory reads or interpret
  remote layouts.

* gh-148169: A bypass in "webbrowser" allowed URLs prefixed with
  "%action" to pass the dash-prefix safety check.

* gh-146581: Fix vulnerability in "shutil.unpack_archive()" for ZIP
  files on Windows which allowed to write files outside of the
  destination tree if the patch in the archive contains a Windows
  drive prefix. Now such invalid paths will be skipped. Files
  containing ".." in the name (like "foo..bar") are no longer skipped.

* gh-137586: Fix a PATH-injection vulnerability in "webbrowser" on
  macOS where "osascript" was invoked without an absolute path. The
  new "MacOS" class uses "/usr/bin/open" directly, eliminating the
  dependency on "osascript" entirely.

* gh-146333: Fix quadratic backtracking in
  "configparser.RawConfigParser" option parsing regexes ("OPTCRE" and
  "OPTCRE_NV"). A crafted configuration line with many whitespace
  characters could cause excessive CPU usage.

* gh-146211: Reject CR/LF characters in tunnel request headers for the
  HTTPConnection.set_tunnel() method.


Núcleo e embutidos
------------------

* gh-148940: Revert the process size based deferral of garbage
  collection (gh-133464). The performance issue this change resolves
  is also fixed by gh-142562.  This approach has the problem that
  process size as seen by the OS (e.g. the resident size or RSS) does
  not immediately decrease after cyclic garbage is freed since
  mimalloc defers returning memory of the OS. This change applies to
  the free-threaded GC only.

* gh-149243: Check for recursion limits in "CALL_ALLOC_AND_ENTER_INIT"
  opcode.

* gh-126910: Add support for unwinding JIT frames using GNU backtrace.
  Patch by Diego Russo and Pablo Galindo

* gh-149171: Allow assignment to the "__module__" attribute of
  "typing.TypeAliasType" instances.

* gh-149122: Fix a crash in optimized calls to "all()", "any()",
  "tuple()", "list()", and "set()" with an async generator expression
  argument (for example, "tuple(await x for x in y)"). These calls now
  correctly raise "TypeError" instead of crashing.

* gh-149049: Fix stack underflow for "BINARY_OP" in tier 2.

* gh-83065: Fix a deadlock that could occur when one thread is
  importing a submodule (for example "import pkg.sub.mod") while
  another thread is importing one of its parent packages (for example
  "import pkg.sub") and that parent's "__init__.py" itself imports the
  submodule. The import system now acquires module locks in
  hierarchical (parent-before-child) order so the two threads
  serialise instead of raising "_DeadlockError".

* gh-113956: Fix a data race in "sys.intern()" in the free-threaded
  build when interning a string owned by another thread. An interned
  copy owned by the current thread is used instead when it is not safe
  to immortalize the original.

* gh-148850: Fix the memory sanitizer false positive in
  "os.getrandom()".

* gh-148820: Fix a race in "_PyRawMutex" on the free-threaded build
  where a "Py_PARK_INTR" return from "_PySemaphore_Wait" could let the
  waiter destroy its semaphore before the unlocking thread's
  "_PySemaphore_Wakeup" completed, causing a fatal "ReleaseSemaphore"
  error.

* gh-148829: Add "sentinel", implementing **PEP 661**. PEP by Tal
  Einat; patch by Jelle Zijlstra.

* gh-146270: Fix a sequential consistency bug in "structmember.c".

* gh-148766: The interpreter help (such as "python --help") is now in
  color. Patch by Hugo van Kemenade.

* gh-148571: Fix a crash in the JIT optimizer when specialized opcode
  families inherited incompatible recorded operand layouts.

* gh-148653: Forbid "marshalling" recursive code objects, "slice" and
  "frozendict" objects which cannot be correctly unmarshalled.

* gh-142516: Forward-port the generational cycle garbage collector to
  the default 3.15 build, replacing the incremental collector while
  leaving the free-threaded collector unchanged.

* gh-146462: Added "PyTypeObject.tp_basicsize",
  "PyTypeObject.tp_dictoffset", and "PyHeapTypeObject.ht_cached_keys"
  offsets to "_Py_DebugOffsets" to support version-independent read-
  only dict introspection tools.

* gh-145239: Unary plus is now accepted in "match" literal patterns,
  mirroring the existing support for unary minus. Patch by Bartosz
  Sławecki.

* gh-148515: Fix a bug in the JIT optimizer reading operands for uops
  with multiple caches.

* gh-148390: Fix an undefined behavior in "memoryview" when using the
  native boolean format ("?") in "cast()". Previously, on some common
  platforms, calling "memoryview(b).cast("?").tolist()" incorrectly
  returned "[False]" instead of "[True]" for any even byte *b*. Patch
  by Bénédikt Tran.

* gh-148418: Fix a possible reference leak in a corrupted "TYPE_CODE"
  marshal stream.

* gh-148393: Fix data races between "PyDict_Watch()" /
  "PyDict_Unwatch()" and concurrent dict mutation in the *free-
  threaded build*.

* gh-148398: Fix a bug in the JIT optimizer where class attribute
  loads were not invalidated after type mutation.

* gh-146527: Add a "GCMonitor" class with a "get_gc_stats" method to
  the "_remote_debugging" module to allow reading GC statistics from
  an external Python process without requiring the full
  "RemoteUnwinder" functionality. Patch by Sergey Miryanov and Pablo
  Galindo.

* gh-148284: Fix high stack consumption in Python's interpreter loop
  on Clang 22 by setting function limits for inlining when building
  with computed gotos.

* gh-148037: Remove critical section from "PyCode_Addr2Line()" in
  free-threading.

* gh-115802: Improve JIT code generation on Linux AArch64 by reducing
  the indirect call to external symbols. Patch by Diego Russo.

* gh-148189: Repaired undercount of bytes in type-specific free lists
  reported by sys._debugmallocstats(). For types that participate in
  cyclic garbage collection, it was missing two pointers used by GC.

* gh-148222: Fix vectorcall support in "types.GenericAlias" when the
  underlying type does not support the vectorcall protocol. Fix
  possible leaks in "types.GenericAlias" and "types.UnionType" in case
  of memory error.

* gh-148208: Fix recursion depth leak in "PyObject_Print()"

* gh-95004: The specializing interpreter now specializes for
  "enum.Enum" improving performance and scaling in free-threading.
  Patch by Kumar Aditya.

* gh-149202: Enable frame pointers by default for GCC-compatible
  CPython builds, including "-mno-omit-leaf-frame-pointer", "-marm" on
  32-bit ARM, and/or "-mbackchain" on s390x platforms when the
  compiler supports them, so profilers and debuggers can unwind native
  interpreter frames more reliably. Users can pass "--without-frame-
  pointers" to "./configure" to opt out.

* gh-148014: Accept a function name in "-X presite" command line
  option and "PYTHON_PRESITE" environment variable. Patch by Victor
  Stinner.

* gh-147998: Fixed a memory leak in interpreter helper calls so
  cleanup works when an operation falls across interpreter boundaries.
  Patch by Maurycy Pawłowski-Wieroński.

* gh-146455: Fix O(N²) compile-time regression in constant folding
  after it was moved from AST to CFG optimizer.

* gh-146306: Specialize float true division in the tier 2 optimizer
  with inplace mutation for uniquely-referenced operands.

* gh-142186: Global "sys.monitoring" events can now be turned on and
  disabled on a per code object basis. Returning "DISABLE" from a
  callback disables the event for the entire code object (for the
  current tool).

* gh-126910: Add support for unwinding JIT frames using GDB. Patch by
  Diego Russo and Pablo Galindo.

* gh-146031: The unstable API _PyInterpreterState_SetEvalFrameFunc has
  a companion function
  _PyInterpreterState_SetEvalFrameAllowSpecialization to specify if
  specialization should be allowed. When this option is set to 1 the
  specializer will turn Python -> Python calls into specialized
  opcodes which the replacement interpreter loop can choose to respect
  and perform inlined dispatch.

* gh-145278: The "encodings" is now partially frozen, including the
  "aliases" and "utf_8" submodules.

  The "linecache" is now frozen.

* gh-134584: Optimize and eliminate redundant ref-counting for
  "MAKE_FUNCTION" in the JIT.

* gh-143886: Reorder function annotations so positional-only arguments
  are returned before other arguments. This fixes how
  "functools.singledispatch()" registers functions with positional-
  only arguments.

* gh-98894: Restore "function__entry" and "function__return"
  DTrace/SystemTap probes that were broken since Python 3.11.

* gh-116021: Support for creating instances of abstract AST nodes from
  the "ast" module is deprecated and scheduled for removal in Python
  3.20. Patch by Brian Schubert.

* gh-137814: Fix the "__qualname__" attribute of "__annotate__"
  functions on functions.

* gh-137600: "ast": The constructors of AST nodes now raise a
  "TypeError" when a required argument is omitted or when a keyword
  argument that does not map to a field on the AST node is passed.
  These cases had previously raised a "DeprecationWarning" since
  Python 3.13. Patch by Brian Schubert.

* gh-137293: Fix "SystemError" when searching ELF Files in
  "sys.remote_exec()".

* gh-135357: Add support for "socket.SO_PASSRIGHTS" on Linux.

* gh-134690: Removed deprecated in **PEP 626** since Python 3.12
  "codeobject.co_lnotab" from "types.CodeType".

* gh-100239: Specialize "BINARY_OP" for concatenation of lists and
  tuples, and propagate the result type through "_BINARY_OP_EXTEND" in
  the tier 2 optimizer so that follow-up type guards can be
  eliminated.


Biblioteca
----------

* gh-148823: Defer the import of "_colorize" in "argparse" until
  needed for coloring output.

* gh-141560: Add an *annotation_format* parameter to
  "inspect.getfullargspec()".

* gh-139489: Add the "xml.is_valid_text()" function, which allows to
  check whether a string can be used in the XML document.

* gh-142389: Add backticks to stdlib argparse help to display in
  colour. Patch by Hugo van Kemenade.

* gh-149377: Update bundled pip to 26.1.1

* gh-142389: Add backtick markup support in "argparse" option help
  text to highlight inline code when color output is enabled. Patch by
  Hugo van Kemenade.

* gh-148675: Remove "F" and "D" formats from "array" and "memoryview".
  Patch by Victor Stinner.

* gh-149342: Fix "_remote_debugging" binary writing so that sampling a
  thread whose Python frame stack is empty (for example while it is in
  a C call or mid-syscall) no longer raises "RuntimeError("Invalid
  stack encoding type")", and so that "BinaryWriter.total_samples"
  after "finalize()" or context-manager exit includes samples flushed
  from the RLE buffer. Patch by Maurycy Pawłowski-Wieroński.

* gh-149010: The "inspect" module CLI now reports as much information
  as it has available for non-source modules when "--details" is
  specified, and provides an error message rather than a traceback
  when "--details" is omitted. It also reports improved information
  when the given target location is not the target's defining location
  and when the given target is a data value rather than a class or
  function definition.

* gh-146609: Use "argparse" for colour help "timeit" CLI. Patch by
  Hugo van Kemenade.

* gh-142389: Add backticks for colour to regrtest and pdb's help
  description. Patch by Hugo van Kemenade.

* gh-144384: Lazily import "_colorize". Patch by Hugo van Kemenade.

* gh-149321: Fix import cycles exposed by running standard library
  modules with "-X lazy_imports=none".

* gh-145378: Generate consistent colors for "pdb" commands in "pdb"
  REPL.

* gh-149296: Add a "dump" subcommand to "profiling.sampling" that
  prints a single traceback-style snapshot of a running process's
  Python stack, including per-thread status, source line highlighting,
  optional bytecode opcode names, and async-aware task reconstruction.
  Patch by Pablo Galindo.

* gh-143231: A *module* attribute has been added to
  "warnings.WarningMessage".

* gh-148675: "ctypes": Change the "_type_" of "c_float_complex",
  "c_double_complex" and "c_longdouble_complex" from "F", "D" and "G"
  to "Zf", "Zd" and "Zg" for compatibility with numpy. Patch by Victor
  Stinner.

* gh-148675: The "array.typecodes" type changed from "str" to "tuple"
  to support type codes longer than 1 character ("Zf" and "Zd"). Patch
  by Victor Stinner.

* gh-149221: Catch rare math domain error for
  "random.binomialvariate()".

* gh-149231: In "tomllib", the number of parts in TOML keys is now
  limited.

* gh-143231: "unittest.TestCase.assertWarns()" and
  "unittest.TestCase.assertWarnsRegex()" no longer swallow warnings
  that do not match the specified category or regex. Nested context
  managers are now supported.

* gh-149214: Fix "_remote_debugging" misreading non-ASCII Unicode
  strings (Latin-1, BMP and non-BMP) from a remote process. Filenames
  and function names that contain non-ASCII characters are now
  reported correctly in stack traces, the sampling profiler, and
  "asyncio" task introspection.

* gh-149189: "pprint" now uses modern defaults: "indent=4" and
  "width=88", and the default "compact=False" output is now formatted
  similar to pretty-printed "json.dumps()", with opening parentheses
  and brackets followed by a newline and the contents indented by one
  level. The *expand* parameter, added in 3.15.0a8, has been removed;
  "compact=False" (the default) now produces the former "expand=True"
  layout. Patch by Hugo van Kemenade.

* gh-149173: Fix inverted "PYTHON_BASIC_REPL" environment check in
  "pdb._pyrepl_available".

* gh-149117: Fix "runpy.run_module()" and "runpy.run_path()" to set
  the "name" attribute on the "ImportError" they raise.

* gh-149148: "ensurepip": Upgrade bundled pip to 26.1. This version
  fixes the **CVE 2026-3219** vulnerability. Patch by Victor Stinner.

* gh-149009: Validate that "profiling.sampling" binary profiles do not
  contain more unique (thread, interpreter) pairs than declared in the
  header. Patch by Maurycy Pawłowski-Wieroński.

* gh-148292: "ssl": Update "ssl.SSLSocket" and "ssl.SSLObject" for
  OpenSSL 4. The classes now remember if they get a "ssl.SSLEOFError".
  In this case, following "read()", "sendfile()", "write()", and
  "do_handshake()" calls raise "ssl.SSLEOFError" without calling the
  underlying OpenSSL function. Thanks to that, "ssl.SSLSocket" behaves
  the same on all OpenSSL versions on EOF.  Patch by Victor Stinner.

* gh-149085: Add a *max_threads* keyword argument to
  "faulthandler.dump_traceback()",
  "faulthandler.dump_traceback_later()", "faulthandler.enable()", and
  "faulthandler.register()".

* gh-148641: "pkgutil.resolve_name()" gets a new optional, keyword-
  only argument called "strict".  The default is "False" for backward
  compatibility.

* gh-148093: Fix an out-of-bounds read of one byte in
  "binascii.a2b_uu()". Raise "binascii.Error", instead of reading past
  the buffer end.

* gh-149083: "dataclasses.MISSING" and "dataclasses.KW_ONLY" are now
  instances of "sentinel".

* gh-148914: Fix memoization of in-band "PickleBuffer" in the Python
  implementation of "pickle". Previously, identical "PickleBuffer"s
  did not preserve identity, and empty writable "PickleBuffer"
  memoized an empty bytearray object in place of "b''", so the
  following references to "b''" were unpickled as an empty bytearray
  object.

* gh-149026: Add colour to "pickletools" CLI output. Patch by Hugo van
  Kemenade.

* gh-148991: Add colour to "tokenize" CLI output. Patch by Hugo van
  Kemenade.

* gh-138907: Support **RFC 9309** in "urllib.robotparser".

* gh-148981: Add *color* parameter to "ast.dump()".

* gh-148849: Deprecate "http.cookies.Morsel.js_output()" and
  "http.cookies.BaseCookie.js_output()", which will be removed in
  Python 3.19. Use "http.cookies.Morsel.output()" or
  "http.cookies.BaseCookie.output()" instead.

* gh-146311: Add a *canonical* keyword-only parameter to the base16,
  base32, base64, base85, ascii85, and Z85 decoders in "base64" and
  "binascii". When true, encodings with non-zero padding bits
  (base16/32/64) or non-canonical encodings (base85/ascii85) are
  rejected. Single-character final groups in "binascii.a2b_ascii85()"
  and "binascii.a2b_base85()" are now always rejected as encoding
  violations, regardless of *canonical*; previously they were silently
  ignored and produced no output bytes.

* gh-148947: Fix crash in "@dataclasses.dataclass" with "slots=True"
  that occurred when a function found within the class had an empty
  "__class__" cell.

* gh-148680: "ForwardRef" objects that contain internal names to
  represent known objects now show the "type_repr" of the known object
  rather than the internal "__annotationlib_name_x__" name when
  evaluated as strings.

* gh-124397: The threading module added tooling to support concurrent
  iterator access: "threading.serialize_iterator",
  "threading.synchronized_iterator()", and
  "threading.concurrent_tee()".

* gh-148801: "xml.etree.ElementTree": Fix a crash in
  "Element.__deepcopy__" on deeply nested trees.

* gh-148735: "xml.etree.ElementTree": Fix a use-after-free in
  "Element.findtext" when the element tree is mutated concurrently
  during the search.

* gh-148740: Fix usage for "uuid" command-line interface to support a
  custom namespace be provided for uuid3 and uuid5.

* gh-148688: "bz2", "compression.zstd", "lzma", "zlib": Fix a double
  free on memory allocation failure. Patch by Victor Stinner.

* gh-148675: "array", "struct": Add support for "Zd" and "Zf" formats
  for double complex and float complex. Patch by Victor Stinner.

* gh-148651: Fix reference leak in "compression.zstd.ZstdDecompressor"
  when an invalid option key is passed.

* gh-148641: **PEP 829** (package startup configuration files)
  implements a new format "<name>.start" parallel to "<name>.pth"
  files, to replace "import" lines in the latter.

* gh-148639: Implement **PEP 800**, adding the "@typing.disjoint_base"
  decorator. Patch by Jelle Zijlstra.

* gh-148615: Fix "pdb" to accept standard -- end of options separator.
  Reported by haampie. Patched by Shrey Naithani.

* gh-146553: Fix infinite loop in "typing.get_type_hints()" when
  "__wrapped__" forms a cycle. Patch by Shamil Abdulaev.

* gh-148599: Update the "socket" module's WSA error messages to match
  official documentation.

* gh-148508: An intermittent timing error when running SSL tests on
  iOS has been resolved.

* gh-144881: "asyncio" debugging tools ("python -m asyncio ps" and
  "pstree") now retry automatically on transient errors that can occur
  when attaching to a process under active thread delegation. The
  number of retries can be controlled with the "--retries" flag. Patch
  by Bartosz Sławecki.

* gh-148518: If an email containing an address header that ended in an
  open double quote was parsed with a non-"compat32" policy, accessing
  the "username" attribute of the mailbox accessed through that header
  object would result in an "IndexError". It now correctly returns an
  empty string as the result.

* gh-148464: Add missing "__ctype_le/be__" attributes for
  "c_float_complex" and "c_double_complex". Patch by Sergey B
  Kirpichev.

* gh-148370: "configparser": prevent quadratic behavior when a
  "ParsingError" is raised after a parser fails to parse multiple
  lines. Patch by Bénédikt Tran.

* gh-121190: "importlib.resources.files()" now emits a more meaningful
  error message when module spec is None (as found in some "__main__"
  modules).

* gh-127012: "importlib.abc.Traversable.read_text" now allows/solicits
  an "errors" parameter.

* gh-137855: Improve import time of "dataclasses" module by lazy
  importing "re" and "copy" modules.

* gh-148352: Add more color to "calendar"'s CLI output. Patch by Hugo
  van Kemenade.

* gh-148254: Use singular "sec" instead of "secs" in "timeit" verbose
  output for consistency with other time units.

* gh-130472: Integrate fancycompleter with import completions.

* gh-148241: "json": Fix serialization: no longer call "str(obj)" on
  "str" subclasses. Patch by Victor Stinner.

* gh-148225: The "profiling.sampling" "replay" command now rejects
  non-binary profile files with a clear error explaining that replay
  only accepts files created with "--binary".

* gh-148192: "email.generator.Generator._make_boundary" could fail to
  detect a duplicate boundary string if linesep was not n. It now
  correctly detects boundary strings when linesep is rn as well.

* gh-148207: "typing.TypeVarTuple" now accepts "bound", "covariant",
  "contravariant", and "infer_variance" parameters, matching the
  interface of "typing.TypeVar" and "typing.ParamSpec".

* gh-148100: *Soft deprecate* "re.match()" and "re.Pattern.match()" in
  favour of "re.prefixmatch()" and "re.Pattern.prefixmatch()". Patch
  by Hugo van Kemenade.

* gh-147991: Improve "tomllib" import time (up to 10x faster). Patch
  by Victor Stinner.

* gh-147957: Guarantees that "collections.UserDict.popitem()" will pop
  in the same order as the wrapped dictionary rather than an arbitrary
  order.

* gh-146256: The "profiling.sampling" module now supports JSONL output
  format via "--jsonl". Each run emits a newline-delimited JSON file
  that is sequentially parseable by external tools, scripts, and
  programmatic consumers. Patch by Maurycy Pawłowski-Wieroński.

* gh-146609: Add colour to "timeit" CLI output. Patch by Hugo van
  Kemenade.

* gh-146563: "xml.parsers.expat": add an exception note when a custom
  Expat handler return value cannot be properly interpreted. Patch by
  Bénédikt Tran.

* gh-137586: Add "MacOS" to "webbrowser" for macOS, which opens URLs
  via "/usr/bin/open" instead of piping AppleScript to "osascript".
  Deprecate "MacOSXOSAScript" in favour of "MacOS".

* gh-146406: Cross-language method suggestions are now shown for
  "AttributeError" on builtin types and their subclasses. For example,
  "[].push()" suggests "append", "(1,2).append(3)" suggests using a
  "list", "None.keys()" suggests expecting a "dict", and "1.0.__or__"
  suggests using an "int".

* gh-146313: Fix a deadlock in "multiprocessing"'s resource tracker
  where the parent process could hang indefinitely in "os.waitpid()"
  during interpreter shutdown if a child created via "os.fork()" still
  held the resource tracker's pipe open.

* gh-146292: Add colour to "BaseHTTPRequestHandler" logs, as used by
  the "http.server" CLI. Patch by Hugo van Kemenade.

* gh-145917: Add MIME types for TTC and Haptics formats to
  "mimetypes". (Contributed by Charlie Lin in gh-145918.)

* gh-145846: Fix memory leak in "_lsprof" when "clear()" is called
  during active profiling with nested calls. "clearEntries()" now
  walks the entire "currentProfilerContext" linked list instead of
  only freeing the top context.

* gh-145831: Fix "email.quoprimime.decode()" leaving a stray "\r" when
  "eol='\r\n'" by stripping the full *eol* string instead of one
  character.

* gh-145378: Use "PyREPL" as the default input console for "pdb"

* gh-145244: Fixed a use-after-free in "json" encoder when a "default"
  callback mutates the dictionary being serialized.

* gh-117716: Fix "wave" writing of odd-sized "data" chunks by
  appending the required RIFF pad byte and correcting the RIFF chunk
  size field accordingly.

* gh-145200: "hashlib": fix a memory leak when allocating or
  initializing an OpenSSL HMAC context fails.

* gh-145056: Add support for "frozendict" in "dataclasses.asdict()"
  and "dataclasses.astuple()".

* gh-145105: Fix crash in "csv" reader when iterating with a re-
  entrant iterator that calls "next()" on the same reader from within
  "__next__".

* gh-130750: Restore quoting of choices in "argparse" error messages
  for improved clarity and consistency with documentation.

* gh-137855: Reduce the import time of "dataclasses" module by ~20%.

* gh-70647: "strptime()" now raises "ValueError" when the format
  string contains "%d" without a year directive. Using "%e" without a
  year now emits a "DeprecationWarning".

* gh-105936: Attempting to mutate non-field attributes of
  "dataclasses" with both *frozen* and *slots* being "True" now raises
  "FrozenInstanceError" instead of "TypeError". Their non-dataclass
  subclasses can now freely mutate non-field attributes, and the
  original non-slotted class can be garbage collected.

* gh-142831: Fix a crash in the "json" module where a use-after-free
  could occur if the object being encoded is modified during
  serialization.

* gh-108411: "typing.IO" and "typing.BinaryIO" method arguments are
  now positional-only.

* gh-130273: Fix traceback color output with Unicode characters.

* gh-142307: "imaplib": deprecate support for "IMAP4.file". This
  attribute was never meant to be part of the public interface and
  altering its value may result in unclosed files or other
  synchronization issues with the underlying socket. Patch by Bénédikt
  Tran.

* gh-141449: Improve tests and documentation for non-function
  callables as *annotate functions*.

* gh-140287: The "asyncio" REPL now handles exceptions when executing
  "PYTHONSTARTUP" scripts. Patch by Bartosz Sławecki.

* gh-139489: Add the "xml.is_valid_name()" function, which allows to
  check whether a string can be used as an element or attribute name
  in XML.

* gh-75707: Add optional "mtime" argument to "tarfile.open()", for
  setting the "mtime" header field in ".tar.gz" archives.

* gh-125862: The "contextlib.contextmanager()" and
  "contextlib.asynccontextmanager()" decorators now work correctly
  with generators, coroutine functions, and async generators when the
  wrapped callables are used as decorators.

* gh-135528: "http.cookiejar": add "tv", "or", "nom", "sch", and "web"
  to the default list of supported country code second-level domains.

* gh-135056: Add a "-H" or "--header" CLI option to **python -m
  http.server**. Contributed by Anton I. Sipos.

* gh-134551: Add t-strings support to pprint functions

* gh-133956: Fix bug where "@dataclass" wouldn't detect "ClassVar"
  fields if "ClassVar" was re-exported from a module other than
  "typing".

* gh-132631: Fix "I/O operation on closed file" when parsing JSON
  Lines file with "JSON CLI".

* gh-108951: "asyncio": Add "TaskGroup.cancel" which cancels
  unfinished tasks and exits the group without raising
  "asyncio.CancelledError".

* gh-123853: Update the table of Windows language code identifiers
  (LCIDs) used by "locale.getdefaultlocale()" on Windows to protocol
  version 16.0 (2024-04-23).

* gh-122476: The "email" module no longer incorrectly uses **RFC
  2047** encoding for a mailbox with non-ASCII characters in its
  local-part. Under a policy with "utf8" set "False", attempting to
  serialize such a message will now raise an "HeaderWriteError". There
  is no valid 7-bit encoding for an internationalized local-part. Use
  "email.policy.SMTPUTF8" (or another policy with "utf8=True") to
  correctly pass through the local-part as Unicode characters.

* gh-83938: The "email" module no longer incorrectly uses **RFC 2047**
  encoding for a mailbox with non-ASCII characters in its domain.
  Under a policy with "utf8" set "False", attempting to serialize such
  a message will now raise an "HeaderWriteError". Either apply an
  appropriate IDNA encoding to convert the domain to ASCII before
  serialization, or use "email.policy.SMTPUTF8" (or another policy
  with "utf8=True") to correctly pass through the internationalized
  domain name as Unicode characters.

* gh-81074: The "email" module no longer treats email addresses with
  non-ASCII characters as defects when parsing a Unicode string or in
  the "addr_spec" parameter to "email.headerregistry.Address". **RFC
  5322** permits such addresses, and they were already supported when
  parsing bytes and in the Address "username" parameter.

  The (undocumented) "email.errors.NonASCIILocalPartDefect" is no
  longer used and should be considered deprecated.

* gh-70039: Fixed bug where "smtplib.SMTP.starttls()" could fail if
  "smtplib.SMTP.connect()" is called explicitly rather than
  implicitly.

* gh-113471: Allow "http.server" to set a default content-type when
  serving files with an unknown or missing extension.

* gh-83281: "email": improve handling trailing garbage in address
  lists to avoid throwing AttributeError in certain edge cases

* gh-96894: Do not turn echo off for subsequent commands in batch
  activators ("activate.bat" and "deactivate.bat") of "venv".


Documentação
------------

* gh-148663: Document that "calendar.IllegalMonthError" is a subclass
  of both "ValueError" and "IndexError" since Python 3.12.

* gh-146646: Document that "glob.glob()", "glob.iglob()",
  "pathlib.Path.glob()", and "pathlib.Path.rglob()" silently suppress
  "OSError" exceptions raised from scanning the filesystem.


Testes
------

* gh-149425: Increase time delta in "test.test_zipfile.test_core.Othe
  rTests.test_write_without_source_date_epoch"

* gh-148600: Add OpenSSL 4.0.0 support to test configurations.


Construção
----------

* gh-149353: Avoid unnecessary JIT-related rebuilds during "make
  install" after "--enable-optimizations" builds.

* gh-149351: Avoid possible broken macOS framework install names when
  DESTDIR is specified during builds.

* gh-149252: Update to WASI SDK 33.

* gh-148690: Windows free-threaded builds now output to a different
  default path with default filenames, for example,
  "PCbuild/amd64t/python.exe" rather than
  "PCbuild/amd64/python3.15t.exe". The "PC/layout" script has been
  updated to ensure compatibility of generated layouts.

* gh-146475: Block Apple Clang from being used to build the JIT as it
  ships without required LLVM tools.

* gh-148644: Errors during the PGO training job on Windows are no
  longer ignored, and a non-zero return code will cause the build to
  fail.

* gh-148535: No longer use the "gcc -fprofile-update=atomic" flag on
  i686. The flag has been added to fix a random GCC internal error on
  PGO build (gh-145801) caused by corruption of profile data (.gcda
  files). The problem is that it makes the PGO build way slower (up to
  47x slower) on i686. Since the GCC internal error was not seen on
  i686 so far, don't use "-fprofile-update=atomic" on i686 anymore.
  Patch by Victor Stinner.

* gh-148483: Use "Py_GCC_ATTRIBUTE(unused)" for stop_tracing label.

* gh-148474: Fixed compilation of "Python/pystrhex.c" with older clang
  versions.

* gh-146445: The Android build tools have been moved to the Platforms
  folder.

* gh-146264: Fix static module builds on non-WASI targets by linking
  HACL dependencies as static libraries when
  "MODULE_BUILDTYPE=static", preventing duplicate "_Py_LibHacl_*"
  symbol errors at link time.

* gh-138451: Allow for custom LLVM path using "LLVM_TOOLS_INSTALL_DIR"
  during JIT build.

* gh-133312: Add a new "./configure" option "--enable-static-
  libpython-for-interpreter" which, when used with "--enable-shared",
  continues to build the shared library but does not use it for the
  interpreter. Instead, libpython is statically linked into the
  interpreter, as if "--enable-shared" had not been used. This allows
  you to do a single build and get a Python interpreter binary that
  does not use a shared library but also get a shared library for use
  by other programs.


Windows
-------

* gh-149254: Updated bundled version of OpenSSL to 3.5.6.

* gh-148690: Non-freethreaded builds on Windows now support extensions
  linked to "python3t.dll", and will include a copy of that library in
  normal installs that references the non-freethreaded runtime.

* gh-146458: Fix incorrect REPL height and width tracking on console
  window resize on Windows.


macOS
-----

* gh-142295: For Python macOS framework builds, update Info.plist
  files to be more compliant with current Apple guidelines. Original
  patch contributed by Martinus Verburg.

* gh-149254: Update macOS installer to use OpenSSL 3.5.6.


IDLE
----

* gh-94523: Detect file if modified at local disk and prompt to ask
  refresh. Patch by Shixian Li.

* gh-139551: Support rendering "BaseExceptionGroup" in IDLE.

* gh-89520: Make IDLE extension configuration look at user config
  files, allowing user-installed extensions to have settings and key
  bindings defined in ~/.idlerc.


API C
-----

* gh-149225: "PyCriticalSection" and related functions are added to
  the Stable ABI.

* gh-149216: "PyType_WatchCallback" callbacks registered via
  "PyType_AddWatcher()" are now also invoked when a watched heap type
  is deallocated. Previously, type watchers were only notified of
  modifications, which could cause stale references when a type was
  freed and its address was reused.

* gh-149101: Implement **PEP 788**.

* gh-149044: Implement **PEP 820**: Unified slot system for the C API.

* gh-148267: Using "Py_LIMITED_API" on a non-Windows free-threaded
  build no longer needs an extra "Py_GIL_DISABLED".

* gh-145559: Rename "_Py_DumpTraceback" and "_Py_DumpTracebackThreads"
  to "PyUnstable_DumpTraceback()" and
  "PyUnstable_DumpTracebackThreads()".

* gh-146636: Implement **PEP 803** -- "abi3t": Stable ABI for Free-
  Threaded Builds.

* gh-146302: "Py_IsInitialized()" no longer returns true until
  initialization has fully completed, including import of the "site"
  module.  The underlying runtime flags now use atomic operations.

* gh-146063: Add "PyObject_CallFinalizerFromDealloc()" function to the
  limited C API. Patch by Victor Stinner.

* gh-145921: Add functions that are guaranteed to be safe for use in
  "tp_traverse" handlers: "PyObject_GetTypeData_DuringGC()",
  "PyObject_GetItemData_DuringGC()",
  "PyType_GetModuleState_DuringGC()", "PyModule_GetState_DuringGC()",
  "PyModule_GetToken_DuringGC()", "PyType_GetBaseByToken_DuringGC()",
  "PyType_GetModule_DuringGC()", "PyType_GetModuleByToken_DuringGC()".


Python 3.15.0 alpha 8
=====================

*Release date: 2026-04-07*


Segurança
---------

* gh-145986: "xml.parsers.expat": Fixed a crash caused by unbounded C
  recursion when converting deeply nested XML content models with
  "ElementDeclHandler()". This addresses **CVE 2026-4224**.

* gh-145599: Reject control characters in "http.cookies.Morsel"
  "update()" and "js_output()". This addresses **CVE 2026-3644**.

* gh-143930: Reject leading dashes in URLs passed to
  "webbrowser.open()".


Núcleo e embutidos
------------------

* gh-148157: Fix an unlikely crash when parsing an invalid type
  comments for function parameters. Found by OSS Fuzz in #492782951.

* gh-100239: Propagate result type and uniqueness information through
  "_BINARY_OP_EXTEND" in the tier 2 optimizer, enabling elimination of
  downstream type guards and selection of inplace float operations.

* gh-148144: Initialize "_PyInterpreterFrame.visited" when copying
  interpreter frames so incremental GC does not read an uninitialized
  byte from generator and frame-object copies.

* gh-148072: Cache "pickle.dumps" and "pickle.loads" per interpreter
  in the XIData framework, avoiding repeated module lookups on every
  cross-interpreter data transfer.  This speeds up
  "InterpreterPoolExecutor" for mutable types ("list", "dict") by 1.7x
  --3.3x.

* gh-148110: Fix "sys.set_lazy_imports_filter()" so relative lazy
  imports pass the resolved imported module name to the filter
  callback. Patch by Pablo Galindo.

* gh-148083: Constant-fold "_CONTAINS_OP_SET" for "frozenset". Patch
  by Donghee Na.

* gh-144319: Fix a bug that could cause applications with specific
  allocation patterns to leak memory via Huge Pages if compiled with
  Huge Page support. Patch by Pablo Galindo

* gh-147985: Make "PySet_Contains()" attempt a lock-free lookup,
  similar to "set.__contains__()".  This avoids acquiring the set
  object mutex in the normal case.

* gh-147856: Allow the *count* argument of "bytes.replace()" to be a
  keyword.

* gh-146615: Fix a crash in "__get__()" for METH_METHOD descriptors
  when an invalid (non-type) object is passed as the second argument.
  Patch by Steven Sun.

* gh-146306: Optimize compact integer arithmetic in the JIT by
  mutating uniquely-referenced operands in place, avoiding allocation
  of a new int object. Speeds up the pyperformance "spectral_norm"
  benchmark by ~10%.

* gh-146587: Fix type slot assignment incase of multiple slots for
  same name in type object implementation. Patch by Kumar Aditya.

* gh-126910: Set frame pointers in "aarch64-unknown-linux-gnu" JIT
  code, allowing most native profilers and debuggers to unwind through
  them. Patch by Diego Russo

* gh-146388: Adds a null check to handle when the JIT optimizer runs
  out of space when dealing with contradictions in "make_bottom".

* gh-146369: Ensure "-X lazy_imports=none" and
  "PYTHON_LAZY_IMPORTS=none" override "__lazy_modules__". Patch by
  Hugo van Kemenade.

* gh-146308: Fixed multiple error handling issues in the
  "_remote_debugging" module including a double-free in code object
  caching, memory leaks on allocation failure, missing exception
  checks in binary format varint decoding, reference leaks on error
  paths in frame chain processing, and inconsistent thread status
  error reporting across platforms. Patch by Pablo Galindo.

* gh-146306: Optimize float arithmetic in the JIT by mutating
  uniquely-referenced operands in place, avoiding allocation of a new
  float object. Speeds up the pyperformance "nbody" benchmark by ~19%.

* gh-146128: Fix a bug which could cause constant values to be
  partially corrupted in AArch64 JIT code. This issue is theoretical,
  and hasn't actually been observed in unmodified Python interpreters.

* gh-146250: Fixed a memory leak in "SyntaxError" when re-initializing
  it.

* gh-146245: Fixed reference leaks in "socket" when audit hooks raise
  exceptions in "socket.getaddrinfo()" and "socket.sendto()".

* gh-146151: "memoryview" now supports the float complex and double
  complex C types: formatting characters "'F'" and "'D'" respectively.
  Patch by Sergey B Kirpichev.

* gh-146196: Fix potential Undefined Behavior in
  "PyUnicodeWriter_WriteASCII()" by adding a zero-length check. Patch
  by Shamil Abdulaev.

* gh-146227: Fix wrong type in "_Py_atomic_load_uint16" in the C11
  atomics backend ("pyatomic_std.h"), which used a 32-bit atomic load
  instead of 16-bit. Found by Mohammed Zuhaib.

* gh-146205: Fixed a bug where "select.epoll.close()",
  "select.kqueue.close()", and "select.devpoll.close()" silently
  ignored errors.

* gh-146199: Comparison of code objects now handles errors correctly.

* gh-145667: Remove the "GET_ITER_YIELD_FROM" instruction, modifying
  "SEND" to pair with "GET_ITER" when compiling "yield from"
  expressions.

* gh-146192: Add Base32 support to "binascii" and improve the
  performance of the Base32 converters in "base64". Patch by James
  Seo.

* gh-135871: Improve multithreaded scaling of PyMutex in low-
  contention scenarios by reloading the lock's internal state, without
  slowing down high-contention scenarios.

* gh-146096: Fixed segmentation fault when called repr for
  BaseExceptionGroup with empty or 1-size tuple args.

* gh-146056: Fix "repr()" for lists and tuples containing "NULL"s.

* gh-145059: Fixed "sys.lazy_modules" to include lazy modules without
  submodules. Patch by Bartosz Sławecki.

* gh-146041: Fix free-threading scaling bottleneck in "sys.intern()"
  and "PyObject_SetAttr()" by avoiding the interpreter-wide lock when
  the string is already interned and immortalized.

* gh-145990: "python --help-env" sections are now sorted by
  environment variable name.

* gh-145990: "python --help-xoptions" is now sorted by "-X" option
  name.

* gh-145876: "AttributeError"s and "KeyError"s raised in "keys()" or
  "__getitem__()" during dictionary unpacking ("{**mymapping}" or
  "func(**mymapping)") are no longer masked by "TypeError".

* gh-127958: Support tracing from function entrypoints in the JIT.
  Patch by Ken Jin.

* gh-145376: Fix GC tracking in "structseq.__replace__()".

* gh-145792: Fix out-of-bounds access when invoking faulthandler on a
  CPython build compiled without support for VLAs.

* gh-142183: Avoid a pathological case where repeated calls at a
  specific stack depth could be significantly slower.

* gh-145779: Improve scaling of "classmethod()" and "staticmethod()"
  calls in the free-threaded build by avoiding the descriptor
  "__get__" call.

* gh-145783: Fix an unlikely crash in the parser when certain errors
  were erroneously not propagated. Found by OSS Fuzz in #491369109.

* gh-145685: Improve scaling of type attribute lookups in the *free-
  threaded build* by avoiding contention on the internal type lock.

* gh-145713: Make "bytearray.resize()" thread-safe in the free-
  threaded build by using a critical section and calling the lock-held
  variant of the resize function.

* gh-145036: In free-threaded build, fix race condition when calling
  "__sizeof__()" on a "list"

* gh-134584: Eliminate redundant refcounting for "MATCH_CLASS" in the
  JIT.

* gh-69605: Add "math.integer" to *REPL* auto-completion of imports.

* gh-131798: Optimize "_ITER_CHECK_RANGE" and "_ITER_CHECK_LIST" in
  the JIT

* gh-143414: Add tracking to the JIT optimizer to determine whether a
  reference is uniquely owned or shared

* gh-143636: Fix a crash when calling "SimpleNamespace.__replace__()"
  on non-namespace instances. Patch by Bénédikt Tran.

* gh-126910: Set frame pointers in "x86_64-unknown-linux-gnu" JIT
  code, allowing most native profilers and debuggers to unwind through
  them.

* gh-140594: Fix an out of bounds read when a single NUL character is
  read from the standard input. Patch by Shamil Abdulaev.

* gh-140870: Add support for module attributes in the *REPL* auto-
  completion of imports.


Biblioteca
----------

* gh-144503: Fix a regression introduced in 3.14.3 and 3.13.12 where
  the "multiprocessing" "forkserver" start method would fail with
  "BrokenPipeError" when the parent process had a very large
  "sys.argv".  The argv is now passed to the forkserver as separate
  command-line arguments rather than being embedded in the "-c"
  command string, avoiding the operating system's per-argument length
  limit.

* gh-148153: "base64.b32encode()" now always raises "ValueError"
  instead of "AssertionError" for the value of *map01* with invalid
  length.

* gh-73613: Add the *padded* parameter in functions related to Base32
  and Base64 codecs in the "binascii" and "base64" modules. In the
  encoding functions it controls  whether the pad character can be
  added in the output, in the decoding functions it controls whether
  padding is required in input. Padding of input no longer required in
  "base64.urlsafe_b64decode()" by default.

* gh-146613: "itertools": Fix a crash in "itertools.groupby()" when
  the grouper iterator is concurrently mutated.

* gh-147944: Accepted range for the *bytes_per_sep* argument of
  "bytes.hex()", "bytearray.hex()", "memoryview.hex()", and
  "binascii.b2a_hex()" is now increased, so passing "sys.maxsize" and
  "-sys.maxsize" is now valid.

* gh-146080: "ssl": fix a crash when an SNI callback tries to use an
  SSL object that has already been garbage-collected. Patch by
  Bénédikt Tran.

* gh-146556: Fix "annotationlib.get_annotations()" hanging
  indefinitely when called with "eval_str=True" on a callable that has
  a circular "__wrapped__" chain (e.g. "f.__wrapped__ = f"). Cycle
  detection using an id-based visited set now stops the traversal and
  falls back to the globals found so far, mirroring the approach of
  "inspect.unwrap()".

* gh-146090: "sqlite3": fix a crash when
  "sqlite3.Connection.create_collation()" fails with SQLITE_BUSY.
  Patch by Bénédikt Tran.

* gh-146090: "sqlite3": properly raise "MemoryError" instead of
  "SystemError" when a context callback fails to be allocated. Patch
  by Bénédikt Tran.

* gh-146507: Make "asyncio.SelectorEventLoop()" stream transport's
  "get_write_buffer_size()" O(1) by maintaining a running byte counter
  instead of iterating the buffer on every call.

* gh-145056: Fix merging of "collections.OrderedDict" and
  "frozendict".

* gh-145056: Add support for merging "collections.UserDict" and
  "frozendict".

* gh-145633: Fix "struct.pack('f', float)": use "PyFloat_Pack4()" to
  raise "OverflowError". Patch by Sergey B Kirpichev and Victor
  Stinner.

* gh-146440: "json": Add the *array_hook* parameter to "load()" and
  "loads()" functions: allow a callback for JSON literal array types
  to customize Python lists in the resulting decoded object. Passing
  combined "frozendict" to *object_pairs_hook* param and "tuple" to
  "array_hook" will yield a deeply nested immutable Python structure
  representing the JSON data.

* gh-146431: Add the *wrapcol* parameter to "base64" functions
  "b16encode()", "b32encode()", "b32hexencode()", "b85encode()" and
  "z85encode()", and "binascii" functions "b2a_base32()" and
  "b2a_base85()". Add the *ignorechars* parameter to "base64"
  functions "b16decode()", "b32decode()", "b32hexdecode()",
  "b85decode()" and "z85decode()", and "binascii" functions
  "a2b_hex()", "unhexlify()", "a2b_base32()" and "a2b_base85()".

* gh-146310: The "ensurepip" module no longer looks for "pip-*.whl"
  wheel packages in the current directory.

* gh-141510: Support "frozendict" in "plistlib", for serialization
  only. Patch by Hugo van Kemenade.

* gh-146238: Support half-floats (type code "'e'" of the "struct"
  module) in the "array" module.  Patch by Sergey B Kirpichev.

* gh-140947: Fix incorrect contextvars handling in server tasks
  created by "asyncio". Patch by Kumar Aditya.

* gh-146151: Support the float complex and double complex C types in
  the "array" module: formatting characters "'F'" and "'D'"
  respectively.  Patch by Sergey B Kirpichev.

* gh-143387: In importlib.metadata, when a distribution file is
  corrupt and there is no metadata file, calls to
  "Distribution.metadata()" (including implicit calls from other
  properties like ".name" and ".requires") will now raise a
  "MetadataNotFound" Exception. This allows callers to distinguish
  between missing metadata and a degenerate (empty) metadata.
  Previously, if the file was missing, an empty "PackageMetadata"
  would be returned and would be indistinguishable from the presence
  of an empty file.

* gh-146228: Cached FastPath objects in importlib.metadata are now
  cleared on fork, avoiding broken references to zip files during
  fork.

* gh-146171: Nested "AttributeError" suggestions now include property-
  backed attributes on nested objects without executing the property
  getter.

* gh-145410: On Windows, "sysconfig.get_platform()" now gets the
  platform from the "_sysconfig" module instead of parsing
  "sys.version" string. Patch by Victor Stinner.

* gh-146091: Fix a bug in "termios.tcsetwinsize()" where passing a
  sequence that raises an exception in "__getitem__" would cause a
  "SystemError" instead of propagating the original exception.

* gh-146083: Update bundled libexpat to version 2.7.5.

* gh-146076: "zoneinfo": fix crashes when deleting "_weak_cache" from
  a "zoneinfo.ZoneInfo" subclass.

* gh-123471: Make concurrent iteration over "itertools.zip_longest"
  safe under free-threading.

* gh-146075: Errors when calling "functools.partial()" with a
  malformed keyword will no longer crash the interpreter.

* gh-146054: Limit the size of "encodings.search_function()" cache.
  Found by OSS Fuzz in #493449985.

* gh-146004: All "-X" options from the Python command line are now
  propagated to child processes spawned by "multiprocessing", not just
  a hard-coded subset.  This makes the behavior consistent between
  default "spawn" and "forkserver" start methods and the old "fork"
  start method. The options that were previously not propagated are:
  "context_aware_warnings", "cpu_count", "disable-remote-debug",
  "int_max_str_digits", "lazy_imports", "no_debug_ranges",
  "pathconfig_warnings", "perf", "perf_jit", "presite",
  "pycache_prefix", "thread_inherit_context", and
  "warn_default_encoding".

* gh-145980: Added the *alphabet* parameter in "b2a_base64()",
  "a2b_base64()", "b2a_base85()" and "a2b_base85()" and a number of
  "*_ALPHABET" constants in the "binascii" module. Removed "b2a_z85()"
  and "a2b_z85()".

* gh-145968: Fix translation in "base64.b64decode()" when altchars
  overlaps with the standard ones.

* gh-145966: Non-"AttributeError" exceptions raised during dialect
  attribute lookup in "csv" are no longer silently suppressed.

* gh-145883: "zoneinfo": Fix heap buffer overflow reads from malformed
  TZif data. Found by OSS Fuzz, issues #492245058 and #492230068.

* gh-145850: Changed some implementation details in "struct.Struct":
  calling it with non-ASCII string format will now raise a
  "ValueError" instead of "UnicodeEncodeError", calling it with non-
  ASCII bytes format will now raise a "ValueError" instead of
  "struct.error", getting the "format" attribute of uninitialized
  object will now raise an "AttributeError" instead of "RuntimeError".

* gh-123720: asyncio: Fix "asyncio.Server.serve_forever()" shutdown
  regression. Since 3.12, cancelling "serve_forever()" could hang
  waiting for a handler blocked on a read from a client that never
  closed (effectively requiring two interrupts to stop); the shutdown
  sequence now ensures client streams are closed so "serve_forever()"
  exits promptly and handlers observe EOF.

* gh-138122: The "profiling.sampling" module now supports differential
  flamegraph visualization via "--diff-flamegraph" to compare two
  profiling runs. Functions are colored red (regressions), blue
  (improvements), gray (neutral), or purple (new). Elided stacks show
  code paths that disappeared between runs.

* gh-145754: Request signature during mock autospec with "FORWARDREF"
  annotation format. This prevents runtime errors when an annotation
  uses a name that is not defined at runtime.

* gh-145750: Avoid undefined behaviour from signed integer overflow
  when parsing format strings in the "struct" module. Found by OSS
  Fuzz in #488466741.

* gh-145719: Add "application/efi" MIME type to "mimetypes".

* gh-145717: Add a few Microsoft-specific MIME types.

* gh-145703: "asyncio": Make sure that "loop.call_at" and
  "loop.call_later" trigger scheduled events on time when the clock
  resolution becomes too small.

* gh-145697: Add "application/sql" and "application/vnd.sqlite3" into
  "mimetypes".

* gh-145492: Fix infinite recursion in "collections.defaultdict"
  "__repr__" when a "defaultdict" contains itself. Based on analysis
  by KowalskiThomas in gh-145492.

* gh-145650: Add "__repr__()" support to "logging.Formatter" and
  "logging.Filter", showing the format string and filter name
  respectively.

* gh-145587: Resolved a performance regression in
  "multiprocessing.connection.wait" on Windows that caused infinite
  busy loops when called with no objects. The function now properly
  yields control to the OS to conserve CPU resources. Patch By Shrey
  Naithani

* gh-145616: Detect Android sysconfig ABI correctly on 32-bit ARM
  Android on 64-bit ARM kernel

* gh-145546: Fix "unittest.util.sorted_list_difference()" to
  deduplicate remaining elements when one input list is exhausted
  before the other.

* gh-145446: Now "functools" is safer in free-threaded build when
  using keywords in "functools.partial()"

* gh-145264: Base64 decoder (see "binascii.a2b_base64()",
  "base64.b64decode()", etc) no longer ignores excess data after the
  first padded quad in non-strict (default) mode.  Instead, in
  conformance with **RFC 4648**, section 3.3, it now ignores the pad
  character, "=", if it is present before the end of the encoded data.

* gh-145035: Allows omitting the internal library "_pyrepl" with
  limited loss of functionality. This allows complete removal of the
  modern REPL, which is an unsupported configuration, but still
  desirable for some distributions.

* gh-144270: Made the *tag* parameter of
  "xml.etree.ElementTree.Element" and the *parent* and *tag*
  parameters of "xml.etree.ElementTree.SubElement()" positional-only,
  matching the behavior of the C accelerator.

* gh-144984: Fix crash in
  "xml.parsers.expat.xmlparser.ExternalEntityParserCreate()" when an
  allocation fails. The error paths could dereference NULL "handlers"
  and double-decrement the parent parser's reference count.

* gh-144975: "wave.Wave_write.setframerate()" now validates the frame
  rate after rounding to an integer, preventing values like "0.5" from
  being accepted and causing confusing errors later. Patch by Michiel
  Beijen.

* gh-140715: Add "%n" and "%t" support to "strptime()".

* gh-144259: Fix inconsistent display of long multiline pasted content
  in the REPL.

* gh-140814: "multiprocessing.freeze_support()" no longer sets the
  default start method as a side effect, which previously caused a
  subsequent "multiprocessing.set_start_method()" call to raise
  "RuntimeError".

* gh-123471: Make concurrent iteration over "itertools.accumulate"
  safe under free-threading.

* gh-143715: Calling the "Struct.__new__()" without required argument
  now is deprecated. Calling "__init__()" method on initialized
  "Struct" objects is deprecated.

* gh-142763: Fix a race condition between "zoneinfo.ZoneInfo" creation
  and "zoneinfo.ZoneInfo.clear_cache()" that could raise "KeyError".

* gh-141707: Don't change "tarfile.TarInfo" type from "AREGTYPE" to
  "DIRTYPE" when parsing GNU long name or link headers.

* gh-138577: "getpass.getpass()" with non-empty "echo_char" now
  handles keyboard shortcuts including Ctrl+A/E (cursor movement),
  Ctrl+K/U (kill line), Ctrl+W (erase word), and Ctrl+V (literal next)
  by reading the terminal's control character settings and processing
  them appropriately in non-canonical mode. Patch by Sanyam Khurana.

* gh-140049: "traceback.format_exception_only()" now colorizes
  exception notes.

* gh-139933: Improve "AttributeError" suggestions for classes with a
  custom "__dir__()" method returning a list of unsortable values.
  Patch by Bénédikt Tran.

* gh-139633: The "netrc" security check is now run once per parse
  rather than once per entry.

* gh-130472: Add fancycompleter and enable it by default when using
  pyrepl. This gives colored tab completion.

* gh-112632: Add an *expand* keyword argument for "pprint.pprint()",
  "pprint.pformat()", "pprint.pp()" by passing on all *kwargs* and
  "pprint.PrettyPrinter". Contributed by Stefan Todoran and Semyon
  Moroz.

* gh-66419: Optional argument with nargs equals to
  "argparse.REMAINDER" now consumes all remaining arguments including
  "'--'".

* gh-60729: Add support for floating point audio wave files in "wave".

* bpo-36461: Make the target time of "timeit.Timer.autorange()"
  configurable and add "--target-time" option to the command-line
  interface of "timeit".


Documentação
------------

* gh-126676: Expand "argparse" documentation for "type=bool" with a
  demonstration of the surprising behavior and pointers to common
  alternatives.

* gh-145649: Fix text wrapping and formatting of "-X" option
  descriptions in the *python(1)* man page by using proper roff
  markup.


Testes
------

* gh-144418: The Android testbed's emulator RAM has been increased
  from 2 GB to 4 GB.

* gh-146202: Fix a race condition in regrtest: make sure that the
  temporary directory is created in the worker process. Previously,
  temp_cwd() could fail on Windows if the "build" directory was not
  created.  Patch by Victor Stinner.


Construção
----------

* gh-146541: The Android testbed can now be built for 32-bit ARM and
  x86 targets.

* gh-146498: The iOS XCframework build script now ensures libpython
  isn't included in installed app content, and is more robust in
  identifying standard library binary content that requires
  processing.

* gh-146450: The Android build script was modified to improve parity
  with other platform build scripts.

* gh-146446: The clean target for the Apple/iOS XCframework build
  script is now more selective when targeting a single architecture.

* gh-146444: The Apple/iOS build script has been moved to the
  Platforms directory.

* gh-146210: Fix building the jit stencils on Windows when the
  interpreter is built with a different clang version. Patch by Chris
  Eibl.

* gh-145844: Update to WASI SDK 32.

* gh-145801: When Python build is optimized with GCC using PGO, use
  "-fprofile-update=atomic" option to use atomic operations when
  updating profile information. This option reduces the risk of gcov
  Data Files (.gcda) corruption which can cause random GCC crashes.
  Patch by Victor Stinner.

* gh-138850: Add "--disable-epoll" to "configure"

* gh-145633: Remove support for ancient ARM platforms (ARMv4L and
  ARMv5L OABI boards), using mixed-endian representation for doubles.
  Patch by Sergey B Kirpichev.

* gh-85277: Fix building without "stropts.h" or empty "stropts.h"


Windows
-------

* gh-140131: Fix REPL cursor position on Windows when module
  completion suggestion line hits console width.


macOS
-----

* gh-137586: Invoke **osascript** with absolute path in "webbrowser"
  and "turtledemo".


Ferramentas/Demos
-----------------

* gh-135953: Properly identify the main thread in the Gecko profiler
  collector by using a status flag from the interpreter state instead
  of relying on "threading.main_thread()" in the collector process.

* gh-145976: Remove "Misc/indent.pro", a configuration file for GNU
  *indent(1)*.

* gh-145976: Remove "Misc/vgrindefs" and "Misc/Porting".


API C
-----

* gh-146636: The "Py_mod_abi" slot is now mandatory for modules
  created from a slots array (using "PyModule_FromSlotsAndSpec()" or
  the "PyModExport_*" export hook).

* gh-146175: The following macros are *soft deprecated*: "Py_ALIGNED",
  "PY_FORMAT_SIZE_T", "Py_LL", "Py_ULL", "PY_LONG_LONG",
  "PY_LLONG_MIN", "PY_LLONG_MAX", "PY_ULLONG_MAX", "PY_INT32_T",
  "PY_UINT32_T", "PY_INT64_T", "PY_UINT64_T", "PY_SIZE_MAX",
  "Py_UNICODE_SIZE", "Py_VA_COPY".

  The macro "Py_UNICODE_WIDE", which was scheduled for removal, is
  *soft deprecated* instead.

* gh-146143: "PyUnicodeWriter_WriteUCS4()" now accepts a pointer to a
  constant buffer of "Py_UCS4".

* gh-146056: "PyUnicodeWriter_WriteRepr()" now supports "NULL"
  argument.

* gh-145010: Use GCC dialect alternatives for inline assembly in
  "object.h" so that the Python headers compile correctly with
  "-masm=intel".


Python 3.15.0 alpha 7
=====================

*Release date: 2026-03-10*


Windows
-------

* gh-145731: Fix negative timestamp during DST on Windows. Patch by
  Hugo van Kemenade.

* gh-145307: Defers loading of the "psapi.dll" module until it is used
  by "ctypes.util.dllist()".

* gh-144551: Updated bundled version of OpenSSL to 3.5.5.


Testes
------

* gh-144741: Fix "test_frame_pointer_unwind" when Python is built with
  "--enable-shared". Classify also libpython frames as ""python"".
  Patch by Victor Stinner.

* gh-144739: When Python was compiled with system expat older then
  2.7.2 but tests run with newer expat, still skip
  "test.test_pyexpat.MemoryProtectionTest".


Segurança
---------

* gh-145506: Fixes **CVE 2026-2297** by ensuring that
  "SourcelessFileLoader" uses "io.open_code()" when opening ".pyc"
  files.

* gh-144370: Disallow usage of control characters in status in
  "wsgiref.handlers" to prevent HTTP header injections. Patch by
  Benedikt Johannes.


Biblioteca
----------

* gh-145623: Fix crash in "struct" when calling "repr()" or
  "__sizeof__()" on an uninitialized "struct.Struct" object created
  via "Struct.__new__()" without calling "__init__()".

* gh-145551: Fix InvalidStateError when cancelling process created by
  "asyncio.create_subprocess_exec()" or
  "asyncio.create_subprocess_shell()". Patch by Daan De Meyer.

* gh-141510: "marshal" now supports "frozendict" objects. The marshal
  format version was increased to 6. Patch by Victor Stinner.

* gh-145417: "venv": Prevent incorrect preservation of SELinux context
  when copying the "Activate.ps1" script. The script inherited the
  SELinux security context of the system template directory, rather
  than the destination project directory.

* gh-145335: "os.listdir(-1)" and "os.scandir(-1)" now fail with
  "OSError(errno.EBADF)" rather than listing the current directory.
  "os.listxattr(-1)" now fails with "OSError(errno.EBADF)" rather than
  listing extended attributes of the current directory. Patch by
  Victor Stinner.

* gh-145376: Fix double free and null pointer dereference in unusual
  error scenarios in "hashlib" and "hmac" modules.

* gh-145301: "hmac": fix a crash when the initialization of the
  underlying C extension module fails.

* gh-145301: "hashlib": fix a crash when the initialization of the
  underlying C extension module fails.

* gh-76007: The "version" attribute of the "tarfile" module is
  deprecated and slated for removal in Python 3.20.

* gh-145158: Avoid undefined behaviour from signed integer overflow
  when parsing format strings in the "struct" module.

* gh-123853: Removed Windows 95 compatibility for
  "locale.getdefaultlocale()".

* gh-66802: Add "unicodedata.block()" function to return the Unicode
  block of a character.

* gh-145033: Add "typing.TypeForm", implementing **PEP 747**. Patch by
  Jelle Zijlstra.

* gh-141510: "dataclasses.field()": if *metadata* is "None", use an
  empty "frozendict", instead of a "MappingProxyType()" of an empty
  "dict". Patch by Victor Stinner.

* gh-145006: Add "ModuleNotFoundError" hints when a module for a
  different ABI exists.

* gh-141510: "ParameterizedMIMEHeader.params" of
  "email.headerregistry" is now a "frozendict" instead of a
  "types.MappingProxyType". Patch by Victor Stinner.

* gh-134872: Add valid import name suggestions on
  "ModuleNotFoundError".

* gh-88091: Fix "unicodedata.decomposition()" for Hangul characters.

* gh-144986: Fix a memory leak in "atexit.register()". Patch by Shamil
  Abdulaev.

* gh-144777: Fix data races in "io.IncrementalNewlineDecoder" in the
  *free-threaded build*.

* gh-144809: Make "collections.deque" copy atomic in the *free-
  threaded build*.

* gh-141510: The "copy" module now supports the "frozendict" type.
  Patch by Pieter Eendebak based on work by Victor Stinner.

* gh-141510: The "json" module now supports the "frozendict" type.
  Patch by Victor Stinner.

* gh-144835: Added missing explanations for some parameters in
  "glob.glob()" and "glob.iglob()".

* gh-144833: Fixed a use-after-free in "ssl" when "SSL_new()" returns
  NULL in "newPySSLSocket()". The error was reported via a dangling
  pointer after the object had already been freed.

* gh-140715: Add "'%D'" support to "strptime()".

* gh-144782: Fix "argparse.ArgumentParser" to be "pickleable".

* gh-144763: Fix a race condition in "tracemalloc": it no longer
  detaches the attached thread state to acquire its internal lock.
  Patch by Victor Stinner.

* gh-142224: "unicodedata.bidirectional()" now return the correct
  default bidi class for unassigned code points.

* gh-117865: Reduce the import time of "inspect" module by ~20%.

* gh-144156: Fix the folding of headers by the "email" library when
  **RFC 2047** encoded words are used.  Now whitespace is correctly
  preserved and also correctly added between adjacent encoded words.
  The latter property was broken by the fix for gh-92081, which mostly
  fixed previous failures to preserve whitespace.

* gh-66305: Fixed a hang on Windows in the "tempfile" module when
  trying to create a temporary file or subdirectory in a non-writable
  directory.

* gh-144615: Methods directly decorated with
  "@functools.singledispatchmethod" now dispatch on the second
  argument when called after being accessed as class attributes. Patch
  by Bartosz Sławecki.

* gh-144321: The functional syntax for creating "typing.NamedTuple"
  classes now supports passing any *iterable* of fields and types.
  Previously, only sequences were supported.

* gh-144475: Calling "repr()" on "functools.partial()" is now safer
  when the partial object's internal attributes are replaced while the
  string representation is being generated.

* gh-144285: Attribute suggestions in "AttributeError" tracebacks are
  now formatted differently to make them easier to understand, for
  example: "Did you mean '.datetime.now' instead of '.now'".
  Contributed by Bartosz Sławecki.

* gh-144316: Fix crash in "_remote_debugging" that caused
  "test_external_inspection" to intermittently fail. Patch by Taegyun
  Kim.

* gh-143637: Fixed a crash in socket.sendmsg() that could occur if
  ancillary data is mutated re-entrantly during argument parsing.

* gh-140652: Fix a crash in "_interpchannels.list_all()" after closing
  a channel.

* gh-143698: Allow *scheduler* and *setpgroup* arguments to be
  explicitly "None" when calling "os.posix_spawn()" or
  "os.posix_spawnp()". Patch by Bénédikt Tran.

* gh-143698: Raise "TypeError" instead of "SystemError" when the
  *scheduler* in "os.posix_spawn()" or "os.posix_spawnp()" is not a
  tuple. Patch by Bénédikt Tran.

* gh-142516: "ssl": fix reference leaks in "ssl.SSLContext" objects.
  Patch by Bénédikt Tran.

* gh-85809: Added *path-like object* support for
  "shutil.make_archive()".

* gh-143304: Fix "ctypes.CDLL" to honor the "handle" parameter on
  POSIX systems.

* gh-142781: "zoneinfo": fix a crash when instantiating "ZoneInfo"
  objects for which the internal class-level cache is inconsistent.

* gh-142787: Fix assertion failure in "sqlite3" blob subscript when
  slicing with indices that result in an empty slice.

* gh-142352: Fix "asyncio.StreamWriter.start_tls()" to transfer
  buffered data from "StreamReader" to the SSL layer, preventing data
  loss when upgrading a connection to TLS mid-stream (e.g., when
  implementing PROXY protocol support).

* gh-139899: Introduced "importlib.abc.MetaPathFinder.discover()" and
  "importlib.abc.PathEntryFinder.discover()" to allow module and
  submodule name discovery without assuming the use of traditional
  filesystem based imports.

* gh-137335: Get rid of any possibility of a name conflict for named
  pipes in "multiprocessing" and "asyncio" on Windows, no matter how
  small.

* gh-135883: Fix "sqlite3"'s interactive shell keeping part of
  previous commands when scrolling history.

* gh-124748: Improve "TypeError" error message when
  "weakref.WeakKeyDictionary.update()" is used with keyword-only
  parameters.

* gh-80667: Add support for Tangut Ideographs names in "unicodedata".

* bpo-42353: The "re" module gains a new "re.prefixmatch()" function
  as an explicit spelling of what has to date always been known as
  "re.match()". "re.Pattern" similary gains a
  "re.Pattern.prefixmatch()" method.

  Why? Explicit is better than implicit. Other widely used languages
  all use the term "match" to mean what Python uses the term "search"
  for. The unadorened "match" name in Python has been a frequent case
  of confusion and coding bugs due to the inconsistency with the rest
  if the software industry.

  We do not plan to deprecate and remove the older "match" name.

* bpo-40243: Fix "unicodedata.ucd_3_2_0.numeric()" for non-decimal
  values.

* bpo-40212: Re-enable "os.posix_fallocate()" and "os.posix_fadvise()"
  on AIX.

* bpo-3405: Add support for user data of Tk virtual events and detail
  for "Enter", "Leave", "FocusIn", "FocusOut", and "ConfigureRequest"
  events to "tkinter".

* bpo-32234: "mailbox.Mailbox" instances can now be used as a context
  manager. The Mailbox is locked on context entry and unlocked and
  closed at context exit.


Documentação
------------

* gh-145450: Document missing public "wave.Wave_write" getter methods.

* gh-110937: Document rest of full public
  "importlib.metadata.Distribution" API. Also add the (already
  documented) "PackagePath" to "__all__".

* gh-136246: A new "Improve this page" link is available in the left-
  hand sidebar of the docs, offering links to create GitHub issues,
  discussion forum posts, or pull requests.


Núcleo e embutidos
------------------

* gh-145701: Fix "SystemError" when "__classdict__" or
  "__conditional_annotations__" is in a class-scope inlined
  comprehension. Found by OSS Fuzz in #491105000.

* gh-145615: Fixed a memory leak in the *free-threaded build* where
  mimalloc pages could become permanently unreclaimable until the
  owning thread exited.

* gh-116738: Make "mmap.mmap.set_name()" thread-safe on the *free
  threaded* build.

* gh-145566: In the free threading build, skip the stop-the-world
  pause when reassigning "__class__" on a newly created object.

* gh-143055: Fix crash in AST unparser when unparsing dict
  comprehension unpacking. Found by OSS Fuzz in #489790200.

* gh-145335: Fix a crash in "os.pathconf()" when called with "-1" as
  the path argument.

* gh-145376: Fix reference leaks in various unusual error scenarios.

* gh-145234: Fixed a "SystemError" in the parser when an encoding
  cookie (for example, UTF-7) decodes to carriage returns ("\r").
  Newlines are now normalized after decoding in the string tokenizer.

  Patch by Pablo Galindo.

* gh-145275: Added the "-X pathconfig_warnings" and
  "PYTHON_PATHCONFIG_WARNINGS" options, allowing to disable warnings
  from A inicialização do caminho de pesquisa de módulos sys.path.

* gh-145273: A warning is now shown during A inicialização do caminho
  de pesquisa de módulos sys.path if it can't find a valid standard
  library.

* gh-145241: Specialized the parser error for when "with" items are
  followed by a trailing comma (for example, "with item,:"), raising a
  clearer "SyntaxError" message. Patch by Pablo Galindo and Bartosz
  Sławecki.

* gh-130555: Fix use-after-free in "dict.clear()" when the dictionary
  values are embedded in an object and a destructor causes re-entrant
  mutation of the dictionary.

* gh-145197: Fix JIT trace crash when recording function from cleared
  generator frame.

* gh-145187: Fix compiler assertion fail when a type parameter bound
  contains an invalid expression in a conditional block.

* gh-145142: Fix a crash in the free-threaded build when the
  dictionary argument to "str.maketrans()" is concurrently modified.

* gh-145118: "str.maketrans()" now accepts "frozendict".

* gh-144015: Speed up "bytes.hex()", "bytearray.hex()",
  "binascii.hexlify()", and "hashlib" ".hexdigest()" operations with
  SIMD on x86-64, ARM64, and ARM32 with NEON when built with gcc
  (version 12 or higher) or clang (version 3 or higher) compilers.
  Around 1.1-3x faster for common 16-64 byte inputs such as hashlib
  hex digests, and up to 8x faster for larger data.

* gh-145118: "type()" now accepts "frozendict" as an argument.

* gh-145064: Fix JIT optimizer assertion failure during
  "CALL_ALLOC_AND_ENTER_INIT" side exit.

* gh-145055: "exec()" and "eval()" now accept "frozendict" for
  *globals*. Patch by Victor Stinner.

* gh-145058: Fix a crash when "__lazy_import__()" is passed a non-
  string argument, by raising an "TypeError" instead.

* gh-144995: Optimize "memoryview" comparison: a "memoryview" is equal
  to itself, there is no need to compare values. Patch by Victor
  Stinner.

* gh-141510: Update specializer to support frozendict. Patch by
  Donghee Na.

* gh-141510: Optimize "frozendict.fromkeys()" to avoid unnecessary
  thread-safety operations in frozendict cases. Patch by Donghee Na.

* gh-100239: Speedup "BINARY_OP_EXTEND" for exact floats and medium-
  size integers by up to 15%. Patch by Chris Eibl.

* gh-144914: Use "mimalloc" for raw memory allocations such as via
  "PyMem_RawMalloc()" for better performance on *free-threaded
  builds*. Patch by Kumar Aditya.

* gh-144872: Fix heap buffer overflow in the parser found by OSS-Fuzz.

* gh-144766: Fix a crash in fork child process when perf support is
  enabled.

* gh-144759: Fix undefined behavior in the lexer when "start" and
  "multi_line_start" pointers are "NULL" in
  "_PyLexer_remember_fstring_buffers()" and
  "_PyLexer_restore_fstring_buffers()". The "NULL" pointer arithmetic
  ("NULL - valid_pointer") is now guarded with explicit "NULL" checks.

* gh-141510: Add built-in "frozendict" type. Patch by Victor Stinner.

* gh-144681: Fix a JIT assertion failure when a conditional branch
  jumps to the same target as the fallthrough path.

* gh-143300: Add "PyUnstable_SetImmortal()" C-API function to mark
  objects as *immortal*.

* gh-144702: Clarify the error message raised when a class pattern is
  used to match on a non-class object.

* gh-144569: Optimize "BINARY_SLICE" for list, tuple, and unicode by
  avoiding temporary "slice" object creation.

* gh-144438: Align the QSBR thread state array to a 64-byte cache line
  boundary to avoid false sharing in the *free-threaded build*.

* gh-142349: Implement **PEP 810**. Patch by Pablo Galindo and Dino
  Viehland.

* gh-141226: Deprecate **PEP 456** support for providing an external
  definition of the string hashing scheme. Removal is scheduled for
  Python 3.19. Patch by Bénédikt Tran.

* gh-138912: Improve "MATCH_CLASS" performance by up to 52% in certain
  cases. Patch by Marc Mueller.

* gh-130327: Fix erroneous clearing of an object's "__dict__" if
  overwritten at runtime.

* gh-80667: Literals using the "\N{name}" escape syntax can now
  construct CJK ideographs and Hangul syllables using case-insensitive
  names.


API C
-----

* gh-142417: Restore private provisional "_Py_InitializeMain()"
  function removed in Python 3.14. Patch by Victor Stinner.

* gh-144748: "PyErr_CheckSignals()" now raises the exception scheduled
  by "PyThreadState_SetAsyncExc()", if any.

* gh-144981: Made "PyUnstable_Code_SetExtra()",
  "PyUnstable_Code_GetExtra()", and
  "PyUnstable_Eval_RequestCodeExtraIndex()" thread-safe on the *free
  threaded* build.

* gh-141510: Add the following functions for the new "frozendict"
  type:

  * "PyAnyDict_Check()"

  * "PyAnyDict_CheckExact()"

  * "PyFrozenDict_Check()"

  * "PyFrozenDict_CheckExact()"

  * "PyFrozenDict_New()"

  Patch por Victor Stinner.

* gh-121617: "Python.h" now also includes "<string.h>" in the limited
  C API version 3.11 and newer to fix the "Py_CLEAR" macro which uses
  "memcpy()". Patch by Victor Stinner.

* gh-144175: Add "PyArg_ParseArray()" and
  "PyArg_ParseArrayAndKeywords()" functions to parse arguments of
  functions using the "METH_FASTCALL" calling convention. Patch by
  Victor Stinner.


Construção
----------

* gh-144533: Use wasmtime's "--argv0" to auto-discover sysconfig in
  WASI builds

* gh-145110: Fix targets "Clean" and "CLeanAll" in case of PGO builds
  on Windows. Patch by Chris Eibl.

* gh-144679: When building with Visual Studio 2026 (Version 18), use
  PlatformToolSet v145 by default. Patch by Chris Eibl.

* gh-144675: Update to WASI SDK 30.

* gh-136677: Introduce executable specific linker flags to
  "./configure".


Python 3.15.0 alpha 6
=====================

*Release date: 2026-02-11*


macOS
-----

* gh-144648: Allowed _remote_debugging to build on more OS versions by
  using proc_listpids() rather than proc_listallpids().

* gh-124111: Update macOS installer to use Tcl/Tk 9.0.3.

* gh-144551: Update macOS installer to use OpenSSL 3.5.5.


Windows
-------

* gh-80620: Support negative timestamps in "time.gmtime()",
  "time.localtime()", and various "datetime" functions.


Testes
------

* gh-144415: The Android testbed now distinguishes between
  stdout/stderr messages which were triggered by a newline, and those
  triggered by a manual call to "flush". This fixes logging of
  progress indicators and similar content.

* gh-65784: Add support for parametrized resource "wantobjects" in
  regrtests, which allows to run Tkinter tests with the specified
  value of "tkinter.wantobjects", for example "-u wantobjects=0".


Segurança
---------

* gh-144125: "BytesGenerator" will now refuse to serialize (write)
  headers that are unsafely folded or delimited; see
  "verify_generated_headers". (Contributed by Bas Bloemsaat and Petr
  Viktorin in gh-121650).

* gh-143935: Fixed a bug in the folding of comments when flattening an
  email message using a modern email policy. Comments consisting of a
  very long sequence of non-foldable characters could trigger a forced
  line wrap that omitted the required leading space on the
  continuation line, causing the remainder of the comment to be
  interpreted as a new header field. This enabled header injection
  with carefully crafted inputs.

* gh-143925: Reject control characters in "data:" URL media types.

* gh-143923: Reject control characters in POP3 commands.

* gh-143921: Reject control characters in IMAP commands.

* gh-143919: Reject control characters in "http.cookies.Morsel" fields
  and values.

* gh-143916: Reject C0 control characters within
  wsgiref.headers.Headers fields, values, and parameters.


Biblioteca
----------

* gh-144538: Bump the version of pip bundled in ensurepip to version
  26.0.1

* gh-144493: Improve an exception error message in
  "_overlapped.BindLocal()" that is raised when
  "asyncio.loop.sock_connect()" is called on a
  "asyncio.ProactorEventLoop" with a socket that has an invalid
  address family.

* gh-144386: Add support for arbitrary descriptors "__enter__()",
  "__exit__()", "__aenter__()", and "__aexit__()" in
  "contextlib.ExitStack" and "contextlib.AsyncExitStack", for
  consistency with the "with" and "async with" statements.

* gh-123471: Make concurrent iteration over
  "itertools.combinations_with_replacement" and
  "itertools.permutations" safe under free-threading.

* gh-74453: Deprecate "os.path.commonprefix()" in favor of
  "os.path.commonpath()" for path segment prefixes.

  The "os.path.commonprefix()" function is being deprecated due to
  having a misleading name and module. The function is not safe to use
  for path prefixes despite being included in a module about path
  manipulation, meaning it is easy to accidentally introduce path
  traversal vulnerabilities into Python programs by using this
  function.

* gh-144380: Improve performance of "io.BufferedReader" line iteration
  by ~49%.

* gh-144363: Update bundled libexpat to 2.7.4

* gh-140824: When "faulthandler" dumps the list of third-party
  extension modules, ignore sub-modules of stdlib packages. Patch by
  Victor Stinner.

* gh-144206: Improve error messages for buffer overflow in
  "fcntl.fcntl()" and "fcntl.ioctl()".

* gh-144264: Speed up Base64 decoding of data containing ignored
  characters (both in non-strict mode and with an explicit
  *ignorechars* argument). It is now up to 2 times faster for
  multiline Base64 data.

* gh-144249: Add filename context to "OSError" exceptions raised by
  "ssl.SSLContext.load_cert_chain()", allowing users to have more
  context.

* gh-132888: Fix incorrect use of "ctypes.GetLastError()" and add
  missing error checks for Windows API calls in
  "_pyrepl.windows_console".

* gh-142956: Updated "tomllib" to parse TOML 1.1.0.

* gh-144217: "mimetypes": Add support for DICOM files (for medical
  imaging) with the official MIME type "application/dicom". Patch by
  Benedikt Johannes.

* gh-144212: Mime type "image/jxl" is now supported by "mimetypes".

* gh-143594: Add "symtable.Function.get_cells()" and
  "symtable.Symbol.is_cell()" methods.

* gh-144169: Fix three crashes when non-string keyword arguments are
  supplied to objects in the "ast" module.

* gh-144128: Fix a crash in "array.array.fromlist()" when an element's
  "__index__()" method mutates the input list during conversion.

* gh-144100: Fixed a crash in ctypes when using a deprecated
  "POINTER(str)" type in "argtypes". Instead of aborting, ctypes now
  raises a proper Python exception when the pointer target type is
  unresolved.

* gh-143658: "importlib.metadata": Use "str.lower()" and
  "str.replace()" to further improve performance of
  "importlib.metadata.Prepared.normalize()". Patch by Hugo van
  Kemenade and Henry Schreiner.

* gh-144050: Fix "stat.filemode()" in the pure-Python implementation
  to avoid misclassifying invalid mode values as block devices.

* gh-83069: "subprocess.Popen.wait()": when "timeout" is not "None",
  an efficient event-driven mechanism now waits for process
  termination, if available. Linux >= 5.3 uses "os.pidfd_open()" +
  "select.poll()". macOS and other BSD variants use "select.kqueue()"
  + "KQ_FILTER_PROC" + "KQ_NOTE_EXIT". Windows keeps using
  "WaitForSingleObject" (unchanged). If none of these mechanisms are
  available, the function falls back to the traditional busy loop
  (non-blocking call and short sleeps). Patch by Giampaolo Rodola.

* gh-144030: The Python implementation of "functools.lru_cache()"
  differed from the default C implementation in that it did not check
  that its argument is callable. This discrepancy is now fixed and
  both raise a "TypeError".

* gh-144001: Added the *ignorechars* parameter in
  "binascii.a2b_base64()" and "base64.b64decode()".

* gh-144023: Fixed validation of file descriptor 0 in posix functions
  when used with follow_symlinks parameter.

* gh-143999: Fix an issue where "inspect.getgeneratorstate()" and
  "inspect.getcoroutinestate()" could fail for generators wrapped by
  "types.coroutine()" in the suspended state.

* gh-143952: Fixed "asyncio" debugging tools to work with new remote
  debugging API. Patch by Bartosz Sławecki.

* gh-143904: "struct.pack_into()" now raises OverflowError instead of
  IndexError for too large *offset* argument.

* gh-143897: Remove the "isxidstart()" and "isxidcontinue()" methods
  of "unicodedata.ucd_3_2_0". They are now only exposed as
  "unicodedata.isxidstart()" and "unicodedata.isxidcontinue()".

* gh-143831: "annotationlib.ForwardRef" objects are now hashable when
  created from annotation scopes with closures. Previously, hashing
  such objects would throw an exception. Patch by Bartosz Sławecki.

* gh-143874: Fixed a bug in "pdb" where expression results were not
  sent back to remote client.

* gh-143754: Add new "tkinter" widget methods "pack_content()",
  "place_content()" and "grid_content()" which are alternative
  spelling of old "*_slaves()" methods.

* gh-143756: Fix potential thread safety issues in "ssl" module.

* gh-132604: Previously, "Protocol" classes that were not decorated
  with "@~typing.runtime_checkable", but that inherited from another
  "Protocol" class that did have this decorator, could be used in
  "isinstance()" and "issubclass()" checks. This behavior is now
  deprecated and such checks will throw a "TypeError" in Python 3.20.
  Patch by Bartosz Sławecki.

* gh-143543: Fix a crash in itertools.groupby that could occur when a
  user-defined "__eq__()" method re-enters the iterator during key
  comparison.

* gh-143689: Fix "io.BufferedReader.read1()" state cleanup on buffer
  allocation failure.

* gh-143602: Fix a inconsistency issue in "write()" that leads to
  unexpected buffer overwrite by deduplicating the buffer exports.

* gh-142434: Use "ppoll()" if available in "select.poll()" to have a
  timeout resolution of 1 nanosecond, instead of a resolution of 1 ms.
  Patch by Victor Stinner.

* gh-140557: "array.array" buffers now have the same alignment when
  empty as when allocated. Unaligned buffers can still be created by
  slicing.

* gh-143423: Fix free-threaded build detection in the sampling
  profiler when Py_GIL_DISABLED is set to 0.

* gh-101178: Add Ascii85, Base85, and Z85 support to "binascii" and
  improve the performance of the base-85 converters in "base64".

* gh-142966: Fix "ctypes.POINTER.set_type()" not updating the format
  string to match the type.

* gh-142555: "array": fix a crash in "a[i] = v" when converting *i* to
  an index via "i.__index__" or "i.__float__" mutates the array.

* gh-142438: Fix _decimal builds configured with EXTRA_FUNCTIONALITY
  by correcting the Context.apply wrapper to pass the right argument.

* gh-141860: Add an "on_error" keyword-only parameter to
  "multiprocessing.set_forkserver_preload()" to control how import
  failures during module preloading are handled. Accepts "'ignore'"
  (default, silent), "'warn'" (emit "ImportWarning"), or "'fail'"
  (raise exception). Contributed by Nick Neumann and Gregory P. Smith.

* gh-125346: Accepting "+" and "/" characters with an alternative
  alphabet in "base64.b64decode()" and "base64.urlsafe_b64decode()" is
  now deprecated. In future Python versions they will be errors in the
  strict mode and discarded in the non-strict mode.

* gh-140715: Add "'%F'" support to "strptime()".

* gh-67041: Add the *missing_as_none* parameter to "urlparse()",
  "urlsplit()" and "urldefrag()" functions. Add the *keep_empty*
  parameter to "urlunparse()" and "urlunsplit()" functions. This
  allows to distinguish between empty and not defined URI components
  and preserve empty components.

* gh-77188: The "pickle" module now properly handles name-mangled
  private methods.


IDLE
----

* gh-143774: Better explain the operation of Format / Format
  Paragraph.


Núcleo e embutidos
------------------

* gh-134584: Optimize and eliminate ref-counting in
  "_BINARY_OP_SUBSCR_LIST_SLICE"

* gh-144563: Fix interaction of the Tachyon profiler and "ctypes" and
  other modules that load the Python shared library (if present) in an
  independent map as this was causing the mechanism that loads the
  binary information to be confused. Patch by Pablo Galindo

* gh-144601: Fix crash when importing a module whose "PyInit" function
  raises an exception from a subinterpreter.

* gh-144549: Fix building the tail calling interpreter on Visual
  Studio 2026 with free-threading.

* gh-144513: Fix potential deadlock when using critical sections
  during stop-the-world pauses in the free-threaded build.

* gh-131798: Optimise "_GUARD_TOS_SLICE" in the JIT.

* gh-144330: Move "classmethod" and "staticmethod" initialization from
  "__init__()" to "__new__()". Patch by Victor Stinner.

* gh-144446: Fix data races in the free-threaded build when reading
  frame object attributes while another thread is executing the frame.

* gh-120321: Add "gi_state", "cr_state", and "ag_state" attributes to
  generators, coroutines, and async generators that return the current
  state as a string (e.g., "GEN_RUNNING"). The "inspect" module
  functions "getgeneratorstate()", "getcoroutinestate()", and
  "getasyncgenstate()" now return these attributes directly.

* gh-141563: Fix thread safety of " PyDateTime_IMPORT".

* gh-144280: Fix a bug in JIT where the predicate symbol had no
  truthiness

* gh-140550: In "PyModuleDef.m_slots", allow slots that repeat
  information present in "PyModuleDef".

* gh-139103: Improve scaling of "namedtuple()" instantiation in the
  free-threaded build.

* gh-144307: Prevent a reference leak in module teardown at
  interpreter finalization.

* gh-144319: Add huge pages support for the pymalloc allocator. Patch
  by Pablo Galindo

* gh-120321: Made "gi_yieldfrom" thread-safe in the free-threading
  build by using a lightweight lock on the frame state.

* gh-144194: Fix error handling in perf jitdump initialization on
  memory allocation failure.

* gh-143962: Name suggestion for not normalized name suggests now the
  normalized name or the closest name to the normalized name. If the
  suggested name is not ASCII, include also its ASCII representation.

* gh-144157: "bytes.translate()" now allows the compiler to unroll its
  loop more usefully for a 2x speedup in the common no-deletions
  specified case.

* gh-144068: Fix JIT tracer memory leak, ensure the JIT tracer state
  is freed when daemon threads are cleaned up during interpreter
  shutdown.

* gh-144012: Check if the result is "NULL" in "BINARY_OP_EXTENT"
  opcode.

* gh-144007: Eliminate redundant refcounting in the JIT for
  "BINARY_OP".

* gh-144005: Eliminate redundant refcounting from "BINARY_OP_EXTEND".

* gh-143939: Fix erroneous "cannot reuse already awaited coroutine"
  error that could occur when a generator was run during the process
  of clearing a coroutine's frame.

* gh-141805: Fix crash in "set" when objects with the same hash are
  concurrently added to the set after removing an element with the
  same hash while the set still contains elements with the same hash.

* gh-143670: Fixes a crash in "ga_repr_items_list" function.

* gh-143650: Fix race condition in "importlib" where a thread could
  receive a stale module reference when another thread's import fails.

* gh-143569: Generator expressions in 3.15 now conform to the
  documented behavior when the iterable does not support iteration.
  This matches the behavior in 3.14 and earlier

* gh-143192: Improve performance of bitwise operations on multi-digit
  ints.

* gh-132657: If we are specializing to "LOAD_GLOBAL_MODULE" or
  "LOAD_ATTR_MODULE", try to enable deferred reference counting for
  the value, if the object is owned by a different thread.  This
  applies to the free-threaded build only and should improve scaling
  of multi-threaded programs. Note that when deferred reference
  counting is enabled, the object will be deallocated by the GC,
  rather than by "Py_DECREF()".

* gh-143055: Implement **PEP 798** (Unpacking in Comprehensions).
  Patch by Adam Hartz.

* gh-142037: Improve error messages for printf-style formatting. For
  errors in the format string, always include the position of the
  start of the format unit. For errors related to the formatted
  arguments, always include the number or the name of the argument.
  Raise more specific errors and include more information (type and
  number of arguments, most probable causes of error).

* gh-140557: "bytearray" buffers now have the same alignment when
  empty as when allocated. Unaligned buffers can still be created by
  slicing.

* gh-140232: Frozenset objects with immutable elements are no longer
  tracked by the garbage collector.

* gh-115231: Setup "__module__" attribute for built-in static methods.
  Patch by Sergey B Kirpichev.


API C
-----

* gh-143869: Added "PyLong_GetNativeLayout()", "PyLongLayout",
  "PyLongExport", "PyLong_Export()", "PyLong_FreeExport()",
  "PyLongWriter", "PyLongWriter_Create()", "PyLongWriter_Finish()" and
  "PyLongWriter_Discard()" to the limited API.

* gh-141070: Renamed "PyUnstable_Object_Dump()" to "PyObject_Dump()".


Construção
----------

* gh-140421: Disable the perf trampoline on older macOS versions where
  it cannot be built.

* gh-144309: Build Python with POSIX 2024, instead of POSIX 2008.
  Patch by Victor Stinner.

* gh-144278: Enables defining the "_PY_IMPL_NAME" and
  "_PY_IMPL_CACHE_TAG" preprocessor definitions to override
  "sys.implementation" at build time. Definitions need to include
  quotes when setting to a string literal. Setting the cache tag to
  "NULL" has the effect of completely disabling automatic creation and
  use of ".pyc" files.

* gh-143960: Add support for OpenSSL 3.6, drop EOL 3.2. Patch by Hugo
  van Kemenade.

* gh-143941: Move WASI-related files to "Platforms/WASI". Along the
  way, leave a deprecated "Tools/wasm/wasi/__main__.py" behind for
  backwards-compatibility.

* gh-143842: Prevent static builds from clashing with curses by making
  the optimizer COLORS table static.


Python 3.15.0 alpha 5
=====================

*Release date: 2026-01-14*


Windows
-------

* gh-143082: Fix "pdb" arrow key history not working when "stdin" is
  "sys.stdin".

* gh-128067: Fix a bug in PyREPL on Windows where output without a
  trailing newline was overwritten by the next prompt.


Ferramentas/Demos
-----------------

* gh-142095: Make gdb 'py-bt' command use frame from thread local
  state when available. Patch by Sam Gross and Victor Stinner.


Testes
------

* gh-143460: Skip tests relying on infinite recusion if stack size is
  unlimited.

* gh-143553: Add support for parametrized resources, such as "-u
  xpickle=2.7".

* bpo-31391: Forward-port test_xpickle from Python 2 to Python 3 and
  add the resource back to test's command line.


Biblioteca
----------

* gh-143706: Fix "multiprocessing" forkserver so that "sys.argv" is
  correctly set before "__main__" is preloaded. Previously, "sys.argv"
  was empty during main module import in forkserver child processes.
  This fixes a regression introduced in 3.13.8 and 3.14.1. Root caused
  by Aaron Wieczorek, test provided by Thomas Watson, thanks!

* gh-143638: Forbid reentrant calls of the "pickle.Pickler" and
  "pickle.Unpickler" methods for the C implementation. Previously,
  this could cause crash or data corruption, now concurrent calls of
  methods of the same object raise "RuntimeError".

* gh-143658: "importlib.metadata": Use "str.translate()" to improve
  performance of "importlib.metadata.Prepared.normalize()". Patch by
  Hugo van Kemenade and Henry Schreiner.

* gh-78724: Raise "RuntimeError"'s when user attempts to call methods
  on half-initialized "Struct" objects, For example, created by
  "Struct.__new__(Struct)".  Patch by Sergey B Kirpichev.

* gh-143196: Fix crash when the internal encoder object returned by
  undocumented function "json.encoder.c_make_encoder()" was called
  with non-zero second (*_current_indent_level*) argument.

* gh-143191: "_thread.stack_size()" now raises "ValueError" if the
  stack size is too small. Patch by Victor Stinner.

* gh-143547: Fix "sys.unraisablehook()" when the hook raises an
  exception and changes "sys.unraisablehook()": hold a strong
  reference to the old hook. Patch by Victor Stinner.

* gh-139686: Revert 0a97941245f1dda6d838f9aaf0512104e5253929 and
  57db12514ac686f0a752ec8fe1c08b6daa0c6219 which made importlib.reload
  a no-op for lazy modules; caused Buildbot failures.

* gh-143517: "annotationlib.get_annotations()" no longer raises a
  "SyntaxError" when evaluating a stringified starred annotation that
  starts with one or more whitespace characters followed by a "*".
  Patch by Bartosz Sławecki.

* gh-143474: Add "os.RWF_ATOMIC" constant for Linux 6.11+.

* gh-143445: Speed up "copy.deepcopy()" by 1.04x.

* gh-143378: Fix use-after-free crashes when a "BytesIO" object is
  concurrently mutated during "write()" or "writelines()".

* gh-143368: Fix endless retry loop in "profiling.sampling" blocking
  mode when threads cannot be seized due to "EPERM". Such threads are
  now skipped instead of causing repeated error messages. Patch by
  Pablo Galindo.

* gh-143346: Fix incorrect wrapping of the Base64 data in
  "plistlib._PlistWriter" when the indent contains a mix of tabs and
  spaces.

* gh-140025: "queue": Fix "SimpleQueue.__sizeof__()" computation.

* gh-143310: "tkinter": fix a crash when a Python "list" is mutated
  during the conversion to a Tcl object (e.g., when setting a Tcl
  variable). Patch by Bénédikt Tran.

* gh-143309: Fix a crash in "os.execve()" on non-Windows platforms
  when given a custom environment mapping which is then mutated during
  parsing. Patch by Bénédikt Tran.

* gh-143308: "pickle": fix use-after-free crashes when a
  "PickleBuffer" is concurrently mutated by a custom buffer callback
  during pickling. Patch by Bénédikt Tran and Aaron Wieczorek.

* gh-142939: Performance optimisations for
  "difflib.get_close_matches()"

* gh-124951: The base64 implementation behind the "binascii",
  "base64", and related codec has been optimized for modern pipelined
  CPU architectures and now performs 2-3x faster across all platforms.

* gh-143237: Fix support of named pipes in the rotating "logging"
  handlers.

* gh-143249: Fix possible buffer leaks in Windows overlapped I/O on
  error handling.

* gh-143241: "zoneinfo": fix infinite loop in "ZoneInfo.from_file"
  when parsing a malformed TZif file. Patch by Fatih Celik.

* gh-142830: "sqlite3": fix use-after-free crashes when the
  connection's callbacks are mutated during a callback execution.
  Patch by Bénédikt Tran.

* gh-143200: "xml.etree.ElementTree": fix use-after-free crashes in
  "__getitem__()" and "__setitem__()" methods of "Element" when the
  element is concurrently mutated. Patch by Bénédikt Tran.

* gh-143214: Add the *wrapcol* parameter in "binascii.b2a_base64()"
  and "base64.b64encode()".

* gh-142195: Updated timeout evaluation logic in "subprocess" to be
  compatible with deterministic environments like Shadow where time
  moves exactly as requested.

* gh-140739: Fix several crashes due to reading invalid memory in the
  new Tachyon sampling profiler. Patch by Pablo Galindo.

* gh-142164: Fix the ctypes bitfield overflow error message to report
  the correct offset and size calculation.

* gh-143145: Fixed a possible reference leak in ctypes when
  constructing results with multiple output parameters on error.

* gh-143103: Add padding support to "base64.z85encode()" via the "pad"
  parameter.

* gh-130796: Undeprecate the "locale.getdefaultlocale()" function.
  Patch by Victor Stinner.

* gh-74902: Add the "iter_graphemes()" function in the "unicodedata"
  module to iterate over grapheme clusters according to rules defined
  in Unicode Standard Annex #29, "Unicode Text Segmentation". Add
  "grapheme_cluster_break()", "indic_conjunct_break()" and
  "extended_pictographic()" functions to get the properties of the
  character which are related to the above algorithm.

* gh-143004: Fix a potential use-after-free in
  "collections.Counter.update()" when user code mutates the Counter
  during an update.

* gh-140648: The "asyncio" REPL now respects the "-I" flag (isolated
  mode). Previously, it would load and execute "PYTHONSTARTUP" even if
  the flag was set. Contributed by Bartosz Sławecki.

* gh-142991: Fixed socket operations such as recvfrom() and sendto()
  for FreeBSD divert(4) socket.

* gh-116738: Make the attributes in "lzma" thread-safe on the *free
  threaded* build.

* gh-142950: Fix regression in "argparse" where format specifiers in
  help strings raised "ValueError".

* gh-142881: Fix concurrent and reentrant call of
  "atexit.unregister()".

* gh-142615: Fix possible crashes when initializing "asyncio.Task" or
  "asyncio.Future" multiple times. These classes can now be
  initialized only once and any subsequent initialization attempt will
  raise a RuntimeError. Patch by Kumar Aditya.

* gh-142517: The non-"compat32" "email" policies now correctly handle
  refolding encoded words that contain bytes that can not be decoded
  in their specified character set.  Previously this resulted in an
  encoding exception during folding.

* gh-138122: The Tachyon profiler's live TUI now integrates with the
  experimental "_colorize" theming system. Users can customize colors
  via "_colorize.set_theme()" (experimental API, subject to change). A
  "LiveProfilerLight" theme is provided for light terminal
  backgrounds. Patch by Pablo Galindo.

* gh-142306: Improve errors for "Element.remove".

* gh-63016: Add a "flags" parameter to "mmap.mmap.flush()" to control
  synchronization behavior.

* gh-139262: Some keystrokes can be swallowed in the new "PyREPL" on
  Windows, especially when used together with the ALT key. Fix by
  Chris Eibl.

* gh-138897: Improved "license"/"copyright"/"credits" display in the
  *REPL*: now uses a pager.

* gh-135852: Add "_winapi.RegisterEventSource()",
  "_winapi.DeregisterEventSource()" and "_winapi.ReportEvent()". Using
  these functions in "NTEventLogHandler" to replace "pywin32".

* gh-109263: Starting a process from spawn context in
  "multiprocessing" no longer sets the start method globally.

* gh-132715: Skip writing objects during marshalling once a failure
  has occurred.


Documentação
------------

* gh-140806: Add documentation for "enum.bin()".


Núcleo e embutidos
------------------

* gh-134584: Eliminate redundant refcounting from "_CONTAINS_OP",
  "_CONTAINS_OP_SET" and "_CONTAINS_OP_DICT".

* gh-143604: Fix a reference counting issue in the JIT tracer where
  the current executor could be prematurely freed during tracing.

* gh-143469: Enable "LOAD_ATTR_MODULE" specialization even if
  "__getattr__()" is defined in module.

* gh-134584: Eliminate redundant refcounting from "TO_BOOL_STR".

* gh-143377: Fix a crash in "_interpreters.capture_exception()" when
  the exception is incorrectly formatted. Patch by Bénédikt Tran.

* gh-139757: Add "BINARY_OP_SUBSCR_USTR_INT" to specialize reading an
  ASCII character from any string. Patch by Chris Eibl.

* gh-141504: Factor out tracing and optimization heuristics into a
  single object. Patch by Donghee Na.

* gh-142982: Specialize "CALL_FUNCTION_EX" for Python and non-Python
  callables.

* gh-136924: The interactive help mode in the *REPL* no longer
  incorrectly syntax highlights text input as Python code. Contributed
  by Olga Matoula.

* gh-139757: Fix unintended bytecode specialization for non-ascii
  string. Patch by Donghee Na, Ken Jin and Chris Eibl.

* gh-143361: Add "PY_VECTORCALL_ARGUMENTS_OFFSET" to
  "_Py_CallBuiltinClass_StackRefSteal" to avoid redundant allocations

* gh-131798: The JIT optimizer now understands more generator
  instructions.

* gh-134584: Eliminate redundant refcounting from "_LOAD_ATTR_SLOT".

* gh-143189: Fix crash when inserting a non-"str" key into a split
  table dictionary when the key matches an existing key in the split
  table but has no corresponding value in the dict.

* gh-143228: Fix use-after-free in perf trampoline when toggling
  profiling while threads are running or during interpreter
  finalization with daemon threads active. The fix uses reference
  counting to ensure trampolines are not freed while any code object
  could still reference them. Pach by Pablo Galindo

* gh-142664: Fix a use-after-free crash in "memoryview.__hash__" when
  the "__hash__" method of the referenced object mutates that object
  or the view. Patch by Bénédikt Tran.

* gh-142557: Fix a use-after-free crash in bytearray.__mod__ when the
  "bytearray" is mutated while formatting the "%"-style arguments.
  Patch by Bénédikt Tran.

* gh-143195: Fix use-after-free crashes in "bytearray.hex()" and
  "memoryview.hex()" when the separator's "__len__()" mutates the
  original object. Patch by Bénédikt Tran.

* gh-143183: Fix a bug in the JIT when dealing with unsupported
  control-flow or operations.

* gh-142975: Fix crash after unfreezing all objects tracked by the
  garbage collector on the *free threaded* build.

* gh-143135: Set "sys.flags.inspect" to "1" when "PYTHONINSPECT" is
  "0". Previously, it was set to "0" in this case.

* gh-143123: Protect the JIT against recursive tracing.

* gh-143092: Fix a crash in the JIT when dealing with "list.append(x)"
  style code.

* gh-143003: Fix an overflow of the shared empty buffer in
  "bytearray.extend()" when "__length_hint__()" returns 0 for non-
  empty iterator.

* gh-143006: Fix a possible assertion error when comparing negative
  non-integer "float" and "int" with the same number of bits in the
  integer part.

* gh-116738: Fix thread safety of "contextvars.Context.run()".

* gh-142829: Fix a use-after-free crash in "contextvars.Context"
  comparison when a custom "__eq__" method modifies the context via
  "set()".

* gh-142863: Generate optimized bytecode when calling "list" or "set"
  with generator expression.

* gh-41779: Allowed defining any __slots__ for a class derived from
  "tuple" (including classes created by "collections.namedtuple()").

* gh-69605: Fix edge-cases around already imported modules in the
  *REPL* auto-completion of imports.

* gh-138568: Adjusted the built-in "help()" function so that empty
  inputs are ignored in interactive mode.

* gh-131798: Remove bounds check when indexing into tuples with a
  constant index.

* gh-134584: Eliminate redundant refcounting from "_CALL_TYPE_1".
  Patch by Tomas Roun

* gh-132108: Speed up "int.from_bytes()" when passed object supports
  buffer protocol, like "bytearray" by ~1.2x.

* gh-128334: Make the "slice" class subscriptable at runtime to be
  consistent with typing implementation.


API C
-----

* gh-141671: "PyMODINIT_FUNC" (and the new "PyMODEXPORT_FUNC") now
  adds a linkage declaration ("__declspec(dllexport)") on Windows.


Python 3.15.0 alpha 4
=====================

*Release date: 2026-01-13*


Testes
------

* gh-142836: Accommodated Solaris in
  "test_pdb.test_script_target_anonymous_pipe".


Biblioteca
----------

* gh-122431: Corrected the error message in
  "readline.append_history_file()" to state that "nelements" must be
  non-negative instead of positive.

* gh-143046: The "asyncio" REPL no longer prints copyright and version
  messages in the quiet mode ("-q"). Patch by Bartosz Sławecki.

* gh-80744: Fix issue where "pdb" would read a ".pdbrc" twice if
  launched from the home directory

* gh-138122: Add blocking mode to Tachyon for accurate stack traces in
  applications with many generators or fast-changing call stacks.
  Patch by Pablo Galindo.

* gh-143010: Fixed a bug in "mailbox" where the precise timing of an
  external event could result in the library opening an existing file
  instead of a file it expected to create.

* gh-112127: Fix possible use-after-free in "atexit.unregister()" when
  the callback is unregistered during comparison.

* gh-138122: Fix incomplete stack traces in the Tachyon profiler's
  frame cache when profiling code with deeply nested generators. The
  frame cache now validates that stack traces reach the base frame
  before caching, preventing broken flamegraphs. Patch by Pablo
  Galindo.

* gh-142834: Change the "pdb" "commands" command to use the last
  available breakpoint instead of failing when the most recently
  created breakpoint was deleted.

* gh-142783: Fix zoneinfo use-after-free with descriptor _weak_cache.
  a descriptor as _weak_cache could cause crashes during object
  creation. The fix ensures proper reference counting for descriptor-
  provided objects.

* gh-76007: Deprecate "VERSION" from "xml.etree.ElementTree" and
  "version" from "xml.sax.expatreader" and "xml.sax.handler". Patch by
  Hugo van Kemenade.

* gh-142784: The "asyncio" REPL now properly closes the loop upon the
  end of interactive session. Previously, it could cause surprising
  warnings. Contributed by Bartosz Sławecki.

* gh-138122: Add binary output format to "profiling.sampling" for
  compact storage of profiling data. The new "--binary" option
  captures samples to a file that can be converted to other formats
  using the "replay" command. Patch by Pablo Galindo

* gh-142495: "collections.defaultdict" now prioritizes "__setitem__()"
  when inserting default values from "default_factory". This prevents
  race conditions where a default value would overwrite a value set
  before "default_factory" returns.

* gh-142654: Show the clearer error message when using
  "profiling.sampling" on an unknown PID.

* gh-142560: Fix use-after-free in "bytearray" search-like methods
  ("find()", "count()", "index()", "rindex()", and "rfind()") by
  marking the storage as exported which causes reallocation attempts
  to raise "BufferError". For "contains()", "split()", and "rsplit()"
  the buffer protocol is used for this.

* gh-142419: "mmap.mmap.set_name()" method added to annotate an
  anonymous memory map if Linux kernel supports "PR_SET_VMA_ANON_NAME"
  (Linux 5.17 or newer). Patch by Donghee Na.

* gh-139971: "pydoc": Ensure that the link to the online documentation
  of a *stdlib* module is correct.

* gh-124098: Fix issue where methods in handlers that lacked the
  protocol name but matched a valid base handler method (e.g.,
  "_open()" or "error()") were incorrectly added to
  "urllib.request.OpenerDirector"'s handlers. Contributed by Andrea
  Mattei.

* gh-136282: Add support for "UNNAMED_SECTION" when creating a section
  via the mapping protocol access


Núcleo e embutidos
------------------

* gh-143057: Avoid locking in "PyTraceMalloc_Track()" and
  "PyTraceMalloc_Untrack()" when "tracemalloc" is not enabled.

* gh-139109: Add missing terminator in certain cases when tracing in
  the new JIT compiler.

* gh-142961: Fix a segfault in the JIT when constant folding
  "len(tuple)".

* gh-142776: Fix a file descriptor leak in import.c

* gh-139757: Fix building JIT stencils on free-threaded builds.

* gh-129068: Make concurrent iteration over the same range iterator
  thread-safe in the free threading build.

* gh-142543: Fix a stack overflow on Clang JIT build configurations
  with full LTO.

* gh-142448: Fix a bug when using monitoring with the JIT.

* gh-142766: Clear the frame of a generator when "generator.close()"
  is called.

* gh-134584: Eliminate redundant refcounting from
  "_LOAD_ATTR_INSTANCE_VALUE".

* gh-134584: Eliminate redundant refcounting from
  "_STORE_ATTR_WITH_HINT".

* gh-142476: Fix a memory leak in the experimental Tier 2 optimizer
  when creating executors. Patched by Shamil Abdulaev.

* gh-100964: Fix reference cycle in exhausted generator frames. Patch
  by Savannah Ostrowski.

* gh-139922: Allow building CPython with the tail calling interpreter
  on Visual Studio 2026 MSVC. This provides a performance gain over
  the prior interpreter for MSVC. Patch by Ken Jin, Brandt Bucher, and
  Chris Eibl. With help from the MSVC team including Hulon Jenkins.


Python 3.15.0 alpha 3
=====================

*Release date: 2025-12-16*


Ferramentas/Demos
-----------------

* gh-141692: Cada componente de um XCframework para iOS agora contém
  uma pasta "lib" que contém um link simbólico para a biblioteca
  dinâmica libpython. Isso permite que módulos binários sejam
  compilados para iOS usando vinculação dinâmica de bibliotecas, em
  vez de vinculação de framework.


Testes
------

* gh-140381: Fix flaky test_profiling tests on i686 and s390x
  architectures by increasing slow_fibonacci call frequency from every
  5th iteration to every 2nd iteration.

* gh-140210: Make "test_sysconfig.test_parse_makefile_renamed_vars"
  less fragile by clearing the environment variables before parsing
  the Makefile.


Segurança
---------

* gh-142145: Remove quadratic behavior in "xml.minidom" node ID cache
  clearing.

* gh-42400: Fix buffer overflow in "_Py_wrealpath()" for paths
  exceeding "MAXPATHLEN" bytes by using dynamic memory allocation
  instead of fixed-size buffer. Patch by Shamil Abdulaev.

* gh-119451: Fix a potential memory denial of service in the
  "http.client" module. When connecting to a malicious server, it
  could cause an arbitrary amount of memory to be allocated. This
  could have led to symptoms including a "MemoryError", swapping, out
  of memory (OOM) killed processes or containers, or even system
  crashes.

* gh-119342: Fix a potential memory denial of service in the
  "plistlib" module. When reading a Plist file received from untrusted
  source, it could cause an arbitrary amount of memory to be
  allocated. This could have led to symptoms including a
  "MemoryError", swapping, out of memory (OOM) killed processes or
  containers, or even system crashes.


Biblioteca
----------

* gh-142754: Add the *ownerDocument* attribute to "xml.dom.minidom"
  elements and attributes created by directly instantiating the
  "Element" or "Attr" class. Note that this way of creating nodes is
  not supported; creator functions like
  "xml.dom.Document.documentElement()" should be used instead.

* gh-142594: Fix crash in "TextIOWrapper.close()" when the underlying
  buffer's "closed" property calls "detach()".

* gh-76007: Deprecate "__version__" from "ctypes". Patch by Hugo van
  Kemenade.

* gh-76007: Deprecate "__version__" from "wsgiref.simple_server".
  Patch by Hugo van Kemenade.

* gh-142651: "unittest.mock": fix a thread safety issue where
  "Mock.call_count" may return inaccurate values when the mock is
  called concurrently from multiple threads.

* gh-76007: Deprecate "__version__" from "http.server". Patch by Hugo
  van Kemenade.

* gh-138122: Add "--subprocesses" flag to "profiling.sampling" CLI to
  automatically profile subprocesses spawned by the target. When
  enabled, the profiler monitors for new Python subprocesses and
  profiles each one separately, writing results to individual output
  files. This is useful for profiling applications that use
  "multiprocessing", "ProcessPoolExecutor", or other subprocess-based
  parallelism. Patch by Pablo Galindo.

* gh-142595: Added type check during initialization of the "decimal"
  module to prevent a crash in case of broken stdlib.  Patch by Sergey
  B Kirpichev.

* gh-142556: Fix crash when a task gets re-registered during
  finalization in "asyncio". Patch by Kumar Aditya.

* gh-138122: Add "--mode=exception" to the sampling profiler to
  capture samples only from threads with an active exception, useful
  for analyzing exception handling overhead. Patch by Pablo Galindo.

* gh-142539: "traceback": Fix location of carets in "SyntaxError"s
  when the source contains wide characters.

* gh-123241: Avoid reference count operations in garbage collection of
  "ctypes" objects.

* gh-142451: "hmac": correctly copy "HMAC" attributes for objects
  copied through "HMAC.copy()". Patch by Bénédikt Tran.

* gh-138122: The "profiling.sampling" flamegraph profiler now supports
  inverted flamegraph view that aggregates all leaf nodes. In a
  standard flamegraph, if a hot function is called from multiple
  locations, it appears multiple times as separate leaf nodes. In the
  inverted flamegraph, all occurrences of the same leaf function are
  merged into a single aggregated node at the root, showing the total
  hotness of that function in one place. The children of each
  aggregated node represent its callers, making it easier to identify
  which functions consume the most CPU time and where they are called
  from.

* gh-112527: The help text for required options in "argparse" no
  longer extended with " (default: None)".

* gh-142438: Fixed a possible leaked GIL in _PySSL_keylog_callback.

* gh-138122: Add bytecode-level instruction profiling to the sampling
  profiler via the new "--opcodes" flag. When enabled, the profiler
  captures which bytecode opcode is executing at each sample,
  including Python 3.11+ adaptive specializations, and visualizes this
  data in the heatmap, flamegraph, gecko, and live output formats.
  Patch by Pablo Galindo

* gh-142389: Add backtick markup support in "argparse" description and
  epilog text to highlight inline code when color output is enabled.

* gh-142346: Corrige a formatação de uso para grupos mutuamente
  exclusivos em "argparse" quando eles são precedidos por argumentos
  posicionais ou seguidos ou misturados com outros argumentos
  opcionais.

* gh-142374: Fix cumulative percentage calculation for recursive
  functions in the new sampling profiler. When profiling recursive
  functions, cumulative statistics (cumul%, cumtime) could exceed 100%
  because each recursive frame in a stack was counted separately. For
  example, a function recursing 500 times in every sample would show
  50000% cumulative presence. The fix deduplicates locations within
  each sample so cumulative stats correctly represent "percentage of
  samples where this function was on the stack". Patch by Pablo
  Galindo.

* gh-142315: Pdb can now run scripts from anonymous pipes used in
  process substitution. Patch by Bartosz Sławecki.

* gh-64532: Subparser help now includes required optional arguments
  from the parent parser in the usage, making it clearer what
  arguments are needed to run a subcommand. Patch by Savannah
  Ostrowski.

* gh-142207: Fix: profiling.sampling may cause assertion "!(has_gil &&
  gil_requested)"

* gh-142332: Corrige formatação de uso para argumentos posicionais em
  grupos mutuamente exclusivos em "argparse". em "argparse".

* gh-142282: Fix "winreg.QueryValueEx()" to not accidentally read
  garbage buffer under race condition.

* gh-142318: Fix typing "'q'" at the help of the interactive tachyon
  profiler exiting the profiler.

* gh-75949: Corrige o "argparse" para preservar os separadores "|" em
  grupos mutuamente exclusivos quando a linha de uso quebra devido ao
  comprimento.

* gh-142267: Melhora o desempenho do "argparse" armazenando em cache o
  formatador usado para validação de argumentos.

* gh-139862: Remove "color" parameter from "argparse.HelpFormatter"
  constructor. Color is controlled by "ArgumentParser".

* gh-68552: Os defeitos "MisplacedEnvelopeHeaderDefect" e "Missing
  header name" agora são passados corretamente para o método
  "handle_defect" de "policy" em "FeedParser".

* gh-142206: The resource tracker in the "multiprocessing" module can
  now understand messages from older versions of itself. This avoids
  issues with upgrading Python while it is running. (Note that such
  'in-place' upgrades are not tested.)

* gh-142214: Fix two regressions in "dataclasses" in Python 3.14.1
  related to annotations.

  * An exception is no longer raised if "slots=True" is used and the
    "__init__" method does not have an "__annotate__" attribute
    (likely because "init=False" was used).

  * An exception is no longer raised if annotations are requested on
    the "__init__" method and one of the fields is not present in the
    class annotations. This can occur in certain dynamic scenarios.

  Patch by Jelle Zijlstra.

* gh-142203: Remove the *debug_override* parameter from
  "importlib.util.cache_from_source()" which has been deprecated since
  Python 3.5.

* gh-138122: The "_remote_debugging" module now implements frame
  caching in the "RemoteUnwinder" class to reduce memory reads when
  profiling remote processes. When "cache_frames=True", unchanged
  portions of the call stack are reused from previous samples,
  significantly improving profiling performance for deep call stacks.

* gh-116738: Fix "cmath" data race when initializing trigonometric
  tables with subinterpreters.

* gh-141982: Allow "pdb" to set breakpoints on async functions with
  function names.

* gh-74389: Quando a entrada padrão (stdin) usada por uma instância de
  "subprocess.Popen" é fechada, isso agora é ignorado em
  "subprocess.Popen.communicate()", em vez de deixar a classe em um
  estado inconsistente.

* gh-87512: Corrige o tratamento do limite de tempo de
  "subprocess.Popen.communicate()" no Windows ao escrever entradas
  grandes. Anteriormente, o timeout era ignorado durante a escrita na
  entrada padrão (stdin), fazendo com que o método bloqueasse
  indefinidamente se o processo filho não consumisse a entrada
  rapidamente. Agora, a escrita na entrada padrão é realizada em uma
  thread em segundo plano, permitindo que o tempo limite seja aplicado
  corretamente.

* gh-141939: Add color to all interpolated values in "argparse" help,
  like "%(default)s" or "%(choices)s". Patch by Alex Prengère.

* gh-141473: Quando o método "subprocess.Popen.communicate()" é
  chamado com um valor de entrada e um tempo limite definido, e é
  chamado uma segunda vez após uma exceção "TimeoutExpired" antes que
  o processo seja encerrado, ele não deve mais travar.

* gh-141999: Correctly allow "KeyboardInterrupt" to stop the process
  when using "profiling.sampling".

* gh-142006: Corrige um bug no algoritmo de recolhimento do mod
  "email.policy.default" que resultava incorretamente em uma quebra de
  linha duplicada quando uma linha que terminava exatamente em
  max_line_length era seguida por um token que podia ser desdobrado.

* gh-141968: Remove data copy from "re" compilation of regexes with
  large charsets by using "bytearray.take_bytes()".

* gh-141968: Remove data copy from "encodings.idna" "encode()" and
  "encode()" by using "bytearray.take_bytes()".

* gh-141968: Remove data copy from "codecs" "punycode" encoding by
  using "bytearray.take_bytes()".

* gh-141968: Remove data copy from "wave.Wave_read.readframes()" and
  "wave.Wave_write.writeframes()" by using "bytearray.take_bytes()".

* gh-141968: Remove a data copy from "base64.b32decode()" and
  "base64.b32encode()" by using "bytearray.take_bytes()".

* gh-59000: Fix "pdb" breakpoint resolution for class methods when the
  module defining the class is not imported.

* gh-116738: Corrige problema de segurança de threads com objetos
  scanners de "re" em construções com threads livres.

* gh-138122: The "profiling.sampling" flamegraph profiler now displays
  thread status statistics showing the percentage of time threads
  spend holding the GIL, running without the GIL, waiting for the GIL,
  and performing garbage collection. These statistics help identify
  GIL contention and thread behavior patterns. When filtering by
  thread, the display shows per-thread metrics.

* gh-141781: Fixed an issue where pdb.line_prefix assignment was
  ignored if assigned after the module was imported.

* gh-141863: Update Streams to use "bytearray.take_bytes()" for a over
  10% performance improvement on pyperformance asyncio_tcp benchmark.

* gh-141817: Add "socket.IPV6_HDRINCL" constant.

* gh-105836: Fix "asyncio.run_coroutine_threadsafe()" leaving
  underlying cancelled asyncio task running.

* gh-141570: Suporte para *objeto arquivo ou similar* que levanta
  "OSError" de "fileno()" na detecção de cores
  ("_colorize.can_colorize()"). Isso pode ocorrer quando "sys.stdout"
  é redirecionado.

* gh-141679: Add colour to defaults in "argparse" help. Patch by Hugo
  van Kemenade.

* gh-141686: Break reference cycles created by each call to
  "json.dump()" or "json.JSONEncoder.iterencode()".

* gh-141659: Corrige erros de descritor de arquivo inválido
  provenientes do processo "_posixsubprocess" no AIX.

* gh-141645: Add a new "--live" mode to the tachyon profiler in
  "profiling.sampling" module. This mode consist of a live TUI that
  displays real-time profiling statistics as the target application
  runs, similar to "top". Patch by Pablo Galindo

* gh-141615: Check "stdin" instead of "stdout" for "use_rawinput" in
  "pdb".

* gh-69113: Fix "doctest" to correctly report line numbers for
  doctests in "__test__" dictionary when formatted as triple-quoted
  strings by finding unique lines in the string and matching them in
  the source file.

* gh-141600: Corrigeoa detecção da versão musl no Void Linux.

* gh-48752: Add "readline.get_pre_input_hook()" function to retrieve
  the current pre-input hook. This allows applications to save and
  restore the hook without overwriting user settings. Patch by Sanyam
  Khurana.

* gh-141565: Add async-aware profiling to the Tachyon sampling
  profiler. The profiler now reconstructs and displays async task
  hierarchies in flamegraphs, making the output more actionable for
  users. Patch by Savannah Ostrowski and Pablo Galindo Salgado.

* gh-60107: Remove a copy from "io.RawIOBase.read()". If the
  underlying I/O class keeps a reference to the mutable memory, raise
  a "BufferError".

* gh-116738: Torna o módulo csv seguro para thread na construção com
  *threads livres*.

* gh-140911: "collections": Garante que os métodos
  "UserString.rindex()" e "UserString.index()" aceitem instâncias de
  "collections.UserString" como sub-argumento.

* gh-140875: Corrigido o tratamento de referências de caracteres não
  fechadas (nomeadas e numéricas) seguidas pelo fim do arquivo em
  "html.parser.HTMLParser" com "convert_charrefs=False".

* gh-140677: Add heatmap visualization mode to the Tachyon sampling
  profiler. The new "--heatmap" output format provides a line-by-line
  view showing execution intensity with color-coded samples, inline
  statistics, and interactive call graph navigation between callers
  and callees.

* gh-139946: Distinguish stdout and stderr when colorizing output in
  argparse module.

* gh-76007: "pydoc": Fix "DeprecationWarning" being raised when
  generating doc for *stdlib* modules.

* gh-138697: Fix inferring *dest* from a single-dash long option in
  "argparse". If a short option and a single-dash long option are
  passed to "add_argument()", *dest* is now inferred from the single-
  dash long option.

* gh-138525: Add support for single-dash long options and alternate
  prefix characters in "argparse.BooleanOptionalAction".

* gh-79986: Add parsing for "References" and "In-Reply-To" headers to
  the "email" library that parses the header content as lists of
  message id tokens.  This prevents them from being folded
  incorrectly.

* gh-135559: Flag: a "dir()" on a "Flag" enumeration now shows non-
  canonical members. (i.e. aliases).

* gh-134453: Corrigido o tratamento de "input=" da função
  "subprocess.Popen.communicate()" por instâncias de "memoryview" que
  não tinham formato de bytes em plataformas POSIX. Agora, essas
  instâncias são convertidas corretamente para uma visualização em
  formato de byte, em vez de truncar a entrada. Plataformas Windows
  não apresentavam esse bug.

* gh-127930: Add "__all__" to "tkinter.simpledialog".

* gh-115952: Fix a potential memory denial of service in the "pickle"
  module. When reading a pickled data received from untrusted source,
  it could cause an arbitrary amount of memory to be allocated, even
  if the code that is allowed to execute is restricted by overriding
  the "find_class()" method. This could have led to symptoms including
  a "MemoryError", swapping, out of memory (OOM) killed processes or
  containers, or even system crashes.

* bpo-40350: Fix support for namespace packages in "modulefinder".


Documentação
------------

* gh-141994: "xml.sax.handler": Faz a documentação de
  "xml.sax.handler.feature_external_ges" alertar sobre a
  vulnerabilidade a ataques de entidades externas. Patch por Sebastian
  Pipping.


Núcleo e embutidos
------------------

* gh-134584: Eliminate redundant refcounting from
  "_STORE_ATTR_INSTANCE_VALUE".

* gh-142718: JIT: Fix segfault caused by not flushing the stack to
  memory at side exits.

* gh-142737: Tracebacks will be displayed in fallback mode even if
  "io.open()" is lost. Previously, this would crash the interpreter.
  Patch by Bartosz Sławecki.

* gh-116738: Make the attributes in "bz2" thread-safe on the *free
  threaded* build.

* gh-134584: Eliminate redundant refcounting from "_CALL_LIST_APPEND".

* gh-142554: Fix a crash in "divmod()" when "_pylong.int_divmod()"
  does not return a tuple of length two exactly. Patch by Bénédikt
  Tran.

* gh-142531: Fix a free-threaded GC performance regression.  If there
  are many untracked tuples, the GC will run too often, resulting in
  poor performance.  The fix is to include untracked tuples in the
  "long lived" object count. The number of frozen objects is also now
  included since the free-threaded GC must scan those too.

* gh-142402: Fix reference counting when adjacent literal parts are
  merged while constructing "string.templatelib.Template", preventing
  the displaced string object from leaking.

* gh-116738: Make the attributes in "zlib" thread-safe on the *free
  threaded* build.

* gh-142343: Fix SIGILL crash on m68k due to incorrect assembly
  constraint.

* gh-142236: Improve the "Perhaps you forgot a comma?" syntax error
  for multi-line string concatenations to point to the last string
  instead of the first, making it easier to locate where the comma is
  missing. Patch by Pablo Galindo.

* gh-142236: Fix incorrect keyword suggestions for syntax errors in
  "traceback". The keyword typo suggestion mechanism would incorrectly
  suggest replacements when the extracted source code was incomplete
  rather than containing an actual typo. Patch by Pablo Galindo.

* gh-142305: Decrease the size of the generated stencils and the
  runtime JIT code. Patch by Diego Russo.

* gh-135379: Implement a limited form of register allocation known as
  "top of stack caching" in the JIT. It works by keeping 0-3 of the
  top items in the stack in registers. The code generator generates
  multiple versions of those uops that do not escape and are
  relatively small. During JIT compilation, the copy that produces the
  least memory traffic is selected, spilling or reloading values when
  needed.

* gh-142276: Fix missing type watcher when promoting attribute loads
  to constants in the JIT. Patch by Ken Jin. Reproducer by Yuancheng
  Jiang.

* gh-142218: Fix crash when inserting into a split table dictionary
  with a non "str" key that matches an existing key.

* gh-141976: Check against abstract stack overflow in the JIT
  optimizer.

* gh-97850: Remove all "*.load_module()" usage and definitions from
  the import system and importlib. The method has been deprecated in
  favor of "importlib.abc.Loader.exec_module()" since Python 3.4.

* gh-142048: Fix quadratically increasing garbage collection delays in
  free-threaded build.

* gh-65961: Stop setting "__cached__" on modules.

* gh-141770: Annotate anonymous mmap usage only when supported by the
  Linux kernel and if "-X dev" is used or Python is built in debug
  mode. Patch by Donghee Na.

* gh-142029: Raise "ModuleNotFoundError" instead of crashing when a
  nonexistent module is used as a name in "_imp.create_builtin()".

* gh-142029: Raise "ValueError" instead of crashing when empty string
  is used as a name in "_imp.create_builtin()".

* gh-141976: Protect against specialization failures in the tracing
  JIT compiler for performance reasons.

* gh-141861: Fix invalid memory read in the "ENTER_EXECUTOR"
  instruction.

* gh-141930: When importing a module, use Python's regular file object
  to ensure that writes to ".pyc" files are complete or an appropriate
  error is raised.

* gh-138122: Add incomplete sample detection to prevent corrupted
  profiling data. Each thread state now contains an embedded base
  frame (sentinel at the bottom of the frame stack) with owner type
  "FRAME_OWNED_BY_INTERPRETER". The profiler validates that stack
  unwinding terminates at this sentinel frame. Samples that fail to
  reach the base frame (due to race conditions, memory corruption, or
  other errors) are now rejected rather than being included as
  spurious data.

* gh-120158: Corrige estado inconsistente ao habilitar e desabilitar
  eventos de monitoramento muitas vezes.

* gh-140638: Expose a ""candidates"" stat in "gc.get_stats()" and
  "gc.callbacks".

* gh-141780: Fix "Py_mod_gil" with API added in **PEP 793**:
  "PyModule_FromSlotsAndSpec()" and "PyModExport" hooks

* gh-141732: Ensure the "__repr__()" for "ExceptionGroup" and
  "BaseExceptionGroup" does not change when the exception sequence
  that was original passed in to its constructor is subsequently
  mutated.

* gh-140638: Expose a ""duration"" stat in "gc.get_stats()" and
  "gc.callbacks".

* gh-139653: Somente levanta um erro "RecursionError" ou aciona um
  erro fatal se o ponteiro da pilha estiver abaixo do ponteiro limite
  *e* acima da base da pilha. Se estiver fora desses limites, presume
  que está tudo bem. Isso evita falsos positivos quando threads do
  espaço do usuário trocam pilhas.

* gh-41779: Allowed defining the *__dict__* and *__weakref__*
  __slots__ for any class.

* gh-139103: Melhora a escalabilidade multithread das classes de dados
  na construção com threads livres.

* gh-141589: Change "backoff counter" to use prime numbers instead of
  powers of 2. Use only 3 bits for "counter" and 13 bits for "value".
  This allows to support values up to 8191. Patch by Mikhail Efimov.

* gh-137007: Fix a bug during JIT compilation failure which caused
  garbage collection debug assertions to fail.

* gh-132657: For the free-threaded build, avoid locking the "set"
  object for the "__contains__" method.

* gh-134584: Eliminate redundant refcounting from "_CALL_STR_1".

* gh-134584: Eliminate redundant refcounting from "_CALL_BUILTIN_O".

* gh-134584: Eliminate redundant refcounting from "_CALL_TUPLE_1".
  Patch by Noam Cohen


API C
-----

* gh-142589: Fix "PyUnstable_Object_IsUniqueReferencedTemporary()"
  handling of tagged ints on the interpreter stack.

* gh-142571: "PyUnstable_CopyPerfMapFile()" now checks that opening
  the file succeeded before flushing.

* gh-142225: Fixed the "PyABIInfo_VAR" macro.

* gh-141049: "_PyObject_CallMethodId()", "_PyObject_GetAttrId()" and
  "_PyUnicode_FromId()" are deprecated since 3.15 and will be removed
  in 3.20. Instead, use "PyUnicode_InternFromString()" and cache the
  result in the module state, then call "PyObject_CallMethod()" or
  "PyObject_GetAttr()". Patch by Victor Stinner.

* gh-142163: Fix the "HAVE_THREAD_LOCAL" macro being defined without
  the "Py_BUILD_CORE" macro set after including "Python.h".

* gh-137422: Corrige o problema de condição de corrida com *threads
  livres* em "PyImport_AddModuleRef()". Anteriormente, era possível
  que duas chamadas à função retornassem dois objetos diferentes, dos
  quais apenas um era armazenado em "sys.modules".

* gh-141726: Add "PyDict_SetDefaultRef()" to the Stable ABI.

* gh-140042: Removed the sqlite3_shutdown call that could cause
  closing connections for sqlite when used with multiple sub
  interpreters.

* gh-141070: Add "PyUnstable_Object_Dump()" to dump an object to
  "stderr". It should only be used for debugging. Patch by Victor
  Stinner.

* gh-139165: Expose the functions "Py_SIZE()", "Py_IS_TYPE()" and
  "Py_SET_SIZE()" in the Stable ABI.


Construção
----------

* gh-131372: Add "LDVERSION" and "EXE" to the "base_interpreter" value
  of "build-details.json".

* gh-142454: When calculating the digest of the JIT stencils input,
  sort the hashed files by filenames before adding their content to
  the hasher. This ensures deterministic hash input and hence
  deterministic hash, independent on filesystem order.

* gh-131372: "build-details.py" will only be installed as part of the
  main install ("make install"). "make altinstall" will no longer
  include it.

* gh-142234: Allow "--enable-wasm-dynamic-linking" for WASI. While
  CPython doesn't directly support it so external/downstream users do
  not have to patch in support for the flag.

* gh-142050: Fixed a bug where JIT stencils produced on Windows
  contained debug data. Patch by Chris Eibl.

* gh-141808: Do not generate the jit stencils twice in case of PGO
  builds on Windows.

* gh-141926: "RUNSHARED" is no longer cleared when cross-compiling.
  Previously, "RUNSHARED" was cleared when cross-compiling, which
  breaks PGO when using "--enabled-shared" on systems where the cross-
  compiled CPython is otherwise executable (e.g., via transparent
  emulation).

* gh-141808: When running "make clean-retain-profile", keep the
  generated JIT stencils. That way, the stencils are not generated
  twice when Profile-guided optimization (PGO) is used. It also allows
  distributors to supply their own pre-built JIT stencils.

* gh-141784: Correção na construção de "_remote_debugging_module.c" em
  Linux de 32 bits. Inclusão de Python.h antes dos cabeçalhos do
  sistema para garantir que "_remote_debugging_module.c" utilize os
  mesmos tipos (ABI) que o Python. Patch por Victor Stinner.

* gh-141172: Update to WASI SDK 29.

* gh-139707: Add configure option "--with-missing-stdlib-config=FILE"
  allows which distributors to pass a JSON configuration file
  containing custom error messages for missing *standard library*
  modules.

* gh-108819: Honor "--with-platlibdir" in the pure-Python standard
  library installation path, if "PLATLIBDIR" doesn't match the value
  used in "LIBDIR".


Python 3.15.0 alpha 2
=====================

*Release date: 2025-11-18*


Windows
-------

* gh-140849: Update bundled liblzma to version 5.8.1.


Ferramentas/Demos
-----------------

* gh-141442: O ambiente de testes do iOS agora lida corretamente com
  argumentos de teste que contêm espaços.

* gh-140702: A aplicação de teste para iOS agora exporá a variável de
  ambiente "GITHUB_ACTIONS" para os aplicativos iOS que estão sendo
  testados.

* gh-139198: Remove "Tools/scripts/checkpip.py" script.

* gh-139188: Remove "Tools/tz/zdump.py" script.


Testes
------

* gh-140482: Preserva e restaura o estado de "stty echo" como parte do
  ambiente de teste.

* gh-140082: Atualiza o comando "python -m test" para definir
  "FORCE_COLOR=1" quando executado com cores ativadas, para que o
  "unittest", executado por ele com saída redirecionada, seja exibido
  em cores.

* gh-136442: Usa o código de saída "1" em vez de "5" se a
  "unittest.TestCase.setUpClass()" levantar uma exceção.


Segurança
---------

* gh-137836: Adiciona suporte ao elemento "plaintext", elementos
  RAWTEXT "xmp", "iframe", "noembed e "noframes", e elementos RAWTEXT
  "noscript" opicionais em "html.parser.HTMLParser".

* gh-136063: "email.message": ensure linear complexity for legacy HTTP
  parameters parsing. Patch by Bénédikt Tran.

* gh-136065: Corrige complexidade quadrática em
  "os.path.expandvars()".


Biblioteca
----------

* gh-141497: "ipaddress": garante que os métodos "IPv4Network.hosts()"
  e "IPv6Network.hosts()" sempre retornem um iterador.

* gh-140938: As funções "statistics.stdev()" e "statistics.pstdev()"
  agora levantam "ValueError" quando a entrada contém um infinito ou
  um NaN.

* gh-124111: Atualizada a configuração de threads do Tcl em "_tkinter"
  para presumir que threads estão sempre disponíveis no Tcl 9 e
  versões posteriores.

* gh-137109: O "os.fork" e as APIs de fork relacionadas não emitirão
  mais avisos no caso comum em que as APIs da plataforma Linux ou
  macOS retornam o número de threads em um processo e encontram a
  resposta como 1, mesmo quando um função de retorno
  "os.register_at_fork()" "after_in_parent=" (re)inicia uma thread.

* gh-141314: Corrigido o erro de asserção em "io.TextIOWrapper.tell()"
  ao ler arquivos com quebras de linha de retorno de carro isoladas
  ("\r").

* gh-141311: Corrigido o erro de asserção em "io.BytesIO.readinto()" e
  o comportamento indefinido que ocorria quando a posição de leitura
  estava acima da capacidade em "io.BytesIO".

* gh-87710: "mimetypes": Update mime type for ".ai" files to
  "application/pdf".

* gh-85524: Update "io.FileIO.readall", an implementation of
  "io.RawIOBase.readall()", to follow "io.IOBase" guidelines and raise
  "io.UnsupportedOperation" when a file is in "w" mode rather than
  "OSError"

* gh-141141: Corrige um problema de segurança de threads com
  "base64.b85decode()". Contribuição de Benel Tayar.

* gh-141018: "mimetypes": Update ".exe", ".dll", ".rtf" and (when
  "strict=False") ".jpg" to their correct IANA mime type.

* gh-137969: Corrigido o método "annotationlib.ForwardRef.evaluate()"
  que retorna objetos "ForwardRef" que não são atualizados com novas
  variáveis globais.

* gh-75593: Add support of *path-like objects* and *bytes-like
  objects* in "wave.open()".

* gh-140797: A classe não documentada "re.Scanner" agora proíbe
  expressões regulares que contenham grupos de captura em seus padrões
  de léxico. Padrões que utilizavam grupos de captura podiam
  anteriormente causar falhas de segmentação. Em vez disso, utilize
  grupos sem captura (?:...).

* gh-125115: Refatora a correção do problema de análise sintática do
  "pdb" para que os argumentos posicionais possam ser passados de
  forma intuitiva.

* gh-140815: "faulthandler" agora detecta se um quadro ou um objeto
  código é inválido ou foi liberado. Patch por Victor Stinner.

* gh-100218: Define corretamente "errno" quando as
  "socket.if_nametoindex()" ou "socket.if_indextoname()" levantam
  "OSError". Patch por Bénédikt Tran.

* gh-140734: "multiprocessing": Corrige erro de diferença de um bit ao
  verificar o comprimento do caminho de um arquivo de socket
  temporário. Patch por Bénédikt Tran.

* gh-140873: Add support of non-*descriptor* callables in
  "functools.singledispatchmethod()".

* gh-140874: Atualiza a versão do pip incluída no ensurepip para a
  versão 25.3.

* gh-140826: Now "winreg.HKEYType" objects are compared by their
  underlying Windows registry handle value instead of their object
  identity.

* gh-140808: The internal class "mailbox._ProxyFile" is no longer a
  parameterized generic.

* gh-140691: Em "urllib.request", quando a abertura de um URL FTP
  falha porque não é possível estabelecer uma conexão de dados, o
  socket da conexão de controle é agora fechado para evitar um
  "ResourceWarning".

* gh-103847: Corrigido o travamento que ocorria ao cancelar um
  processo criado por "asyncio.create_subprocess_exec()" ou
  "asyncio.create_subprocess_shell()". Patch por Kumar Aditya.

* gh-137821: Convert "_json" module to use Argument Clinic. Patched by
  Yoonho Hann.

* gh-140790: Initialize all Pdb's instance variables in "__init__",
  remove some hasattr/getattr

* gh-140766: Add "enum.show_flag_values()" and "enum.bin" to
  "enum.__all__".

* gh-120057: Adiciona "os.reload_environ()" para "os.__all__".

* gh-140741: Fix "profiling.sampling.sample()" incorrectly handling a
  "FileNotFoundError" or "PermissionError".

* gh-140228: Evita fazer chamadas desnecessárias ao sistema de
  arquivos para módulos congelados em "linecache" quando o cache de
  módulos global não estiver presente.

* gh-139946: Error and warning keywords in "argparse.ArgumentParser"
  messages are now colorized when color output is enabled, fixing a
  visual inconsistency in which they remained plain text while other
  output was colorized.

* gh-140590: Correção na verificação de argumentos para o método
  "functools.partial.__setstate__()", que pode levar à corrupção do
  estado interno e ao travamento do sistema. Patch por Sergey
  Miryanov.

* gh-125434: Exibe o nome da thread em "faulthandler" no Windows.
  Patch por Victor Stinner.

* gh-140634: Corrige um bug de contagem de referências em
  "os.sched_param.__reduce__()".

* gh-140650: Fix an issue where closing "io.BufferedWriter" could
  crash if the closed attribute raised an exception on access or could
  not be converted to a boolean.

* gh-140633: Ignora "AttributeError" ao definir o atributo "__file__"
  de um módulo ao carregar um módulo de extensão empacotado como Apple
  Framework.

* gh-140601: "xml.etree.ElementTree.iterparse()" now emits a
  "ResourceWarning" when the iterator is not explicitly closed and was
  opened with a filename. This helps developers identify and fix
  resource leaks. Patch by Osama Abdelkader.

* gh-140593: "xml.parsers.expat": Corrige um vazamento de memória que
  poderia afetar usuários com "ElementDeclHandler()" definido como um
  manipulador de declaração de elemento personalizado. Patch por
  Sebastian Pipping.

* gh-140607: Dentro de "io.RawIOBase.read()", verifica se a contagem
  de bytes retornada por "io.RawIOBase.readinto()" é válida (dentro do
  buffer fornecido).

* gh-138162: Corrige "logging.LoggerAdapter" com "merge_extra=True" e
  sem o argumento *extra*.

* gh-140481: Improve error message when trying to iterate a Tk widget,
  image or font.

* gh-138774: "ast.unparse()" agora gera código-fonte completo ao
  manipular nós "ast.Interpolation" que não têm uma fonte
  especificada.

* gh-140474: Corrige vazamento de memória em "array.array" ao criar
  vetores a partir de um objeto "str" vazio e do código do tipo "u".

* gh-140448: Change the default of "suggest_on_error" to "True" in
  "argparse.ArgumentParser".

* gh-137530: "dataclasses": Corrige as anotações dos métodos
  "__init__" gerados, substituindo as anotações que estavam embutidas
  no código-fonte gerado por funções "__annotate__" anexadas aos
  métodos.

* gh-140348: Corrige uma regressão no Python 3.14.0 em que o uso do
  operador "|" em um objeto "typing.Union" combinado com um objeto que
  não é um tipo levantava um erro.

* gh-76007: "decimal": Deprecate "__version__" and replace with
  "decimal.SPEC_VERSION".

* gh-76007: Deprecate "__version__" from "imaplib". Patch by Hugo van
  Kemenade.

* gh-140272: Corrige vazamento de memória no método "clear()" do banco
  de dados "dbm.gnu".

* gh-129117: "unicodedata": Add "isxidstart()" and "isxidcontinue()"
  functions to check whether a character can start or continue a
  Unicode Standard Annex #31 identifier.

* gh-140251: Colorize the default import statement "import asyncio" in
  asyncio REPL.

* gh-140212: Calendar's HTML formatting now accepts year and month as
  options. Previously, running "python -m calendar -t html 2025 10"
  would result in an error message. It now generates an HTML document
  displaying the calendar for the specified month. Contributed by Pål
  Grønås Drange.

* gh-135801: Improve filtering by module in "warnings.warn_explicit()"
  if no *module* argument is passed. It now tests the module regular
  expression in the warnings filter not only against the filename with
  ".py" stripped, but also against module names constructed starting
  from different parent directories of the filename (with
  "/__init__.py", ".py" and, on Windows, ".pyw" stripped).

* gh-139707: Improve "ModuleNotFoundError" error message when a
  *standard library* module is missing.

* gh-140041: Corrige importação de "ctypes" no Android e Cygwin quando
  sinalizadores ABI estiverem presentes.

* gh-140120: Corrigido um vazamento de memória em "hmac" ao usar o
  backend hacl-star. Descoberto por "@ashm-dev" usando
  AddressSanitizer.

* gh-140141: The "importlib.metadata.PackageNotFoundError" traceback
  raised when "importlib.metadata.Distribution.from_name" cannot
  discover a distribution no longer includes a transient
  "StopIteration" exception trace.

  Contributed by Bartosz Sławecki in gh-140142.

* gh-140166: "mimetypes": Per the IANA assignment, update the MIME
  type for the ".texi" and ".texinfo" file formats to
  "application/texinfo", instead of "application/x-texinfo".

* gh-140135: Speed up "io.RawIOBase.readall()" by using PyBytesWriter
  API (about 4x faster)

* gh-76007: "zlib": Deprecate "__version__" and schedule for removal
  in Python 3.20.

* gh-136702: "encodings": Deprecate passing a non-ascii *encoding*
  name to "encodings.normalize_encoding()" and schedule removal of
  support for Python 3.17.

* gh-139940: Print clearer error message when using "pdb" to attach to
  a non-existing process.

* gh-139462: When a child process in a
  "concurrent.futures.ProcessPoolExecutor" terminates abruptly, the
  resulting traceback will now tell you the PID and exit code of the
  terminated process. Contributed by Jonathan Berg.

* gh-63161: Corrige "tokenize.detect_encoding()". Suporte a shebang e
  comentários não UTF-8 se a codificação não UTF-8 for especificada.
  Detecta erro de decodificação para codificação não UTF-8. Detecta
  bytes nulos no código-fonte.

* gh-101828: Corrige os codecs "'shift_jisx0213'", "'shift_jis_2004'",
  "'euc_jisx0213'" e "'euc_jis_2004'" que truncavam caracteres nulos,
  pois eram tratados como parte de sequências de múltiplos caracteres.

* gh-139246: correção: colar texto com largura zero na largura padrão
  do REPL está incorreto.

* gh-83714: Implement "os.statx()" on Linux kernel versions 4.11 and
  later with glibc versions 2.28 and later.  Contributed by Jeffrey
  Bosboom and Victor Stinner.

* gh-138891: Corrige "SyntaxError" quando "inspect.get_annotations(f,
  eval_str=True)" for chamado em uma função anotada com
  "star_expression" da **PEP 646**

* gh-138859: Corrige a parametrização de tipo genérico levantando
  "TypeError" ao omitir uma "ParamSpec" que tem um padrão que não é
  uma lista de tipos.

* gh-138764: Impede que "annotationlib.call_annotate_function()" chame
  funções "__annotate__" que não ofereçam suporte a
  "VALUE_WITH_FAKE_GLOBALS" em um espaço de nomes globals falso com
  globais vazios.

  Faz com que as anotações "FORWARDREF" e "STRING" voltem a usar
  anotações "VALUE" no caso de nem seu próprio formato nem
  "VALUE_WITH_FAKE_GLOBALS" serem suportados.

* gh-138775: O uso de "python -m" com "base64" foi corrigido para
  detectar a entrada de um terminal, de forma que reconheça
  corretamente o EOF (fim de arquivo).

* gh-98896: Corrige um erro em resource_tracker do módulo
  multiprocessing quando os nomes de SharedMemory contêm dois pontos.
  Patch por Rani Pinchuk.

* gh-138425: Corrige avaliação parcial de objetos
  "annotationlib.ForwardRef" que dependem de nomes definidos como
  globais.

* gh-138151: Em "annotationlib", aprimora-se a avaliação de
  referências futuras a variáveis não locais que ainda não estão
  definidas quando as anotações são avaliadas inicialmente.

* gh-69528: The "mode" attribute of files opened in the "'wb+'" mode
  is now "'wb+'" instead of "'rb+'".

* gh-137627: Speed up "csv.Sniffer.sniff()" delimiter detection by up
  to 1.6x.

* gh-55531: "encodings": Improve "normalize_encoding()" performance by
  implementing the function in C using the private
  "_Py_normalize_encoding" which has been modified to make lowercase
  conversion optional.

* gh-136057: Corrigido o bug em "pdb" e "bdb" onde "next" e "step" não
  conseguiam ultrapassar a linha se existisse um laço na linha.

* gh-133390: Support table, index, trigger, view, column, function,
  and schema completion for "sqlite3"'s command-line interface.

* gh-135307: "email": Corrige a exceção em "set_content()" ao
  codificar texto quando max_line_length está definido como "0" ou
  "None" (ilimitado).

* gh-133789: Corrige a desserialização com pickle de objetos "pathlib"
  que foram serializados com pickle no Python 3.13.

* gh-133601: Remove deprecated "typing.no_type_check_decorator()".

* gh-132686: Add parameters *inherit_class_doc* and
  *fallback_to_class_doc* for "inspect.getdoc()".

* gh-131116: "inspect.getdoc()" now correctly returns an inherited
  docstring on "cached_property" objects if none is given in a
  subclass.

* gh-130693: Add support for "-nolinestop", and "-strictlimits"
  options to "tkinter.Text.search()". Also add the
  "tkinter.Text.search_all()" method for "-all" and "-overlap"
  options.

* gh-122255: In the "linecache" module and in the Python
  implementation of the "warnings" module, a "DeprecationWarning" is
  issued when "mod.__loader__" differs from "mod.__spec__.loader"
  (like in the C implementation of the "warnings" module).

* gh-121011: "math.log()" now supports arbitrary large integer-like
  arguments in the same way as arbitrary large integer arguments.

* gh-119668: Publicly expose and document
  "importlib.machinery.NamespacePath".

* gh-102431: Esclarece restrições para argumentos "lógicos" em métodos
  de "decimal.Context".

* gh-81313: Add the "math.integer" module (**PEP 791**).


Núcleo e embutidos
------------------

* gh-141579: Corrigido o problema na função
  "sys.activate_stack_trampoline()" para que ela ofereça suporte
  correto ao backend "perf_jit". Patch por Pablo Galindo.

* gh-114203: Ignora a trava se o objeto já estiver travado por uma
  seção crítica de dois mutexes.

* gh-141528: Sugere o uso de
  "concurrent.interpreters.Interpreter.close()" em vez da função
  privada "_interpreters.destroy" ao emitir avisos sobre
  subinterpretadores restantes. Patch por Sergey Miryanov.

* gh-141367: Specialize "CALL_LIST_APPEND" instruction only for lists,
  not for list subclasses, to avoid unnecessary deopt. Patch by
  Mikhail Efimov.

* gh-141312: Corrige a falha de asserção no método "__setstate__" do
  iterador de intervalo quando um argumento não inteiro é passado.
  Patch por Sergey Miryanov.

* gh-140643: Add support for "<GC>" and "<native>" frames to
  "profiling.sampling" output to denote active garbage collection and
  calls to native code.


Biblioteca
----------

* gh-140942: Add ".cjs" to "mimetypes" to give CommonJS modules a MIME
  type of "application/node".


Núcleo e embutidos
------------------

* gh-140479: Update JIT compilation to use LLVM 21 at build time.

* gh-140939: Corrige vazamento de memória quando "bytearray" ou
  "bytes" é formatado com o formato "%*b" com uma largura grande que
  resulta em uma "MemoryError".


Biblioteca
----------

* gh-140260: Correção de condição de corrida de dados em "struct" na
  inicialização de tabelas endian com subinterpretadores. Patch por
  Shamil Abdulaev.


Núcleo e embutidos
------------------

* gh-140530: Corrige um vazamento de referência que ocorria quando
  "raise exc from cause" falhava. Patch por Bénédikt Tran.


Biblioteca
----------

* gh-90344: Replace "io.IncrementalNewlineDecoder" with non
  incremental newline decoders in codebase where
  "io.IncrementalNewlineDecoder.decode()" was being called once.


Núcleo e embutidos
------------------

* gh-140373: Correctly emit "PY_UNWIND" event when generator object is
  closed. Patch by Mikhail Efimov.

* gh-140729: Fix pickling error in the sampling profiler when using
  "concurrent.futures.ProcessPoolExecutor" script can not be properly
  pickled and executed in worker processes.

* gh-131527: Dynamic borrow checking for stackrefs is added to
  "Py_STACKREF_DEBUG" mode. Patch by Mikhail Efimov.

* gh-140576: Corrigido o erro que causava o fechamento inesperado do
  código em "tokenize.generate_tokens()" em caso de entrada incorreta
  específica. Patch por Mikhail Efimov.

* gh-140544: Speed up accessing interpreter state by caching it in a
  thread local variable. Patch by Kumar Aditya.

* gh-140551: Corrigido o problema que causava o fechamento inesperado
  do arquivo "dict" se o método "dict.clear()" fosse chamado na fase
  de busca. Patch por Mikhail Efimov e Inada Naoki.

* gh-140517: Corrigido um vazamento de referência ao iterar sobre o
  resultado de "map()" com "strict=True" quando os iteráveis de
  entrada tinham comprimentos diferentes. Patch por Mikhail Efimov.

* gh-133467: Fix race when updating "type.__bases__" that could allow
  a read of "type.__base__" to observe an inconsistent value on the
  free threaded build.

* gh-140471: Corrige possível estouro de buffer na inicialização do nó
  "ast.AST" ao encontrar "_fields" malformados contendo não-"str".


Biblioteca
----------

* gh-140443: The logarithm functions (such as "math.log10()" and
  "math.log()") may now produce slightly different results for
  extremely large integers that cannot be converted to floats without
  overflow. These results are generally more accurate, with reduced
  worst-case error and a tighter overall error distribution.


Núcleo e embutidos
------------------

* gh-140431: Corrige uma falha no *coletor de lixo* do Python devido a
  objetos *corrotina* parcialmente inicializados quando a profundidade
  do rastreamento da origem da corrotina está habilitada
  ("sys.set_coroutine_origin_tracking_depth()").

* gh-140476: Optimize "PySet_Add()" for "frozenset" in *free threaded*
  build.

* gh-135904: Add special labels to the assembly created during stencil
  creation to support relocations that the native object file format
  does not support. Specifically, 19 bit branches for AArch64 in
  Mach-O object files.


Biblioteca
----------

* gh-140398: Corrige vazamento de memória nas funções
  "read_init_file()", "read_history_file()", "write_history_file()" e
  "append_history_file()" do módulo "readline" quando "PySys_Audit()"
  falha.


Núcleo e embutidos
------------------

* gh-140406: Corrige vazamento de memória quando o método "__hash__()"
  de um objeto retorna um objeto que não é um "int".

* gh-140358: Restaura o tempo decorrido e a contagem de objetos
  inacessíveis na saída de depuração do GC. Esses dados foram
  removidos inadvertidamente durante uma refatoração de "gc.c". O log
  de depuração agora relata novamente o tempo de coleta decorrido e o
  número de objetos inacessíveis. Contribuição de Pål Grønås Drange.

* gh-136895: Update JIT compilation to use LLVM 20 at build time.

* gh-139109: A new tracing frontend for the JIT compiler has been
  implemented. Patch by Ken Jin. Design for CPython by Ken Jin, Mark
  Shannon and Brandt Bucher.

* gh-140306: Corrige vazamentos de memória em operações de canal entre
  interpretadores e manipulação de espaço de nomes compartilhado.

* gh-116738: Make _suggestions module thread-safe on the *free
  threaded* build.

* gh-140301: Corrige vazamento de memória de "PyConfig" em
  subinterpretadores.

* gh-140257: Corrige corrida de dados entre interpreter_clear() e
  take_gil() em eval_breaker durante a finalização com threads daemon.

* gh-139951: Corrige uma regressão no desempenho do GC para um heap
  crescente composto principalmente de pequenas tuplas.

  * Conta o número de objetos realmente rastreados, em vez de objetos
    rastreáveis. Isso garante que o cancelamento do rastreamento de
    tuplas tenha o efeito desejado de reduzir a sobrecarga do coletor
    de lixo.

  * Não rastreia a maioria das tuplas não rastreáveis durante a
    criação. Isso evita que um grande número de tuplas pequenas causem
    GCs excessivos.

* gh-140253: Wrong placement of a double-star pattern inside a mapping
  pattern now throws a specialized syntax error. Contributed by
  Bartosz Sławecki in gh-140253.

* gh-140104: Correção de um bug no tratamento de exceções no JIT.
  Patch por Ken Jin. Bug relatado por Daniel Diniz.

* gh-140149: Speed up parsing bytes literals concatenation by using
  PyBytesWriter API and a single memory allocation (about 3x faster).

* gh-140061: Correção da verificação de se um objeto é referenciado
  exclusivamente para garantir compatibilidade com threads livres.
  Patch por Sergey Miryanov.

* gh-140080: Fix hang during finalization when attempting to call
  "atexit" handlers under no memory.

* gh-139871: Update "bytearray" to use a "bytes" under the hood as its
  buffer and add "bytearray.take_bytes()" to take it out.

* gh-140067: Corrige vazamento de memória na criação de
  subinterpretadores.

* gh-139914: Restaura o suporte para HP PA-RISC, que possui uma pilha
  crescente.

* gh-139817: Attribute "__qualname__" is added to
  "typing.TypeAliasType". Patch by Mikhail Efimov.

* gh-135801: Many functions related to compiling or parsing Python
  code, such as "compile()", "ast.parse()", "symtable.symtable()", and
  "importlib.abc.InspectLoader.source_to_code()" now allow to specify
  the module name. It is needed to unambiguous filter syntax warnings
  by module name.

* gh-139640: "ast.parse()" não emite mais avisos de sintaxe para
  "return"/"break"/"continue" em "finally" (veja **PEP 765**) -- eles
  são emitidos apenas durante a compilação.

* gh-139640: Corrige a ingestão de alguns avisos de sintaxe em módulos
  diferentes caso eles acidentalmente tenham a mesma mensagem e sejam
  emitidos na mesma linha. Corrige avisos duplicados no bloco
  "finally".

* gh-139475: Changes in stackref debugging mode when
  "Py_STACKREF_DEBUG" is set. We use the same pattern of refcounting
  for stackrefs as in production build.

* gh-139269: Fix undefined behavior when using unaligned store in
  JIT's "patch_*" functions.

* gh-138944: Corrige a mensagem "SyntaxError" que ocorre quando uma
  sintaxe inválida aparece na mesma linha que uma instrução "import
  ... as ..." ou "from ... import ... as ..." válida. Patch por Brian
  Schubert.

* gh-138857: Improve "SyntaxError" message for "case" keyword placed
  outside "match" body.

* gh-131253: Support the "--enable-pystats" build option for the free-
  threaded build.

* gh-136327: Errors when calling functions with invalid values after
  "*" and "**" now do not include the function name. Patch by Ilia
  Solin.

* gh-134786: If "Py_TPFLAGS_MANAGED_DICT" and
  "Py_TPFLAGS_MANAGED_WEAKREF" are used, then "Py_TPFLAGS_HAVE_GC"
  must be used as well.


API C
-----

* gh-141341: On Windows, rename the "COMPILER" macro to "_Py_COMPILER"
  to avoid name conflicts. Patch by Victor Stinner.

* gh-116146: Add a new "PyImport_CreateModuleFromInitfunc()" C-API for
  creating a module from a *spec* and *initfunc*. Patch by Itamar
  Oren.

* gh-141042: Faz qNaN em "PyFloat_Pack2()" e "PyFloat_Pack4()", se
  durante a conversão para um formato de ponto flutuante de menor
  precisão --- o valor restante após o truncamento for zero. Patch por
  Sergey B Kirpichev.

* gh-141004: "Py_MATH_El" and "Py_MATH_PIl" are deprecated.

* gh-141004: The "Py_INFINITY" macro is *soft deprecated*.

* gh-140556: **PEP 793**: Add a new entry point for C extension
  modules, "PyModExport_<modulename>".

* gh-140487: Corrige "Py_RETURN_NOTIMPLEMENTED" na API C limitada 3.11
  e anteriores: não trata "Py_NotImplemented" como imortal. Patch por
  Victor Stinner.

* gh-140153: Correção da definição "Py_REFCNT()" na API C limitada
  3.11-3.13. Patch por Victor Stinner.

* gh-139653: Adicionadas as funções
  "PyUnstable_ThreadState_SetStackProtection()" e
  "PyUnstable_ThreadState_ResetStackProtection()" para definir o
  endereço base e o tamanho da proteção de pilha de um estado de
  thread Python. Patch por Victor Stinner.


Construção
----------

* gh-140454: When building the JIT, match the jit_stencils filename
  expectations in Makefile with the generator script. This avoid
  needless JIT recompilation during "make install".

* gh-140768: Avisa quando a versão do SDK do WASI não corresponder à
  versão suportada.

* gh-140513: Gera um erro de compilação claro quando
  "_Py_TAIL_CALL_INTERP" estiver habilitado, mas "preserve_none" ou
  "musttail" não forem suportados.

* gh-140475: Support WASI SDK 25.

* gh-140239: Check "statx" availability only on Linux (including
  Android).

* gh-140189: As versões para iOS foram adicionadas à integração
  contínua.

* gh-137618: "PYTHON_FOR_REGEN" agora requer Python 3.10 a Python
  3.15. Patch por Adam Turner.


Python 3.15.0 alpha 1
=====================

*Release date: 2025-10-14*


macOS
-----

* gh-115119: Update macOS installer to use libmpdecimal 4.0.1.

* gh-124111: Update macOS installer to use Tcl/Tk 9.0.2.

* gh-132339: Update macOS installer version of OpenSSL to 3.5.4.

* gh-137450: macOS instalador console melhorias no gerenciamento de
  caminhos: separe o script pós-instalação do instalador "console
  profile updater" do "Update console Profile.comando" para permitir
  um manuseio mais robusto do erro.

* gh-137134: Atualização do instalador do macOS para ser fornecido com
  o SQLite versão 3.50.4.


Windows
-------

* gh-139810: A instalação com "py install 3[.x]-dev" agora selecionará
  versões finais e também pré-lançamentos.

* gh-139573: Atualizada a versão empacotada do OpenSSL para 3.0.18.

* gh-138896: Corrige erro ao instalar o runtime do C em máquinas
  Windows não atualizadas

* gh-138314: Add "winreg.DeleteTree()".

* gh-137136: Suppress build warnings when build on Windows with "--
  experimental-jit-interpreter".

* gh-137134: Atualizar o instalador do Windows para que seja fornecido
  com o SQLite 3.50.4.

* gh-135099: Corrige uma falha que poderia ocorrer no Windows quando
  uma thread em segundo plano aguarda um "PyMutex" enquanto o thread
  principal está desligando o interpretador.

* gh-130727: Corrige uma corrida em chamadas internas para o WMI que
  pode resultar em uma exceção de "identificador inválido" sob carga
  alta. Patch por Chris Eibl.

* gh-76023: Faz com que "os.path.realpath()" ignore o erro 1005 do
  Windows quando estiver no modo não estrito.

* gh-133779: Reverte a alteração para gerar arquivos "pyconfig.h"
  diferentes com base nas configurações do compilador, pois isso
  frequentemente causava falhas nas construções de extensões. Em
  particular, a variável de pré-processador "Py_GIL_DISABLED" agora
  deve ser sempre definida explicitamente ao compilar para o tempo de
  execução experimental de threads livres. A função
  "sysconfig.get_config_var()" pode ser usada para determinar se o
  tempo de execução atual foi compilado com esse sinalizador ou não.

* gh-133626: Garante que os pacotes não sejam acidentalmente agrupados
  no instalador tradicional.

* gh-133580: Fix "sys.getwindowsversion()" failing without setting an
  exception when called on some WinAPI partitions.

* gh-133572: Avoid LsaNtStatus to WinError conversion on unsupported
  WinAPI partitions.

* gh-133568: Fix compile error when using a WinAPI partition that
  doesn't support the RPC runtime library.

* gh-133562: Disable handling of security descriptors by "os.mkdir()"
  with mode "0o700" on WinAPI partitions that do not support it. This
  only affects custom builds for specialized targets.

* gh-133537: Avoid using console I/O in WinAPI partitions that don’t
  support it

* gh-131942: Use the Python-specific "Py_DEBUG" macro rather than
  "_DEBUG" in Windows-related C code. Patch by Xuehai Pan.


Ferramentas/Demos
-----------------

* gh-139330: A ferramenta de geração de SBOM não verificava os valores
  de versão e checksum em relação ao script
  "Modules/expat/refresh.sh", o que levava a que os valores ficassem
  desatualizados durante atualizações de rotina.

* gh-132006: XCframeworks agora incluem manifestos de privacidade para
  atender aos requisitos de envio da Apple App Store.

* gh-138171: Foi adicionado um script para a construção de um
  framework iOS XC. Como parte dessa alteração, a pasta de nível
  superior "iOS" foi movida para um subdiretório da pasta "Apple".

* gh-137873: O executor de testes iOS foi simplificado, resolvendo
  alguns problemas que foram observados ao usar o executor nos
  ambientes de teste do GitHub Actions e do Azure Pipelines.

* gh-137484: Coloca o "Tools/wasm/wasi" no Python de construção em um
  diretório com o nome do triplo de construção em vez de "build".

* gh-137025: The "wasm_build.py" script has been removed.
  "Tools/wasm/emscripten" and "Tools/wasm/wasi" should be used
  instead, as described in the Dev Guide.

* gh-137248: Adiciona uma opção "--logdir" em "Tools/wasm/wasi" para
  especificar onde gravar os arquivos de log.

* gh-137243: Faz com que o Tools/wasm/wasi detecte uma instalação do
  WASI SDK em /opt quando ele foi extraído diretamente de um tarball
  de lançamento.

* gh-136251: Correções e melhorias de usabilidade para
  "Tools/wasm/emscripten/web_example"

* gh-135968: Os stubs para "strip" agora são fornecidos como parte de
  uma instalação do iOS.

* gh-135379: The cases generator no longer accepts type annotations on
  stack items. Conversions to non-default types are now done
  explicitly in bytecodes.c and optimizer_bytecodes.c. This will
  simplify code generation for top-of-stack caching and other future
  features.

* gh-134215: Autopreenchimento de importação do *REPL* sugere apenas
  módulos privados quando explicitamente especificado.


Testes
------

* gh-139208: Corrige o regrtest "--fast-ci --verbose": não ignora mais
  a opção "--verbose". Patch por Victor Stinner.

* gh-138313: Restore skipped test and add janky workaround to prevent
  select buildbots from failing with a ResourceWarning.

* gh-135966: O ambiente de teste do iOS agora manipula a pasta
  "app_packages" como um diretório de site.

* gh-135494: Corrige o regrtest para suportar a exclusão de testes de
  "--pgo". Patch por Victor Stinner.

* gh-132815: Corrige test__opcode: adiciona "JUMP_BACKWARD" às
  estatísticas de especialização.

* gh-135489: Exibe saída detalhada para testes com falha durante a
  etapa de criação de perfil do PGO com --enable-optimizations.

* gh-135401: Add a new GitHub CI job to test the "ssl" module with
  AWS-LC as the backing cryptography and TLS library.

* gh-135120: Adiciona "test.support.subTests()".

* gh-134567: Expose log formatter to users in TestCase.assertLogs.
  "unittest.TestCase.assertLogs()" will now optionally accept a
  formatter that will be used to format the strings in output if
  provided.

* gh-133744: Corrigido o teste de interrupção de multiprocessamento.
  Adicionado um evento para sincronizar o processo pai com o processo
  filho: aguardar até que o processo filho comece a hibernar. Patch
  por Victor Stinner.

* gh-133682: Corrigido caso de teste
  "test.test_annotationlib.TestStringFormat.test_displays" que garante
  o tratamento adequado de estruturas de dados complexas (listas,
  conjuntos, dicionários e tuplas) em anotações de string.

* gh-133639: Corrige "TestPyReplAutoindent.test_auto_indent_default()"
  não executar "input_code".


Segurança
---------

* gh-139700: Verifica a consistência do registro zip64 no final do
  diretório central. Suporte a registros com "dados extensíveis zip64"
  se não houver bytes anexados ao arquivo ZIP.

* gh-139400: "xml.parsers.expat": Garante que os analisadores Expat
  pais sejam coletados como lixo somente quando não forem mais
  referenciados por subanalisadores criados por
  "ExternalEntityParserCreate()". Patch por Sebastian Pipping.

* gh-139283: "sqlite3": manipula corretamente o número máximo de
  linhas a serem buscadas em "Cursor.fetchmany" e rejeita valores
  negativos para "Cursor.arraysize". Patch por Bénédikt Tran.

* gh-136053: "marshal": corrige uma possível falha ao desserializar
  objetos "slice".

* gh-135661: Corrige a análise das tags de início e fim em
  "html.parser.HTMLParser" de acordo com o padrão HTML5.

  * Espaços em branco não são mais aceitos entre "</" e o nome da tag.
    Por exemplo, "</ script>" não encerra a seção de script.

  * Tabulação vertical ("\v") e espaços em branco não ASCII não são
    mais reconhecidos como espaços em branco. Os únicos espaços em
    branco são "\t\n\r\f" e espaço.

  * O caractere nulo (U+0000) não termina mais o nome da tag.

  * Atributos e barras após o nome da tag em tags finais agora são
    ignorados, em vez de terminar após o primeiro ">" no valor do
    atributo entre aspas. Por exemplo, "</script/foo=">"/>".

  * Barras múltiplas e espaços em branco entre o último atributo e o
    ">" de fechamento agora são ignorados nas tags de início e fim.
    Por exemplo, "<a foo=bar/ //>".

  * Múltiplos "=" entre o nome do atributo e o valor não são mais
    recolhidos. Por exemplo, "<a foo==bar>" produz o atributo "foo"
    com o valor "=bar".

* gh-135661: Corrige a análise da seção CDATA em
  "html.parser.HTMLParser" de acordo com o padrão HTML5: "] ]>" e "]]
  >" não encerram mais a seção CDATA. Adiciona o método privado
  "_set_support_cdata()", que pode ser usado para especificar como
  analisar "<[CDATA[" --- como uma seção CDATA em conteúdo externo
  (SVG ou MathML) ou como um comentário falso no espaço de nomes HTML.

* gh-102555: Corrige a análise de comentários em
  "html.parser.HTMLParser" de acordo com o padrão HTML5. "--!>" agora
  encerra o comentário. "-- >" não encerra mais o comentário. Suporte
  a comentários vazios "<-->" e "<--->" que encerravam anormalmente.

* gh-135462: Corrigida a complexidade quadrática no processamento de
  entradas especialmente criadas em "html.parser.HTMLParser". Erros de
  fim de arquivo agora são tratados de acordo com as especificações do
  HTML5 -- comentários e declarações são fechados automaticamente,
  tags são ignoradas.

* gh-118350: Corrige suporte ao modo de texto bruto escapável
  (elementos "textarea" e "title") em "html.parser.HTMLParser".

* gh-135034: Corrige vários problemas que permitiam que os filtros de
  extração "tarfile" ("filter="data"" e "filter="tar"") fossem
  ignorados usando links simbólicos e links físicos criados.

  Endereços **CVE 2024-12718**, **CVE 2025-4138**, **CVE 2025-4330** e
  **CVE 2025-4517**.

* gh-133767: Corrige uso após liberação no decodificador "unicode-
  escape" com um tratador de erros não "estrito".

* gh-133623: Indicate through "ssl.HAS_PSK_TLS13" whether the "ssl"
  module supports "External PSKs" in TLSv1.3, as described in RFC
  9258. Patch by Will Childs-Klein.

* gh-128840: Faz um curto-circuito no processamento de endereços IPv6
  longos no início de "ipaddress" para evitar consumo excessivo de
  memória e uma pequena negação de serviço.


Biblioteca
----------

* gh-139482: Optimize "os.environ.clear()" by calling *clearenv(3)*
  when this function is available. Patch by Victor Stinner.

* gh-139958: The "application/toml" mime type is now supported by
  "mimetypes". Patch by Gil Forcada.

* gh-139823: "ensurepip" now fails with a nicer error message when the
  "zlib" module is not available.

* gh-139905: Adiciona sugestão à mensagem de erro para subclasses
  "typing.Generic" quando "cls.__parameters__" estiver ausente devido
  a uma classe pai falhar ao chamar "super().__init_subclass__()" em
  sua "__init_subclass__".

* gh-139894: Corrige compartilhamento incorreto da tarefa atual com o
  processo filho durante o fork em "asyncio". Patch por Kumar Aditya.

* gh-139845: Correção para não exibir KeyboardInterrupt duas vezes no
  REPL padrão de asyncio.

* gh-139783: Corrige "inspect.getsourcelines()" para o caso em que um
  decorador é seguido por um comentário ou uma linha vazia.

* gh-139809: Evita a colorização prematura do subanalisador "prog" em
  "argparse.ArgumentParser.add_subparsers()" para respeitar as
  alterações da variável de ambiente de cor após a criação do
  analisador.

* gh-139736: Corrige recuo excessivo no "argparse" padrão
  "HelpFormatter". Patch por Alexander Edland.

* gh-70765: "http.server": corrige o tratamento padrão de requisições
  HTTP/0.9 em "BaseHTTPRequestHandler". Anteriormente,
  "BaseHTTPRequestHandler.parse_request()" aguardava incorretamente
  por cabeçalhos na requisição, embora estes não sejam suportados em
  HTTP/0.9. Patch por Bénédikt Tran.

* gh-139322: Fix "os.getlogin()" error handling: fix the error number.
  Patch by Victor Stinner.

* gh-135953: Add a Gecko format output to the tachyon profiler via "--
  gecko".

* gh-139184: "os.forkpty()" does now make the returned file descriptor
  non-inheritable.

* gh-139391: Corrige um problema em que, em plataformas não Windows,
  não era possível sair normalmente de um processo "python -m asyncio"
  suspenso por Ctrl+Z e posteriormente retomado por *fg*, exceto com
  *kill*.

* gh-139374: "timeit": Add color to error tracebacks.

* gh-90949: Add
  "SetBillionLaughsAttackProtectionActivationThreshold()" and
  "SetBillionLaughsAttackProtectionMaximumAmplification()" to
  xmlparser objects to tune protections against billion laughs
  attacks. Patch by Bénédikt Tran.

* gh-139312: Atualiza libexpat empacotado para 2.7.3

* gh-139289: Faz uma importação preguiçosa real em "rlcompleter" em
  "pdb" e restaura o completer existente após importar "rlcompleter".

* gh-90949: Add "SetAllocTrackerActivationThreshold()" and
  "SetAllocTrackerMaximumAmplification()" to xmlparser objects to tune
  protections against disproportional amounts of dynamic memory usage
  from within an Expat parser. Patch by Bénédikt Tran.

* gh-67795: Functions that take timestamp or timeout arguments now
  accept any real numbers (such as "Decimal" and "Fraction"), not only
  integers or floats, although this does not improve precision.

* gh-95953: A CSS class, "diff_changed", was added to the changed
  lines in the "make_table" output of "difflib.HtmlDiff". Patch by
  Katie Gardner.

* gh-139210: Corrige o problema de uso após liberação ao relatar um
  evento desconhecido em "xml.etree.ElementTree.iterparse()". Patch
  por Ken Jin.

* gh-138860: Importação preguiçosa de "rlcompleter" em "pdb" para
  evitar impasse no subprocesso.

* gh-112729: Corrige falha ao chamar
  "concurrent.interpreters.create()" quando o processo está sem
  memória.

* gh-126016: Fix an assertion failure when sending "KeyboardInterrupt"
  to a Python process running a subinterpreter in a separate thread.

* gh-118803: "collections.abc.ByteString" has been removed from
  "collections.abc.__all__", and "typing.ByteString" has been removed
  from "typing.__all__". The former has been deprecated since Python
  3.12, and the latter has been deprecated since Python 3.9. Both
  classes are scheduled for removal in Python 3.17.

  Additionally, the following statements now cause
  "DeprecationWarning"s to be emitted at runtime: "from
  collections.abc import ByteString", "from typing import ByteString",
  "import collections.abc; collections.abc.ByteString" and "import
  typing; typing.ByteString". Both classes already caused
  "DeprecationWarning"s to be emitted if they were subclassed or used
  as the second argument to "isinstance()" or "issubclass()", but they
  did not previously lead to "DeprecationWarning"s if they were merely
  imported or accessed from their respective modules.

* gh-135729: Corrige exceção não levantável durante a finalização ao
  usar "concurrent.interpreters" no REPL.

* gh-139076: Corrige um bug no módulo "pydoc" que estava escondendo
  funções em um módulo Python se elas fossem implementadas em um
  módulo de extensão e o módulo não tivesse "__all__".

* gh-139090: Add "os.RWF_DONTCACHE" constant for Linux 6.14+.

* gh-139065: Corrige espaço final antes de uma palavra longa
  encapsulada se o comprimento da linha for exatamente *width* em
  "textwrap".

* gh-139001: Corrige condição de corrida em "pathlib.Path" no campo
  interno "_raw_paths".

* gh-138813: "multiprocessing.BaseProcess" define "kwargs" como "None"
  em vez de um dicionário compartilhado.

* gh-138998: Atualiza libexpat empacotado para 2.7.2

* gh-138993: Reduz indentação do texto de "credits".

* gh-118803: Adiciona novamente "collections.abc.ByteString" e
  "typing.ByteString". Ambas foram removidas nas versões alfa, beta e
  candidatos a lançamento anteriores do Python 3.14, mas sua remoção
  foi adiada para o Python 3.17.

* gh-130567: Corrige possível falha em "locale.strxfrm()" devido a um
  bug de plataforma no macOS.

* gh-137226: Corrige chamadas "typing.get_type_hints()" em classes
  genéricas "typing.TypedDict" definidas com anotações de string.

* gh-138899: Executing "quit" command in "pdb" will raise
  "bdb.BdbQuit" when "pdb" is started from an asyncio console using
  "breakpoint()" or "pdb.set_trace()".

* gh-138804: Levanta "TypeError" em vez de "AttributeError" quando um
  argumento de tipo incorreto for passado para "shlex.quote()". Isso
  restaura o comportamento da função anterior à versão 3.14.

* gh-138779: Suporte a números de dispositivos maiores que "2**63-1"
  para o campo "st_rdev" da estrutura "os.stat_result".

* gh-138682: Added symmetric difference support to
  "collections.Counter" objects.

* gh-138712: Add "os.NODEV".

* gh-128636: Corrige falha no PyREPL quando os.environ é substituído
  por um valor inválido para Mac

* gh-138720: Fix an issue where "io.BufferedWriter" and
  "io.BufferedRandom" had different definitions of "closed" for
  "close()" and "flush()" which resulted in an exception when close
  called flush but flush thought the file was already closed.

* gh-138706: Update "unicodedata" database to Unicode 17.0.0.

* gh-76007: Deprecate "__version__" from a number of standard library
  modules. Patch by Hugo van Kemenade.

* gh-138535: Speed up "os.stat()" for files with reasonable
  timestamps. Contributed by Jeffrey Bosboom.

* gh-116946: "curses.panel": the type of "curses.panel.new_panel()" is
  now immutable. Patch by Bénédikt Tran.

* gh-116946: "zlib": the types of "zlib.compressobj()" and
  "zlib.decompressobj()" are now immutable. Patch by Bénédikt Tran.

* gh-116946: "os": the "os.DirEntry" type and the type of
  "os.scandir()" are now immutable. Patch by Bénédikt Tran.

* gh-116946: "tkinter": the types "_tkinter.Tcl_Obj" (wrapper for Tcl
  objects), "_tkinter.tktimertoken" (obtained by calling
  "createtimerhandler()" on a "Tk" application) and "_tkinter.tkapp"
  (the runtime type of Tk applications) are now immutable. Patch by
  Bénédikt Tran.

* gh-138514: Levanta "ValueError" quando uma string com vários
  caracteres é passada para o parâmetro *echo_char* de
  "getpass.getpass()". Patch de Benjamin Johnson.

* gh-137706: Corrige a avaliação parcial de anotações que usam
  "typing.Annotated[T, x]" onde "T" é uma referência direta.

* gh-88375: Corrige a normalização das regras e URLs "robots.txt" no
  módulo "urllib.robotparser". Não ignora mais o "?" final. Distingue
  os caracteres especiais brutos "?", "=" e "&" dos codificados em
  porcentagem.

* gh-138515: "email" é adicionado à construção Emscripten.

* gh-99948: "ctypes.util.find_library()" agora funciona em construções
  Emscripten.

* gh-111788: Corrige erros de análise no módulo "urllib.robotparser".
  Não falhe ao tentar analisar caminhos estranhos. Não falha ao tentar
  decodificar arquivos "robots.txt" não UTF-8.

* gh-138432: "zoneinfo.reset_tzpath()" agora converterá quaisquer
  objetos "os.PathLike" recebidos em strings antes de adicioná-los a
  "TZPATH". Ele levantará "TypeError" se algo diferente de uma string
  for encontrado após essa conversão. Se for fornecido um objeto
  "os.PathLike" que represente um caminho relativo, ele levantará
  "ValueError" em vez de "TypeError" e apresentará uma mensagem de
  erro mais informativa.

* gh-132657: Improve the scaling of "copy.copy()" and
  "copy.deepcopy()" in the free-threading build.

* gh-116946: The types of "select.poll()" and "select.epoll()" objects
  are now immutable. Patch by Bénédikt Tran.

* gh-116946: The "_random.Random" C type is now immutable. Patch by
  Bénédikt Tran.

* gh-57911: When extracting tar files on Windows, slashes in symlink
  targets will be replaced by backslashes to prevent corrupted links.

* gh-138205: Removed the "resize()" method on platforms that don't
  support the underlying syscall, instead of raising a "SystemError".

* gh-138008: Corrige falhas de segmentação no módulo "ctypes" devido a
  "argtypes" inválido. Patch por Dung Nguyen.

* gh-138252: "ssl": "SSLContext" objects can now set client and server
  TLS signature algorithms. If Python has been built with OpenSSL 3.5
  or later, "SSLSocket" objects can return the signature algorithms
  selected on a connection.

* gh-138253: Adiciona o parâmetro *block* nos métodos "put()" e
  "get()" das filas "concurrent.interpreters" para compatibilidade com
  a interface "queue.Queue".

* gh-60462: Corrige "locale.strxfrm()" no Solaris (e possivelmente em
  outras plataformas).

* gh-138239: O REPL agora realça "type" como uma palavra reservada
  contextual em instruções de tipo.

* gh-78502: "mmap.mmap" now has a *trackfd* parameter on Windows; if
  it is "False", the file handle corresponding to *fileno* will not be
  duplicated.

* gh-138204: Proibe expansão de "mapas de memória" anônimos
  compartilhados no Linux, o que causou um erro de barramento.

* gh-138010: Fix an issue where defining a class with a
  "@warnings.deprecated"-decorated base class may not invoke the
  correct "__init_subclass__()" method in cases involving multiple
  inheritance. Patch by Brian Schubert.

* gh-134716: Add support of regular expressions in the "-W" option and
  the "PYTHONWARNINGS" environment variable.

* gh-138133: Evita laço infinito de traceback ao enviar CTRL^C para
  Python através de "strace".

* gh-138122: Implement **PEP 799** -- A dedicated profiling package
  for organizing Python profiling tools. Patch by Pablo Galindo.

* gh-138092: Fixed a bug in "mmap.mmap.flush()" where calling with
  only an offset parameter would fail.

* gh-138044: Remove compatibility shim for deprecated parameter
  *package* in "importlib.resources.files()". Patch by Semyon Moroz.

* gh-86819: "socket": Add missing constants for ISO-TP sockets.

* gh-137884: Add "threading.get_native_id()" support for
  Illumos/Solaris. Patch by Yüce Tekol.

* gh-134869: Correção de um problema em que pressionar Ctrl+C durante
  o preenchimento de guias no site REPL deixava o menu de
  preenchimento automático em um estado corrompido.

* gh-137840: "typing.TypedDict" now supports the "closed" and
  "extra_items" keyword arguments (as described in **PEP 728**) to
  control whether additional non-required keys are allowed and to
  specify their value type.

* gh-132947: Applied changes to "importlib.metadata" from
  importlib_metadata 8.7, including "dist" now disallowed for
  "EntryPoints.select"; deferred imports for faster import times;
  added support for metadata with newlines (python/cpython#119650);
  and "metadata()" function now returns "None" when a metadata
  directory is present but no metadata is present.

* gh-90548: Corrige a detecção de "musl" para "platform.libc_ver()" no
  Alpine Linux se compilado com --strip-all.

* gh-137317: "inspect.signature()" agora trata corretamente classes
  que usam um descritor em um método encapsulado "__init__()" ou
  "__new__()". Contribuição de Yongyu Yan.

* gh-137754: Corrige a importação do módulo "zoneinfo" se a
  implementação C do módulo "datetime" não estiver disponível.

* gh-125854: Improve error messages for invalid category in
  "warnings.warn()".

* gh-137729: "locale.setlocale()" now supports language codes with
  "@"-modifiers. "@"-modifier are no longer silently removed in
  "locale.getlocale()", but included in the language code.

* gh-73487: Speedup processing arguments (up to 1.5x) in the "decimal"
  module methods, that now using "METH_FASTCALL" calling convention.
  Patch by Sergey B Kirpichev.

* gh-137634: Calendar pages generated by the "calendar.HTMLCalendar"
  class now support dark mode and have been migrated to the HTML5
  standard for improved accessibility.

* gh-137630: The "_interpreters" module now uses Argument Clinic to
  parse arguments. Patch by Adam Turner.

* gh-137583: Fix a deadlock introduced in 3.13.6 when a call to
  "ssl.SSLSocket.recv" was blocked in one thread, and then another
  method on the object (such as "ssl.SSLSocket.send") was subsequently
  called in another thread.

* gh-92936: Update regex used by "http.cookies.SimpleCookie" to handle
  values containing double quotes.

* gh-137426: Remove a descontinuação de código de
  "importlib.abc.ResourceLoader". Ele está documentado como
  descontinuado, mas foi mantido pela retrocompatibilidade com outras
  classes em "importlib.abc".

* gh-137490: Manipula "ECANCELED" da mesma forma que "EINTR" em
  "signal.sigwaitinfo()" no NetBSD.

* gh-137512: Add new constants in the "resource" module:
  "RLIMIT_NTHR", "RLIMIT_UMTXP", "RLIMIT_PIPEBUF", "RLIMIT_THREADS",
  "RLIM_SAVED_CUR", and "RLIM_SAVED_MAX".

* gh-137044: "resource.RLIM_INFINITY" is now always a positive
  integer. On all supported platforms, it is larger than any limited
  resource value, which simplifies comparison of the resource values.
  Previously, it could be negative, such as -1 or -3, depending on
  platform.

* gh-137477: Corrige "inspect.getblock()", "inspect.getsourcelines()"
  e "inspect.getsource()" para expressões geradoras.

* gh-137481: Calendar uses the lengths of the locale's weekdays to
  decide if the width requires abbreviation.

* gh-137466: Remove undocumented "glob.glob0()" and "glob.glob1()"
  functions, which have been deprecated since Python 3.13. Use
  "glob.glob()" and pass a directory to its *root_dir* argument
  instead.

* gh-137044: Retorna valores de limite grandes como inteiros positivos
  em vez de inteiros negativos em "resource.getrlimit()". Aceita
  valores grandes e rejeita valores negativos (exceto "RLIM_INFINITY")
  para limites em "resource.setrlimit()".

* gh-115766: Fix "ipaddress.IPv4Interface.is_unspecified".

* gh-75989: "tarfile.TarFile.extractall()" e
  "tarfile.TarFile.extract()" agora substituem links simbólicos ao
  extrair links físicos. (Contribuição de Alexander Enrique Urieles
  Nieto em gh-75989.)

* gh-137017: Corrige "threading.Thread.is_alive" para permanecer
  "True" até que a thread do SO subjacente seja completamente limpa.
  Isso evita falsos negativos em casos extremos envolvendo
  monitoramento de threads ou chamadas prematuras de
  "threading.Thread.is_alive".

* gh-137273: Corrige falha de asserção de depuração em
  "locale.setlocale()" no Windows.

* gh-137191: Fix how type parameters are collected, when
  "typing.Protocol" are specified with explicit parameters. Now,
  "typing.Generic" and "typing.Protocol" always dictate the parameter
  number and parameter ordering of types. Previous behavior was a bug.

* gh-137282: Corrige o preenchimento por tabulação e "dir()" em
  "concurrent.futures".

* gh-137257: Sobe a versão do pip empacotado em ensurepip para a
  versão 25.2.

* gh-137239: "heapq": Atualiza "heapq.__all__" com funções "*_max".

* gh-124503: "ast.literal_eval()" is 10-20% faster for small inputs.

* gh-137226: Corrige o comportamento de
  "annotationlib.ForwardRef.evaluate()" quando o parâmetro
  *type_params* é passado e o nome de um parâmetro de tipo também está
  presente em um escopo envolvente.

* gh-137197: "SSLContext" objects can now set TLS 1.3 cipher suites
  via "set_ciphersuites()".

* gh-81325: "tarfile.TarFile" agora aceita um *caminho ou similar* ao
  trabalhar em um arquivo tar. (Contribuição de Alexander Enrique
  Urieles Nieto em gh-81325.)

* gh-137185: Corrige um possível problema de segurança de sinal
  assíncrono em "faulthandler" ao exibir stack traces (situação da
  pilha de execução).

* gh-133951: Remove lib64-lib symlink creation when creating new
  virtual environments in "venv" module

* gh-130522: Corrige "TypeError" não levantável levantada durante
  *desligamento do interpretador* no módulo "threading".

* gh-137059: Corrige o tratamento de URLs de arquivo com uma letra de
  unidade do Windows na autoridade de URL por
  "urllib.request.url2pathname()". Isso corrige uma regressão em
  versões anteriores do Python 3.14.

* gh-136980: Remove unused C tracing code in bdb for event type
  "c_call", "c_return" and "c_exception"

* gh-130577: "tarfile" agora valida arquivos para garantir que os
  deslocamentos dos membros não sejam negativos. (Contribuição de
  Alexander Enrique Urieles Nieto em gh-130577.)

* gh-136170: Foi removida a propriedade não lançada
  "zipfile.ZipFile.data_offset" adicionada na versão 3.14.0a7, pois
  não estava totalmente claro qual comportamento ela deveria ter em
  algumas situações, então o resultado nem sempre era o que o usuário
  esperava.

* gh-121237: Support "%:z" directive for
  "datetime.datetime.strptime()", "datetime.time.strptime()" and
  "time.strptime()". Patch by Lucas Esposito and Semyon Moroz.

* gh-136929: Ensure that hash functions guaranteed to be always
  *available* exist as attributes of "hashlib" even if they will not
  work at runtime due to missing backend implementations. For
  instance, "hashlib.md5" will no longer raise "AttributeError" if
  OpenSSL is not available and Python has been built without MD5
  support. Patch by Bénédikt Tran.

* gh-124621: pyrepl agora funciona em Emscripten.

* gh-136914: Corrige recuperação de "doctest.DocTest.lineno" para
  objetos decorados com "functools.cache()" ou
  "functools.cached_property".

* gh-136912: "hmac.digest()" agora lida corretamente com chaves e
  mensagens grandes, recorrendo à implementação pura do Python quando
  necessário. Patch por Bénédikt Tran.

* gh-83424: Permite criar um "ctypes.CDLL" sem nome ao passar um
  identificador como argumento.

* gh-135228: Quando "dataclasses" substitui uma classe por uma
  dataclass com slot, a classe original agora pode ser coletada como
  lixo novamente. Alterações anteriores no Python 3.14 fizeram com que
  essa classe permanecesse sempre em existência, juntamente com a
  classe substituta sintetizada por "dataclasses".

* gh-136874: Descarta consulta e fragmento de URL em
  "urllib.request.url2pathname()".

* gh-136787: "hashlib": improve exception messages when a hash
  algorithm is not recognized, blocked by the current security policy
  or incompatible with the desired operation (for instance, using HMAC
  with SHAKE). Patch by Bénédikt Tran.

* gh-130645: Habilita ajuda de cores por padrão em "argparse".

* gh-131724: In "http.client", a new *max_response_headers* keyword-
  only parameter has been added to "HTTPConnection" and
  "HTTPSConnection" constructors. This parameter sets the maximum
  number of allowed response headers, helping to prevent denial-of-
  service attacks.

* gh-135427: With "-Werror", the DeprecationWarning emitted by
  "os.fork()" and "os.forkpty()" in mutli-threaded processes is now
  raised as an exception. Previously it was silently ignored. Patch by
  Rani Pinchuk.

* gh-136234: Corrige "asyncio.WriteTransport.writelines()" para ser
  robusto a falhas de conexão, usando o mesmo comportamento de
  "write()".

* gh-53144: "encodings.aliases": Add "latin_N" aliases

* gh-136669: "_asyncio" is now statically linked for improved
  performance.

* gh-136134: "SMTP.auth_cram_md5()" agora levanta uma "SMTPException"
  em vez de uma "ValueError" se o Python tiver sido construído sem
  suporte a MD5. Em particular, clientes "SMTP" não tentarão usar este
  método, mesmo que se presuma que o servidor remoto o suporte. Patch
  por Bénédikt Tran.

* gh-136134: "IMAP4.login_cram_md5" agora levanta "IMAP4.error" se a
  autenticação CRAM-MD5 não for suportada. Patch por Bénédikt Tran.

* gh-136591: "_hashlib": avoid using deprecated functions
  *ERR_func_error_string* and *EVP_MD_CTX_md* when using OpenSSL 3.0
  and later. Patch by Bénédikt Tran.

* gh-136571: "datetime.date.fromisocalendar()" can now raise
  OverflowError for out of range arguments.

* gh-136549: Corrige assinatura de "threading.excepthook()".

* gh-136492: Expose **PEP 667**'s "FrameLocalsProxyType" in the
  "types" module.

* gh-83336: "utf8_sig" is now aliased to "encodings.utf_8_sig"

* gh-136523: Corrige "wave.Wave_write" emitindo uma exceção não
  levantável quando open a levanta.

* gh-136507: Corrige o CLI dos tipos MIME para manipular vários
  parâmetros de arquivo.

* gh-52876: Adiciona o parâmetro "keepends" ausente (padrão "True")
  para "codecs.StreamReaderWriter.readline()" e
  "codecs.StreamReaderWriter.readlines()".

* gh-136470: Corrige o nome da thread padrão de
  "concurrent.futures.InterpreterPoolExecutor".

* gh-136476: Corrige um bug que estava fazendo com que a função
  "get_async_stack_trace" perdesse alguns quadros no stack trace
  (situação da pilha de execução).

* gh-136434: Corrige geração de documentos de "UnboundItem" em
  "concurrent.interpreters" ao executar com "-OO".

* gh-136380: LEvanta "AttributeError" ao acessar
  "concurrent.futures.InterpreterPoolExecutor" e subinterpretadores
  não estão disponíveis.

* gh-72327: Suggest using the system command prompt when "pip install"
  is typed into the REPL. Patch by Tom Viner, Richard Si, and Brian
  Schubert.

* gh-135953: Implement a new high-frequency runtime profiler that
  leverages the existing remote debugging functionality to collect
  detailed execution statistics from running Python processes. This
  tool is exposed in the "profile.sample" module and enables non-
  intrusive observation of production applications by attaching to
  already-running processes without requiring any code modifications,
  restarts, or special startup flags. The observer can perform
  extremely high-frequency sampling of stack traces and interpreter
  state, providing detailed runtime execution analysis of live
  applications.

* gh-136021: Make "type_params" parameter required in
  "typing._eval_type()" after a deprecation period for not providing
  this parameter. Also remove the "DeprecationWarning" for the old
  behavior.

* gh-136286: Fix pickling failures for protocols 0 and 1 for many
  objects related to subinterpreters.

* gh-136047: Fix issues with "typing" when the C implementation of
  "abc" is not available.

* gh-136316: Melhora o suporte para avaliar referências aninhadas em
  "typing.evaluate_forward_ref()".

* gh-136306: "ssl" can now get and set groups used for key agreement.

* gh-136156: "tempfile.TemporaryFile()" no longer uses "os.O_EXCL"
  with "os.O_TMPFILE", so it's possible to use "linkat()" on the file
  descriptor. Patch by Victor Stinner.

* gh-133982: Update Python implementation of "io.BytesIO" to be thread
  safe.

* gh-136193: Improve "TypeError" error message, when richcomparing two
  "types.SimpleNamespace" objects.

* gh-136097: Fix potential infinite recursion and KeyError in
  "sysconfig --generate-posix-vars".

* gh-85702: Se "zoneinfo._common.load_tzdata" receber um pacote sem um
  recurso, um "zoneinfo.ZoneInfoNotFoundError" será levantada em vez
  de uma "PermissionError". Patch por Victor Stinner.

* gh-90733: Improve error messages when reporting invalid parameters
  in "hashlib.scrypt()". Patch by Bénédikt Tran.

* gh-134759: Corrige "UnboundLocalError" em
  "email.message.Message.get_payload()" quando o payload a ser
  decodificado for um objeto "bytes". Patch por Kliment Lamonov.

* gh-136028: Corrige a análise de nomes de meses contendo "İ" (U+0130,
  LETRA I MAIÚSCULA COM PONTO EM CIMA) em "time.strptime()". Isso
  afeta as localidades az_AZ, ber_DZ, ber_MA e crh_UA.

* gh-87135: Acquiring a "threading.Lock" or "threading.RLock" at
  interpreter shutdown will raise "PythonFinalizationError" if Python
  can determine that it would otherwise deadlock.

* gh-135995: Na codificação palmos, faz o byte "0x9b" ser decodificado
  para "›" (U+203A - ASPAS ÚNICAS DE ÂNGULO À DIREITA).

* gh-105456: Removed "sre_compile", "sre_constants" and "sre_parse"
  modules.

* gh-53203: Corrige "time.strptime()" para os formatos "%c" e "%x" nos
  locais byn_ER, wal_ET e lzh_TW, e para o formato "%X" nos locais
  ar_SA, bg_BG e lzh_TW.

* gh-135878: Corrige uma falha de "types.SimpleNamespace" em
  construções com *threads livres*, quando várias threads estavam
  chamando seu método "__repr__()" ao mesmo tempo.

* gh-135853: Add "math.fmax()" and "math.fmin()" to get the larger and
  smaller of two floating-point values. Patch by Bénédikt Tran.

* gh-135836: Corrige "IndexError" em
  "asyncio.loop.create_connection()" que poderia ocorrer quando uma
  exceção não-"OSError" fosse levantada durante a conexão e o
  "close()" do soquete levantasse "OSError".

* gh-135853: "math": expose C99 "signbit()" function to determine
  whether the sign bit of a floating-point value is set. Patch by
  Bénédikt Tran.

* gh-134531: "hmac": use the *EVP_MAC(3ssl)* interface for HMAC when
  Python is built with OpenSSL 3.0 and later instead of the deprecated
  *HMAC_CTX(3ssl)* interface. Patch by Bénédikt Tran.

* gh-135836: Corrige "IndexError" em
  "asyncio.loop.create_connection()" que poderia ocorrer quando o
  algoritmo Happy Eyeballs resultava em uma lista de exceções vazia
  durante tentativas de conexão.

* gh-135855: Levanta "TypeError" em vez de "SystemError" quando
  "_interpreters.set___main___attrs()" recebe um objeto não dict.
  Patch por Brian Schubert.

* gh-135823: "netrc": improve the error message when the security
  check for the ownership of the default configuration file "~/.netrc"
  fails. Patch by Bénédikt Tran.

* gh-135815: "netrc": Ignora as verificações de segurança se
  "os.getuid()" estiver ausente. Patch por Bénédikt Tran.

* gh-135640: Corrigido um bug que permitia chamar
  "xml.etree.ElementTree.ElementTree.write()" em um objeto ElementTree
  com um elemento raiz inválido. Esse comportamento apagava o arquivo
  passado para "write" caso ele já existisse.

* gh-90117: Speed up "pprint" for "list" and "tuple".

* gh-135759: "hashlib": reject negative digest lengths in OpenSSL-
  based SHAKE objects by raising a "ValueError". Previously, negative
  lengths were implicitly rejected by raising a "MemoryError" or a
  "SystemError". Patch by Bénédikt Tran.

* gh-123471: Make concurrent iterations over "itertools.chain" safe
  under *free threading*.

* gh-135645: Adicionado campo "supports_isolated_interpreters" a
  "sys.implementation".

* gh-135646: Levanta exceções consistentes "NameError" em
  "annotationlib.ForwardRef.evaluate()"

* gh-135557: Corrige corridas em atualizações de "heapq" e leituras de
  "list" na construção com *threads livres*.

* gh-119180: Busca globais e locais somente se necessário em
  "annotationlib.get_annotations()"

* gh-135561: Corrige uma falha em construções DEBUG quando uma rotina
  HACL* HMAC falha. Patch por Bénédikt Tran.

* gh-135386: Corrige a abertura de um banco de dados "dbm.sqlite3"
  para leitura de um arquivo ou diretório somente leitura.

* gh-135444: Corrige "asyncio.DatagramTransport.sendto()" para levar
  em conta o tamanho do cabeçalho do datagrama quando os dados não
  podem ser enviados.

* gh-65697: A mensagem de erro do "configparser" ao tentar escrever
  uma chave inválida agora é mais útil.

* gh-135497: Corrige falha em "os.getlogin()" para nomes de usuários
  mais longos em plataformas baseadas em BSD.

* gh-135487: Corrige "reprlib.Repr.repr_int()" quando são fornecidos
  inteiros com mais de "sys.get_int_max_str_digits()" dígitos. Patch
  por Bénédikt Tran.

* gh-135429: Corrige a incompatibilidade de argumentos em "_lsprof"
  para o evento "PY_THROW".

* gh-135368: Corrige a geração de "unittest.mock.Mock" em objetos
  "dataclasses.dataclass()". Agora, todos os atributos especiais são
  definidos como antes de gh-124429.

* gh-135336: "json" now encodes strings up to 2.2x faster if they
  consist solely of characters that don’t require escaping.

* gh-135335: "multiprocessing": Limpa "stdout" e "stderr" após
  pré-carregar módulos no "forkserver".

* gh-126631: Corrige bug no "forkserver" do "multiprocessing" que
  impedia "__main__" de ser pré-carregado.

* gh-133967: Não normaliza o nome "locale" 'C.UTF-8' para
  'en_US.UTF-8'.

* gh-130870: Preserve "types.GenericAlias" subclasses in
  "typing.get_type_hints()"

* gh-135321: Levanta uma exceção correta para valores maiores que
  0x7fffffff para o opcode "BINSTRING" na implementação C de "pickle".

* gh-121914: Changed the names of the symbol tables for lambda
  expressions and generator expressions to "<lambda>" and "<genexpr>"
  respectively to avoid conflicts with user-defined names.

* gh-135276: Synchronized zipfile.Path with zipp 3.23, including
  improved performance of "zipfile.Path.open()" for non-reading modes,
  rely on "functools.cached_property()" to cache values on the
  instance. Rely on "save_method_args" to save the initialization
  method arguments. Fixed ".name", ".stem" and other basename-based
  properties on Windows when working with a zipfile on disk.

* gh-135234: "hashlib": improve exception messages when an OpenSSL
  function failed. When memory allocation fails on OpenSSL's side, a
  "MemoryError" is raised instead of a "ValueError". Patch by Bénédikt
  Tran.

* gh-135244: "uuid": quando o endereço MAC não pode ser determinado, o
  ID do nó de 48 bits agora é gerado com um gerador de números
  pseudoaleatórios criptograficamente seguro (CSPRNG), conforme **RFC
  9562, §6.10.3**. Isso afeta "uuid1()" e "uuid6()".

* gh-135241: The "INT" opcode of the C accelerator "_pickle" module
  was updated to look only for "00" and "01" to push booleans onto the
  stack, aligning with the Python "pickle" module.

* gh-133934: Improve "sqlite3" CLI's ".help" message.

* gh-135069: Corrige a exceção "Invalid error handling" em
  "encodings.idna.IncrementalDecoder" para substituir corretamente o
  parâmetro 'errors'.

* gh-130662: Aceita zeros à esquerda em campos de precisão e largura
  para formatação "Decimal", por exemplo "format(Decimal(1.25),
  '.016f')".

* gh-130662: Aceita zeros à esquerda em campos de precisão e largura
  para formatação "Fraction", por exemplo "format(Fraction(1, 3),
  '.016f')".

* gh-135004: Rewrite and cleanup the internal "_blake2" module. Some
  exception messages were changed but their types were left untouched.
  Patch by Bénédikt Tran.

* gh-134953: Expande o tema "_colorize" com "keyword_constant" e
  implementa no *repl*.

* gh-134978: "hashlib": Supporting the "string" keyword parameter in
  hash function constructors such as "new()" or the direct hash-named
  constructors such as "md5()" and "sha256()" is now deprecated and
  slated for removal in Python 3.19. Prefer passing the initial data
  as a positional argument for maximum backwards compatibility. Patch
  by Bénédikt Tran.

* gh-134970: Corrige a exceção "ação desconhecida" em
  "argparse.ArgumentParser.add_argument_group()" para substituir
  corretamente a classe de ação.

* gh-134718: By default, omit optional "Load()" values in
  "ast.dump()".

* gh-134718: "ast.dump()" agora só omite os valores "None" e "[]" se
  forem valores padrão.

* gh-134939: Adiciona o módulo "concurrent.interpreters". Veja **PEP
  734**.

* gh-108885: Run each example as a subtest in unit tests synthesized
  by "doctest.DocFileSuite()" and "doctest.DocTestSuite()". Add the
  "doctest.DocTestRunner.report_skip()" method.

* gh-134885: Corrige possível falha no módulo "compression.zstd"
  relacionada à configuração de tipos de parâmetros. Patch por Jelle
  Zijlstra.

* gh-134857: Melhoria no relatório de erros para "doctest" executado
  com "unittest". Remoção de quadros do módulo "doctest" de tracebacks
  e caracteres de quebra de linha redundantes de mensagens de falha.

* gh-128840: Corrige a análise de endereços IPv6 longos com endereço
  IPv4 incorporado.

* gh-133579: "curses": Consistently report failures of curses C API
  calls in module-level methods by raising a "curses.error". This
  affects "assume_default_colors()", "baudrate()", "cbreak()",
  "echo()", "longname()", "initscr()", "nl()", "raw()", "termattrs()",
  "termname()" and "unctrl()". Patch by Bénédikt Tran.

* gh-133579: "curses.window.refresh()" and
  "curses.window.noutrefresh()" now raise a "TypeError" instead of
  "curses.error" when called with an incorrect number of arguments for
  pads. Patch by Bénédikt Tran.

* gh-133579: curses.window: Consistently report failures of curses C
  API calls in Window methods by raising a "curses.error". This
  affects "addch()", "addnstr()", "addstr()", "border()", "box()",
  "chgat()", "getbkgd()", "inch()", "insstr()" and "insnstr()". Patch
  by Bénédikt Tran.

* gh-134771: The "time_clockid_converter()" function now selects
  correct type for "clockid_t" on Cygwin which fixes a build error.

* gh-134637: Corrige regressão de desempenho ao chamar um ponteiro de
  função "ctypes" em *threads livres*.

* gh-134696: Implementações HACL* e OpenSSL embutidas de construtores
  de funções hash agora aceitam corretamente os mesmos argumentos
  nomeados *documentados*. Por exemplo, "md5()" podia ser invocado
  anteriormente como "md5(data=data)" ou "md5(string=string)"
  dependendo da implementação subjacente, mas essas chamadas não eram
  compatíveis. Patch por Bénédikt Tran.

* gh-132710: Se possível, garante que "uuid.getnode()" retorne o mesmo
  resultado mesmo em processos diferentes. Anteriormente, o resultado
  era constante apenas dentro do mesmo processo. Patch por Bénédikt
  Tran.

* gh-134531: "_hashlib": Rename internal C functions for
  "_hashlib.HASH" and "_hashlib.HASHXOF" objects. Patch by Bénédikt
  Tran.

* gh-134698: Corrige uma falha ao chamar métodos de "ssl.SSLContext"
  ou "ssl.SSLSocket" em várias threads.

* gh-134151: "email": Corrige "TypeError" em
  "email.utils.decode_params()" ao classificar continuações **RFC
  2231** que contêm uma seção não numerada.

* gh-134635: "zlib": Allow to combine Adler-32 and CRC-32 checksums
  via "adler32_combine()" and "crc32_combine()". Patch by Callum
  Attryde and Bénédikt Tran.

* gh-134657: "asyncio": Remove alguns nomes privados de
  "asyncio.__all__".

* gh-134210: "curses.window.getch()" agora manipula sinais
  corretamente. Patch por Bénédikt Tran.

* gh-80334: "multiprocessing.freeze_support()" agora verifica o
  trabalho em qualquer plataforma de método de inicialização "spawn",
  em vez de apenas no Windows.

* gh-134582: Corrige erros de ida e volta de tokenize.untokenize()
  relacionados a chaves de escape de t-strings

* gh-134580: Improved the styling of HTML diff pages generated by the
  "difflib.HtmlDiff" class, and migrated the output to the HTML5
  standard.

* gh-134565: "unittest.doModuleCleanups()" no longer swallows all but
  first exception raised in the cleanup code, but raises a
  "ExceptionGroup" if multiple errors occurred.

* gh-134546: Garante que o script de depuração remota "pdb" seja
  legível pelo processo Python remoto.

* gh-134451: Convertido "asyncio.tools.CycleFoundException" de
  dataclass para um tipo de exceção regular.

* gh-114177: Corrige "asyncio" para não fechar encadeamentos de
  subprocesso, o que de outra forma geraria erro quando o laço de
  eventos já estivesse fechado.

* gh-90871: Corrigido um erro de um erro referente ao parâmetro
  backlog em "create_unix_server()". Contribuição de Christian
  Harries.

* gh-134323: Corrige o método "threading.RLock.locked()".

* gh-86802: Corrigido vazamento de memória assíncrona em tarefas de
  escudo canceladas. Para tarefas protegidas em que o escudo foi
  cancelado, registre possíveis exceções por meio do tratador de
  exceções. Contribuição de Christian Harries.

* gh-71189: Add support of the all-but-last mode in
  "os.path.realpath()".

* gh-72902: Improve speed (x1.1-1.8) of the "Fraction" constructor for
  typical inputs ("float"'s, "Decimal"'s or strings).

* gh-134209: "curses": Os métodos "curses.window.instr()" e
  "curses.window.getstr()" agora alocam seu buffer interno no heap em
  vez da heap; além disso, o tamanho máximo do buffer foi aumentado de
  1023 para 2047.

* gh-88994: Change "datetime.datetime.now()" to half-even rounding for
  consistency with "datetime.datetime.fromtimestamp()".  Patch by John
  Keith Hohm.

* gh-80184: The default queue size is now "socket.SOMAXCONN" for
  "socketserver.TCPServer".

* gh-132983: Add "compression.zstd" version information to
  "test.pythoninfo".

* gh-134235: Atualizada a complementação de tabulação no REPL para
  incluir módulos embutidos. Contribuição de Tom Wang e Hunter Young.

* gh-134152: Corrigida "UnboundLocalError" que poderia ocorrer durante
  a análise do cabeçalho "email" se um delimitador final esperado
  estivesse faltando em alguns contextos.

* gh-134152: "email": Corrige análise de ID de mensagem de e-mail com
  domínio inválido.

* gh-134168: "http.server": Corrige a ligação de endereço IPv6 e
  tratamento de "--directory" ao usar HTTPS.

* gh-62184: Remove a importação da implementação C de "io.FileIO" da
  implementação Python que tem sua própria implementação

* gh-134087: Remove support for arbitrary positional or keyword
  arguments in the C implementation of "threading.RLock" objects. This
  was deprecated since Python 3.14. Patch by Bénédikt Tran.

* gh-134173: Speed up "asyncio" performance of transferring state from
  thread pool "concurrent.futures.Future" by up to 4.4x. Patch by J.
  Nick Koston.

* gh-133982: Emite "RuntimeWarning" na implementação Python de "io"
  quando o *objeto arquivo ou similar* não for fechado explicitamente
  na presença de múltiplas camadas de E/S.

* gh-133890: O módulo "tarfile" agora manipula "UnicodeEncodeError" da
  mesma forma que "OSError" quando não é possível extrair um membro.

* gh-134097: Corrige interação da *REPL* e a nova opção de linha de
  comando "-X showrefcount".

* gh-133889: A página de listagem de diretório gerada em
  "http.server.SimpleHTTPRequestHandler" agora mostra apenas o
  componente do caminho decodificado da URL solicitada, e não a
  consulta e o fragmento.

* gh-134098: Corrige caminhos de manipulação que terminam com uma
  barra codificada em porcentagem ("%2f" ou "%2F") em
  "http.server.SimpleHTTPRequestHandler".

* gh-132124: Em sistemas compatíveis com POSIX,
  "multiprocessing.util.get_temp_dir()" agora ignora "TMPDIR" (e
  variáveis de ambiente semelhantes) se o comprimento do caminho dos
  arquivos de soquete "AF_UNIX" exceder o comprimento máximo
  específico da plataforma ao usar o método de inicialização
  forkserver. Patch por Bénédikt Tran.

* gh-134062: "ipaddress": corrige colisões em "__hash__()" para
  objetos "IPv4Network" e "IPv6Network".

* gh-134004: "shelve" as well as underlying "dbm.dumb" and
  "dbm.sqlite" now have "reorganize()" methods to recover unused free
  space previously occupied by deleted entries.

* gh-133970: Torna "string.templatelib.Template" e
  "string.templatelib.Interpolation" genéricos.

* gh-71253: Levanta "ValueError" em "open()" se *opener* retornar um
  descritor de arquivo negativo na implementação Python de "io" para
  corresponder à implementação C.

* gh-133960: Simplifica e aprimora "typing.evaluate_forward_ref()".
  Agora, ele não levanta mais erros em determinados tipos inválidos.
  Em diversas situações, agora é possível avaliar referências futuras
  que antes não eram suportadas.

* gh-133925: Torna a classe privada "typing._UnionGenericAlias"
  hasheável.

* gh-133604: Remove "platform.java_ver()" which was deprecated since
  Python 3.13.

* gh-133875: Removed deprecated "pathlib.PurePath.is_reserved()". Use
  "os.path.isreserved()" to detect reserved paths on Windows.

* gh-133873: Remove the deprecated "getmark()", "setmark()" and
  "getmarkers()" methods of the "Wave_read" and "Wave_write" classes,
  which were deprecated since Python 3.13. Patch by Bénédikt Tran.

* gh-133866: Remove the undocumented function
  "ctypes.SetPointerType()", which has been deprecated since Python
  3.13. Patch by Bénédikt Tran.

* gh-133823: Remove support for "TD = TypedDict("TD")" and "TD =
  TypedDict("TD", None)" calls for constructing "typing.TypedDict"
  objects with zero field. Patch by Bénédikt Tran.

* gh-125996: Correção da segurança de thread de
  "collections.OrderedDict". Patch por Kumar Aditya.

* gh-133817: Remove support for creating "NamedTuple" classes via the
  undocumented keyword argument syntax. Patch by Bénédikt Tran.

* gh-133653: Corrige "argparse.ArgumentParser" com o argumento
  *formatter_class*. Corrige TypeError quando *formatter_class* for
  uma subclasse personalizada de "HelpFormatter". Corrige TypeError
  quando *formatter_class* não for uma subclasse de "HelpFormatter" e
  *prefix_char* não padrão for usado. Corrige suporte à colorização
  quando *formatter_class* não for uma subclasse de "HelpFormatter".

* gh-133810: Remove "http.server.CGIHTTPRequestHandler" and "--cgi"
  flag from the **python -m http.server** command-line interface. They
  were deprecated in Python 3.13. Patch by Bénédikt Tran.

* gh-132641: Corrigida uma corrida em "functools.lru_cache()" em
  threads livres.

* gh-133783: Corrige bug ao aplicar "copy.replace()" a objetos "ast".
  Atributos cujo padrão é "None" eram tratados incorretamente como
  obrigatórios para nós de AST criados manualmente.

* gh-133684: Corrige bug em que "annotationlib.get_annotations()"
  retornaria o resultado errado para determinadas classes que fazem
  parte de uma hierarquia de classes onde "from __future__ import
  annotations" é usado.

* gh-77057: Corrige o tratamento de declarações de marcação inválidas
  em "html.parser.HTMLParser".

* gh-130328: Aceleração da colagem em "PyREPL" no Windows em um
  console antigo. Patch por Chris Eibl.

* gh-133701: Corrige bug onde classes "typing.TypedDict" definidas em
  "from __future__ import annotations" e herdadas de outro "TypedDict"
  tinham um atributo "__annotations__" incorreto.

* gh-133656: Remove deprecated "zipimport.zipimporter.load_module()".
  Use "zipimport.zipimporter.exec_module()" instead.

* gh-133722: Added a *color* option to "difflib.unified_diff()" that
  colors output similar to **git diff**.

* gh-133489: "random.getrandbits()" agora pode gerar mais de 2^31
  bits. "random.randbytes()" agora pode gerar mais de 256 MiB.

* gh-133595: Clean up "sqlite3.Connection" APIs. All parameters of
  "sqlite3.connect()" except *database* are now keyword-only. The
  first three parameters of methods "create_function()" and
  "create_aggregate()" are now positional-only. The first parameter of
  methods "set_authorizer()", "set_progress_handler()" and
  "set_trace_callback()" is now positional-only.

* gh-133581: Melhoria na desanálise de t-strings em "ast.unparse()" e
  "from __future__ import annotations". T-strings vazias agora
  realizam a ida e volta corretamente e a formatação em interpolações
  é preservada. Patch por Jelle Zijlstra.

* gh-133577: Add parameter "formatter" to "logging.basicConfig()".

* gh-92897: Removed the "check_home" parameter from
  "sysconfig.is_python_build()", deprecated since Python 3.12.

* gh-133551: Suporte a t-strings (**PEP 750**) em "annotationlib".
  Patch por Jelle Zijlstra.

* gh-133517: Remove "os.listdrives()", "os.listvolumes()" and
  "os.listmounts()" in non Windows desktop builds since the underlying
  functionality is missing.

* gh-133439: Corrige comandos ponto com espaços à direita são
  confundidos com instruções SQL multilinha na interface de linha de
  comando sqlite3.

* gh-133447: Add basic color to "sqlite3" CLI interface.

* gh-133253: Fix thread-safety issues in "linecache".

* gh-133390: Support keyword completion in the "sqlite3" command-line
  interface and add "sqlite3.SQLITE_KEYWORDS" constant.

* gh-132493: Evita acessar "__annotations__" desnecessariamente em
  "inspect.signature()".

* gh-133017: Improve the error message of
  "multiprocessing.sharedctypes.Array()",
  "multiprocessing.sharedctypes.RawArray()",
  "multiprocessing.sharedctypes.Value()" and
  "multiprocessing.sharedctypes.RawValue()" when an invalid typecode
  is passed. Patch by Tomas Roun

* gh-132813: Melhora as mensagens de erro para tipos e valores
  incorretos de atributos "csv.Dialect".

* gh-132969: Impede que a thread executora "ProcessPoolExecutor", que
  permanece em execução quando "shutdown(wait=False)", tente ajustar
  os processos de trabalho do pool após o estado do objeto já ter sido
  redefinido durante o desligamento. Uma combinação de condições,
  incluindo um processo de trabalho encerrado de forma anormal,
  resultou em uma exceção e um possível travamento quando a thread
  executora ainda em execução tentou substituir os processos de
  trabalho inativos no pool.

* gh-132876: "ldexp()" no Windows não arredonda resultados abaixo do
  normal antes do Windows 11, mas deveria. O invólucro de
  "math.ldexp()" do Python agora os arredonda, então os resultados
  podem mudar um pouco, em casos raros de resultados muito pequenos,
  em versões do Windows anteriores à 11.

* gh-133009: "xml.etree.ElementTree": Corrige uma falha em
  "Element.__deepcopy__" quando o elemento sofre mutação simultânea.
  Patch por Bénédikt Tran.

* gh-132908: Add "math.isnormal()" and "math.issubnormal()" functions.
  Patch by Sergey B Kirpichev.

* gh-95380: "fcntl.fcntl()" and "fcntl.ioctl()": Remove the 1024 bytes
  limit on the size of not mutated bytes-like argument.

* gh-122781: Fix "%z" directive in "datetime.datetime.strptime()" to
  allow for no provided offset as was documented.

* gh-123471: Make concurrent iterations over "itertools.combinations"
  and "itertools.product" safe under free-threading.

* gh-127081: Corrige problemas de segurança de thread da libc com
  "dbm" executando operações com estado em seções críticas.

* gh-127081: Corrige problemas de segurança do thread libc com "os"
  substituindo "getlogin" pela versão reentrante "getlogin_r".

* gh-127081: Fix libc thread safety issues with "pwd" by locking
  access to "getpwall".

* gh-132551: Torna "io.BytesIO" segura na construção com *threads
  livres*.

* gh-107583: Fix "Flag" inversion when flag set has missing values
  ("IntFlag" still flips all bits); fix negative assigned values
  during flag creation (both "Flag" and "IntFlag" ignore missing
  values).

* gh-87790: Adicionado suporte para sublinhado e vírgula como
  separadores de milhares na parte fracionária para a formatação de
  "Fraction". Patch por Sergey B Kirpichev.

* gh-87790: Suporte para sublinhado e vírgula como separadores de
  milhares na parte fracionária para a formatação de "Decimal". Patch
  por Sergey B Kirpichev.

* gh-131884: Corrige problemas de formatação em "json.dump()" quando
  *indent* e *skipkeys* são usados.

* gh-131788: Torna "ResourceTracker.send" de "multiprocessing"
  reentrante seguro

* gh-91349: Adjust default "compressionlevel=" to 6 (down from 9) in
  "gzip" and "tarfile". It is the default level used by most
  compression tools and a better tradeoff between speed and
  performance.

* gh-131146: Fix "calendar.TextCalendar", "calendar.HTMLCalendar", and
  the "calendar" CLI to display month names in the nominative case by
  adding "calendar.standalone_month_name" and
  "calendar.standalone_month_abbr", which provide month names and
  abbreviations in the grammatical form used when a month name stands
  by itself, if the locale supports it.

* gh-123471: Make concurrent iterations over "itertools.cycle" safe
  under free-threading.

* gh-130664: Lida com maiúsculas e minúsculas para a formatação de
  "Fraction": tratar o preenchimento com zeros (precedendo o campo de
  largura por um caractere zero ("'0'")) como um equivalente a um
  caractere de preenchimento de "'0'" com um tipo de alinhamento de
  "'='", assim como no caso de "float".

* gh-130999: Evita sair do novo REPL e oferece sugestões mesmo se
  houver candidatos que não sejam strings quando ocorrerem erros.

* gh-88473: Implement a fast path for "datetime.date" objects in
  "datetime.date.today()" which results in a 5x performance gain while
  proper subclasses retain their previous performance.

* gh-126883: Add check that timezone fields are in range for
  "datetime.datetime.fromisoformat()" and
  "datetime.time.fromisoformat()". Patch by Semyon Moroz.

* gh-125028: "functools.Placeholder" não pode ser passado para
  "functools.partial()" como um argumento nomeado.

* gh-125843: If possible, indicate which "curses" C function or macro
  is responsible for raising a "curses.error" exception. Patch by
  Bénédikt Tran.

* gh-119109: "functools.partial()" calls are now faster when keyword
  arguments are used.

* gh-124033: "SimplePath" is now presented in
  "importlib.metadata.__all__".

* gh-91216: "importlib.metadata" now raises a "KeyError" instead of
  returning "None" when a key is missing from the metadata.

* gh-120492: "importlib.metadata" now prioritizes valid dists to
  invalid dists when retrieving by name.

* gh-99631: The "shelve" module now accepts custom serialization and
  deserialization functions.

* gh-119186: Slightly speed up "os.walk()" by calling "os.path.join()"
  less often.

* gh-120170: Fix an issue in the "_pickle" extension module in which
  importing "multiprocessing" could change how pickle identifies which
  module an object belongs to, potentially breaking the unpickling of
  those objects.

* gh-118981: Corrige possível travamento em
  "multiprocessing.popen_spawn_posix" que pode ocorrer quando o
  processo filho morre prematuramente, fechando os descritores de
  arquivo filhos imediatamente.

* gh-105497: Corrige a inversão da máscara de sinalizador quando
  existem flags sem nome.

* gh-99813: "ssl" now uses "SSL_sendfile" internally when it is
  possible (see "OP_ENABLE_KTLS"). The function sends a file more
  efficiently because it performs TLS encryption in the kernel to
  avoid additional context switches. Patch by Illia Volochii.

* gh-62824: Correção de apelidos para codificação "iso8859_8". Patch
  por Dave Goncalves.

* gh-86155: "html.parser.HTMLParser.close()" não perde mais dados
  quando a tag "<script>" não está fechada. Patch por Waylan Limberg.

* gh-78319: O suporte UTF8 para o comando IMAP APPEND foi tornado
  compatível com RFC.

* gh-93334: Reraise "KeyError" as "ModuleNotFoundError" when
  "importlib.machinery.PathFinder.find_spec()" is called on a
  submodule without importing the parent (and without a "path"
  argument).

* gh-69426: Corrige "html.parser.HTMLParser" para não desfazer o
  escape de entidades de caracteres em valores de atributos se eles
  forem seguidos por um alfanumérico ASCII ou um sinal de igual.

* bpo-38735: Corrige falha ao importar um módulo do diretório raiz em
  plataformas do tipo Unix com sys.pycache_prefix definido.

* bpo-45959: "pprint" can now pretty-print dict views.

* gh-84683: "zoneinfo": Check in "<prefix>/share/zoneinfo" for data
  files on Windows

* bpo-43429: The "size()" method of the "mmap.mmap" class now returns
  the size of an anonymous mapping on both Unix and Windows.
  Previously, the size would be returned on Windows and an "OSError"
  would be raised on Unix. "ValueError" is now raised instead of
  "OSError" when "trackfd=False".

* bpo-41839: Permite valores de prioridade negativos das funções
  "os.sched_get_priority_min()" e "os.sched_get_priority_max()".

* bpo-28494: Melhora a taxa de falsos positivos na validação de
  arquivo Zip em "zipfile.is_zipfile()".


IDLE
----

* gh-96491: Desduplica o número da versão na barra de título do shell
  do IDLE após salvar em um arquivo.

* gh-139742: Colore prefixos de t-string para strings template no
  IDLE, como feito para prefixos de f-string.


Documentação
------------

* gh-136155: Agora estamos verificando erros fatais em construções de
  EPUB no CI.

* gh-135171: Documenta que o *iterador* para a cláusula "for" mais à
  esquerda na expressão geradora é criado imediatamente.

* bpo-45210: Documenta que o indicador de erro pode ser definido em
  tp_dealloc e como evitar sobrecarregá-lo.


Núcleo e embutidos
------------------

* gh-140000: Corrige possível vazamento de memória quando há um ciclo
  de referência entre uma instância de "typing.TypeAliasType",
  "typing.TypeVar", "typing.ParamSpec" ou "typing.TypeVarTuple" e seu
  atributo "__name__". Patch por Mikhail Efimov.

* gh-140009: Improve performance of list extension by dictionary
  items.

* gh-139988: Corrige um vazamento de memória causado pela falha na
  criação do tipo "Union". Patch por Bénédikt Tran.

* gh-139748: Corrige vazamentos de referência em ramificações de erro
  de funções que aceitam strings de caminho ou bytes, como "compile()"
  e "os.system()". Patch por Bénédikt Tran.

* gh-139516: Corrigir erro no formato de início de especificação de
  dois pontos lambda na f-string no tokenizador.

* gh-63161: Suporte a shebang e comentários não UTF-8 em arquivos-
  fonte Python se a codificação não UTF-8 for especificada. Detecte
  erros de decodificação em comentários para a codificação padrão
  (UTF-8). Exibe a linha e a posição do erro de decodificação para a
  codificação padrão em um traceback. Exiba a linha que contém o
  cookie de codificação quando ele entrar em conflito com o BOM em um
  traceback.

* gh-139116: Prevent a deadlock when multiple threads start, stop and
  use "tracemalloc" simultaneously.

* gh-139275: Fix compilation problems in "_remote_debugging_module.c"
  when the system doesn't have "process_vm_readv". Patch by Pablo
  Galindo

* gh-133059: Increased the number of cached small positive integers
  from 256 to 1024.

* gh-74857: **PEP 538**: Coerce the POSIX locale to a UTF-8 based
  locale. Patch by Victor Stinner.


Biblioteca
----------

* gh-116738: Torna o "mmap" seguro para thread na construção com
  *threads livres*.


Núcleo e embutidos
------------------

* gh-138558: Corrige o tratamento de anotações incomuns de t-string na
  annotationlib. Patch por Dave Peck.

* gh-134466: Não executa o PyREPL em um ambiente degradado onde a
  definição de atributos termios não é permitida.

* gh-138794: When a new tracing function is registered with
  "PyRefTracer_SetTracer()",  replacing the current a call to the
  trace function will be made with the object set to **NULL** and
  **event** set to "PyRefTracer_TRACKER_REMOVED". This will happen
  just before the new function is registered. Patch by Pablo Galindo

* gh-71810: Levanta "OverflowError" para "(-1).to_bytes()" para
  conversões com sinal quando a contagem de bytes for zero. Patch por
  Sergey B Kirpichev.

* gh-138716: Improve "SyntaxError" message for "assert" in cases like
  "assert a := b".

* gh-105487: Remove "__copy__()", "__deepcopy__()" e "__bases__"
  inexistentes das entradas "__dir__()" de "types.GenericAlias".

* gh-138192: Corrige a inicialização de "contextvars" para que todos
  os subinterpretadores recebam o valor "MISSING".

* gh-138479: Corrige uma falha quando "__typing_subst__" de um objeto
  genérico retorna um objeto que não é uma "tuple".

* gh-138431: Fix a bug in the JIT optimizer when round-tripping
  strings and tuples.

* gh-138378: Move the globals-to-const JIT optimizer pass into to the
  main JIT optimizer pass


Biblioteca
----------

* gh-138401: Add missing validation of argument "count" in
  "os.sendfile()" to be non-negative.


Núcleo e embutidos
------------------

* gh-138372: Correção de "SyntaxWarning" emitido para subscrito
  expressão errôneo envolvendo literal de string template. Patch por
  Brian Schubert.

* gh-138302: "BINARY_OP" now specializes to "BINARY_OP_ADD_INT",
  "BINARY_OP_SUBTRACT_INT" or "BINARY_OP_MULTIPLY_INT" if operands are
  compact ints.

* gh-138318: O REPL padrão agora evita destacar nomes embutidos (por
  exemplo, "set" ou "format()") quando eles são usados como nomes de
  atributos (por exemplo, em "value.set" ou "text.format").

* gh-138349: Corrige falha em certos casos em que um módulo contém uma
  anotação de nível de módulo e uma compreensão.

* gh-69605: Corrige alguns submódulos da biblioteca padrão ausentes no
  preenchimento automático de importações do *REPL*.

* gh-61206: "zipimport" now supports zstandard compressed zip file
  entries.


Biblioteca
----------

* gh-116738: Make "cProfile" thread-safe on the *free threaded* build.


Núcleo e embutidos
------------------

* gh-137838: Fix JIT trace buffer overrun by increasing possible exit
  stubs. Patch by Donghee Na.

* gh-71679: Use the same quoting algorithm for the repr of bytearrays
  as for bytes objects and strings -- use double quotes for quoting if
  the bytearray contains single quotes and does not contain double
  quotes.

* gh-137384: Correção de uma falha ao usar o "warnings" módulo em um
  finalizador no desligamento. Patch por Kumar Aditya .


Biblioteca
----------

* gh-138004: Nas plataformas Solaris/Illumos, os nomes de threads
  agora são codificados como ASCII para evitar erros em sistemas (por
  exemplo, OpenIndiana) que não oferecem suporte a nomes não ASCII.

* gh-137976: Removed "localtime" from the list of reported system
  timezones.


Núcleo e embutidos
------------------

* gh-137992: Ensure that  "PyRefTracer_SetTracer()" sync with all
  existing threads when called to avoid races in the free threaded
  build. Patch by Pablo Galindo

* gh-137967: Show error suggestions on nested attribute access. Patch
  by Pablo Galindo

* gh-137959: Replace the shim code added to every piece of jitted code
  with a single trampoline function.

* gh-137883: Corrige recursão descontrolada ao chamar uma função com
  argumentos nomeados.

* gh-137079: Correção do reconhecimento de erros de digitação em
  palavra reservada ao analisar arquivos. Patch por Pablo Galindo.

* gh-137728: Corrige o tratamento de muitas variáveis locais pelo JIT.
  Isso anteriormente causava uma falha de segmentação.

* gh-137716: Fix double period in "AttributeError" message for invalid
  mock assertions

* gh-137433: Corrige um possível impasse na construção com *threads
  livres* quando threads do daemon habilitam ou desabilitam a criação
  de perfil ou rastreamento enquanto a thread principal está
  desligando o interpretador.

* gh-137576: Correção para código-fonte incorreto exibido em
  tracebacks do REPL básico quando "PYTHONSTARTUP" é fornecido. Patch
  por Adam Hartz.

* gh-37817: Allow assignment to "__bases__" of direct subclasses of
  builtin classes.

* gh-132732: Optimize "_COMPARE_OP", "_CONTAINS_OP",
  "_UNARY_NEGATIVE", "_UNARY_NOT", and "_UNARY_INVERT" in JIT builds
  with constant-loading uops ("_POP_TWO_LOAD_CONST_INLINE_BORROW" and
  "_POP_TOP_LOAD_CONST_INLINE_BORROW"), and then remove both to reduce
  instruction count.

* gh-137400: Corrige uma falha na construção com *threads livres* ao
  desabilitar a criação de perfil ou o rastreamento em todos os
  threads com "PyEval_SetProfileAllThreads()" ou
  "PyEval_SetTraceAllThreads()" ou seus equivalentes em Python
  "threading.settrace_all_threads()" e
  "threading.setprofile_all_threads()".

* gh-133143: Add "sys.abi_info" object to make ABI information more
  easily accessible.

* gh-137400: Corrige uma falha na construção com *threads livres* ao
  desabilitar a criação de perfil ou o rastreamento em todos os
  threads com "PyEval_SetProfileAllThreads()" ou
  "PyEval_SetTraceAllThreads()" ou seus equivalentes em Python
  "threading.settrace_all_threads()" e
  "threading.setprofile_all_threads()".

* gh-120037: Disable user site packages directory when a "._pth" file
  is used, even if it contains "import site".

* gh-58124: Corrige erros de codificação Python em Unicode do codec da
  página de código: usar "cp65000" e "cp65001" em vez de "CP_UTF7" e
  "CP_UTF8", que não são nomes de código Python válidos. Patch por
  Victor Stinner.

* gh-136966: The "object.__dict__" and "__weakref__" descriptors now
  use a single descriptor instance per interpreter, shared across all
  types that need them. This speeds up class creation, and helps avoid
  reference cycles.

* gh-137314: Corrigida uma regressão em que f-strings brutas
  interpretavam incorretamente sequências de escape em especificações
  de formato. As f-strings brutas agora preservam corretamente as
  contrabarras literais nas especificações de formato, correspondendo
  ao comportamento do Python 3.11. Por exemplo, "rf"{obj:\xFF}"" agora
  produz corretamente "'\\xFF'" em vez de "'ÿ'". Patch por Pablo
  Galindo.

* gh-137308: Uma docstring independente no corpo de um nó é otimizada
  como uma instrução "pass" para garantir que o corpo do nó nunca
  fique vazio. Caso contrário, havia um "ValueError" em "compile()".

* gh-137288: Corrige bug em que algumas instruções de bytecode de uma
  expressão booleana não estão associadas ao manipulador de exceção
  correto.

* gh-137291: The perf profiler can now be used if a previous frame
  evaluation API has been provided.

* gh-134291: Remove alguns usos mais recentes da API do macOS do
  compilador JIT para restaurar a compatibilidade com destinos de
  implantação mais antigos do OSX 10.15.

* gh-88886: The codecs lookup function now again performs only minimal
  normalization of the encoding name before passing it to the search
  functions: all ASCII letters are converted to lower case, spaces are
  replaced with hyphens. This restores the pre-Python 3.9 behavior.

* gh-131338: Desabilita verificações de limite de pilha computada em
  plataformas Linux não-glibc para corrigir travamentos em recursão
  profunda.

* gh-136870: Corrige disputas de dados ao desinstrumentar o bytecode
  de objetos código executados simultaneamente em threads.

* gh-132732: Optimize constant comparison for "_COMPARE_OP_INT",
  "_COMPARE_OP_FLOAT" and "_COMPARE_OP_STR" in JIT builds

* gh-127598: Improve "ModuleNotFoundError" by adding flavour text to
  the exception when the "-S" option is passed. Patch by Andrea
  Mattei.

* gh-136801: Corrige o destaque de sintaxe do PyREPL em casos de
  correspondência após casos multilinhas. Contribuição de Olga
  Matoula.

* gh-74185: The "__repr__()" of "ImportError" and
  "ModuleNotFoundError" now shows "name" and "path" as "name=<name>"
  and "path=<path>" if they were given as keyword arguments at
  construction time. Patch by Serhiy Storchaka, Oleg Iarygin, and Yoav
  Nir


Biblioteca
----------

* gh-116738: Make functions in "syslog" thread-safe on the *free
  threaded* build.

* gh-116738: Make functions in "pwd" thread-safe on the *free
  threaded* build.


Núcleo e embutidos
------------------

* gh-136616: Improve "SyntaxError" error messages for invalid "assert"
  usages.

* gh-136599: Improve performance of "int" hash calculations.


Biblioteca
----------

* gh-136421: Corrige falha ao inicializar "datetime" simultaneamente.


Núcleo e embutidos
------------------

* gh-136541: Corrigimos alguns problemas com os trampolins do Perf em
  x86-64 e aarch64. Os trampolins não estavam sendo gerados
  corretamente em alguns casos, o que poderia fazer com que a
  integração do Perf não funcionasse corretamente. Patch por Pablo
  Galindo.


Biblioteca
----------

* gh-107545: Improve the error messages that may be raised by
  "setsockopt()".


Núcleo e embutidos
------------------

* gh-136517: Corrigido um erro de digitação que impedia a exibição de
  objetos não colecionáveis quando o modo "gc.DEBUG_UNCOLLECTABLE"
  estava definido.

* gh-136525: Corrige problema em que o bytecode por thread não era
  instrumentado para threads recém-criadas.

* gh-132657: Melhora o desempenho de "frozenset" removendo travas na
  construção com threads livres.

* gh-136459: Add support for perf trampoline on macOS, to allow
  profilers wit JIT map support to read Python calls. While profiling,
  "PYTHONPERFSUPPORT=1" can be appended to enable the trampoline.

* gh-132661: "Interpolation.expression" agora tem um padrão, a string
  vazia.

* gh-132661: Reflete a recente mudança **PEP 750**.

  Não permite a concatenação de "string.templatelib.Template" e "str".
  Também não permite a concatenação implícita de literais de t-string
  com strings e literais de f-strings.

* gh-91636: Ao realizar a coleta de lixo, limpa as referências fracas
  (weakrefs) a objetos inacessíveis criados durante a execução dos
  finalizadores. Se essas referências fracas não forem limpas, elas
  podem revelar objetos inacessíveis.

* gh-136355: Deprecate "-b" and "-bb" command line options and
  schedule them to become no-op in Python 3.17.

* gh-109700: Corrige tratamento de erro de memória em
  "PyDict_SetDefault()".

* gh-135552: Fix a bug caused by the garbage collector clearing
  weakrefs too early.  The weakrefs in the "tp_subclasses" dictionary
  are needed in order to correctly invalidate type caches (for
  example, by calling "PyType_Modified()"). Clearing weakrefs before
  calling finalizers causes the caches to not be correctly
  invalidated.  That can cause crashes since the caches can refer to
  invalid objects.  Defer the clearing of weakrefs without callbacks
  until after finalizers are executed.

* gh-136203: Improve "TypeError" error message, when richcomparing two
  "types.MappingProxyType" objects.

* gh-136003: Fix "threading.Thread" objects becoming incorrectly
  daemon when created from an "atexit" callback or a pending call
  ("Py_AddPendingCall()").

* gh-78465: Corrige mensagem de erro para "cls.__new__(cls, ...)" onde
  "cls" não é um tipo de extensão ou embutido instanciável (com
  "tp_new" definido como "NULL").

* gh-135904: Perform more aggressive control-flow optimizations on the
  machine code templates emitted by the experimental JIT compiler.

* gh-129958: Diferencia entre t-strings e f-strings em erros de
  sintaxe para novas linhas em especificadores de formato de strings
  interpoladas entre aspas simples.

* gh-135871: Tentativas de trava de mutex não bloqueantes agora
  retornam imediatamente quando a trava está ocupado, em vez de girar
  brevemente na construção com *threads livres*.

* gh-134584: Specialize "POP_TOP" in the JIT compiler by specializing
  for reference lifetime and type. This will also enable easier top of
  stack caching in the JIT compiler.

* gh-135106: Restringe o mecanismo da lixeira aos objetos coletados
  pelo GC e cancele o rastreamento deles enquanto estiverem na lixeira
  para evitar conflitos entre os mecanismos do GC e da lixeira.

* gh-135379: Changes specialization of "BINARY_OP" for ints to only
  specialize for "compact" ints. This streamlines the fast path at the
  cost of fewer specializations when very large integers are used.

* gh-135607: Corrige possíveis corridas "weakref" no destrutor de um
  objeto na construção com *threads livres*.

* gh-135608: Corrige uma falha no JIT envolvendo atributos de módulos.

* gh-82088: Improve performance of "PyLongObject" conversion functions
  "PyLong_AsLongAndOverflow()", "PyLong_AsSsize_t()",
  "PyLong_AsUnsignedLong()", "PyLong_AsSize_t()",
  "PyLong_AsUnsignedLongMask()", "PyLong_AsUnsignedLongLongMask()",
  "PyLong_AsLongLongAndOverflow()" for integers larger than 2**30 up
  to 30%.

* gh-135551: Sorting randomly ordered lists will often run a bit
  faster, thanks to a new scheme for picking minimum run lengths from
  Stefan Pochmann, which arranges for the merge tree to be as evenly
  balanced as is possible.

* gh-135543: Emite o evento de auditoria "sys.remote_exec" quando
  "sys.remote_exec()" for chamado e migra "remote_debugger_script"
  para "cpython.remote_debugger_script".

* gh-135496: Corrige erro de digitação no tipo de conversão de
  f-strings ("exclamanation" -> "exclamation").

* gh-135474: Specialize integer operations only on compact integers.
  This is a CPython internal change.

* gh-135371: Corrige as ferramentas de depuração "asyncio" para exibir
  corretamente as pilhas de chamadas de corrotinas internas juntamente
  com as dependências de tarefas externas. Os comandos "python -m
  asyncio ps" e "python -m asyncio pstree" agora mostram o contexto de
  execução completo. Patch por Pablo Galindo.

* gh-135422: Fix regression in "SyntaxError" messages after gh-134036.


Biblioteca
----------

* gh-116738: Torna as funções em "grp" seguros para thread na
  construção com *threads livres*.

* gh-127319: Define a variável de classe "allow_reuse_port" como
  "False" nos servidores XMLRPC, de registro e HTTP. Isso corresponde
  ao comportamento das versões anteriores do Python, que era não
  permitir a reutilização de portas.


Núcleo e embutidos
------------------

* gh-130077: Gera corretamente erros de sintaxe personalizados quando
  for encontrada uma sintaxe incorreta contendo nomes que são prefixos
  de palavras reservadas contextuais. Patch por Pablo Galindo.

* gh-131798: Optimize _CALL_LEN in the JIT when the length is known.
  Patch by Tomas Roun

* gh-131798: Optimize "_UNARY_NEGATIVE" in JIT-compiled code.

* gh-135148: Corrigido um bug em que expressões de depuração de
  strings f (usando =) removiam incorretamente partes de strings
  contendo aspas de escape e caracteres #. Patch por Pablo Galindo.

* gh-131798: Optimize "_UNARY_INVERT" in JIT-compiled code.

* gh-131798: Optimize away "_CALL_TYPE_1" in the JIT when the return
  type is known. Patch by Tomas Roun

* gh-133136: Limita o uso excessivo de memória na construção com
  *threads livres* quando um dicionário ou lista grande é
  redimensionado e acessado por várias threads.

* gh-131798: Optimize "_CHECK_METHOD_VERSION" into
  "_CHECK_FUNCTION_VERSION_INLINE" in JIT-compiled code.


Biblioteca
----------

* gh-116738: Torna os métodos em "heapq" seguros para thread na
  construção com *threads livres*.


Núcleo e embutidos
------------------

* gh-134280: Desabilita a dobragem constante para "~" com um argumento
  booleano. Isso move o aviso de descontinuação do tempo de compilação
  para o tempo de execução.

* gh-134876: Adiciona suporte à depuração remota **PEP 768** para
  kernels Linux que não tenham CONFIG_CROSS_MEMORY_ATTACH configurado.

* gh-134889: Corrige o tratamento de alguns opcodes que deixam
  operandos na pilha ao otimizar "LOAD_FAST".


Biblioteca
----------

* gh-134908: Corrige falha ao iterar sobre linhas em um arquivo texto
  na construção com *threads livres*.


Núcleo e embutidos
------------------

* gh-117852: Fix argument checking of "athrow()".

* gh-132617: Corrige verificação de modificação "dict.update()" que
  poderia levantar incorretamente um erro "dict mutated during update"
  quando um dicionário diferente era modificado e compartilhava o
  mesmo objeto de chaves subjacente.

* gh-131798: Allow the JIT to remove unnecessary "_ITER_CHECK_TUPLE"
  ops.

* gh-134679: Corrige falha no código QSBR da construção com *threads
  livres* que poderia ocorrer ao alterar o atributo "__dict__" de um
  objeto.

* gh-133912: Corrige a função da API C "PyObject_GenericSetDict" para
  manipular classes de extensão com valores embutidos.

* gh-131798: Make the JIT optimizer understand that slicing a
  string/list/tuple returns the same type.

* gh-134584: Add a reference count elimination pass to the JIT
  compiler. Patch by Ken Jin.

* gh-131798: Optimize "_POP_CALL_TWO_LOAD_CONST_INLINE_BORROW".


Biblioteca
----------

* gh-134381: Corrige "RuntimeError" ao usar um "threading.Thread" não
  iniciado após chamar "os.fork()"


Núcleo e embutidos
------------------

* gh-127960: O shell interativo do PyREPL não inicia mais com os nomes
  globais "__package__" e "__file__" definidos como internos do pacote
  "_pyrepl". Contribuição de Yuichiro Tachibana.

* gh-130397: Remove o uso de maiúsculas e minúsculas especiais para os
  limites de profundidade da pilha C para WASI. Devido à proteção de
  pilha embutida do WebAssembly, isso não representa um problema de
  segurança.

* gh-131798: JIT: replace "_LOAD_SMALL_INT" with
  "_LOAD_CONST_INLINE_BORROW"

* gh-131798: Improve the JIT's ability to optimize away cached class
  attribute and method loads.

* gh-128066: Corrige um caso extremo em que o PyREPL levantava um erro
  incorretamente quando o Python era invocado em um sistema de
  arquivos somente leitura ao tentar gravar entradas no arquivo de
  histórico.

* gh-131798: Improve the JIT's ability to narrow unknown classes to
  constant values.

* gh-134268: Add "_POP_CALL_TWO_LOAD_CONST_INLINE_BORROW" and use it
  to further optimize "CALL_ISINSTANCE".

* gh-131798: Split "CALL_LIST_APPEND" into several uops. Patch by
  Diego Russo.

* gh-69605: Ao completar automaticamente uma importação no *REPL*, não
  encontrar candidatos agora não emite nenhuma sugestão, em vez de
  sugestões do espaço de nomes atual.

* gh-134170: Add colorization to "sys.unraisablehook()" by default.

* gh-91153: Corrige uma falha quando um "bytearray" é mutado
  simultaneamente durante a atribuição de item.

* gh-134158: Corrige a coloração de chaves duplas em f-strings e
  t-strings no *REPL*.

* gh-134119: Corrige falha ao chamar "next()" em um iterador de string
  template esgotado. Patch por Jelle Zijlstra.

* gh-134100: Corrige um bug de uso após liberação que ocorre quando um
  módulo importado não está em "sys.modules" após sua importação
  inicial. Patch por Nico-Posada.

* gh-134036: Improve "SyntaxError" message when using invalid "raise"
  statements.

* gh-133999: Corrige regressão "SyntaxError" na análise de "except"
  após gh-123440.

* gh-133886: Corrige "sys.remote_exec()" para caminhos não-ASCII em
  localidades não-UTF-8 e caminhos não-UTF-8 em localidades UTF-8.

* gh-133400: Comportamento corrigido do Ctrl+D (^D) no módulo _pyrepl
  para corresponder ao comportamento antigo do REPL pré-3.13.

* gh-133703: Corrige que a tabela de hash no dicionário pode ser maior
  do que o pretendido em algumas situações.

* gh-133778: Corrige bug onde atribuir a atributos "__annotations__"
  de classes definidas em "from __future__ import annotations" não
  tinham efeito.

* gh-133711: Implement **PEP 686**: Enable Python UTF-8 Mode by
  default. Patch by Adam Turner.

* gh-132762: "fromkeys()" não entra mais em laço infinito ao adicionar
  um pequeno conjunto de chaves a um dicionário base grande. Patch por
  Angela Liss.

* gh-133541: Indentação inconsistente na entrada do usuário travava o
  novo REPL quando o realce de sintaxe estava ativo. Isso já foi
  corrigido.

* gh-133516: Levanta "ValueError" quando as constantes "True", "False"
  ou "None" forem usadas como um identificador após a normalização
  NFKC.

* gh-131798: Allow the JIT to remove int guards after "_GET_LEN" by
  setting the return type to int.

* gh-131798: Split "CALL_ISINSTANCE" into several uops, allowing the
  JIT to remove some of them.

* gh-132554: Change iteration to use "virtual iterators" for
  sequences. Instead of creating an iterator, a tagged integer
  representing the next index is pushed to the stack above the
  iterable. For non-sequence iterators, "NULL" is pushed.

* gh-130821: Enhance wrong type error messages and make them more
  consistent. Patch by Semyon Moroz.

* gh-131798: Narrow the return type and constant-evaluate
  "CALL_ISINSTANCE" for a subset of known values in the JIT. Patch by
  Tomas Roun

* gh-132542: Atualiza "Thread.native_id" após *fork(2)* para garantir
  a precisão. Patch por Noam Cohen.


Biblioteca
----------

* gh-132732: Automatically constant evaluate bytecode operations
  marked as pure in the JIT optimizer.


Núcleo e embutidos
------------------

* gh-127971: Corrige leituras fora de um ponto além do final de uma
  string na pesquisa de string.

* gh-132042: Improve class creation times by up to 12% by pre-
  computing type slots just once. Patch by Sergey Miryanov.

* gh-133379: Correct usage of *arguments* in error messages.

* gh-127266: In the free-threaded build, avoid data races caused by
  updating type slots or type flags after the type was initially
  created.  For those (typically rare) cases, use the stop-the-world
  mechanism.  Remove the use of atomics when reading or writing type
  flags.  The use of atomics is not sufficient to avoid races (since
  flags are sometimes read without a lock and without atomics) and are
  no longer required.

* gh-130425: Add ""Did you mean: 'attr'?"" suggestion when using "del
  obj.attr" if "attr" does not exist.

* gh-128640: Corrige uma falha ao usar threads dentro de um
  subinterpretador.


Biblioteca
----------

* gh-116738: Make the module "json" safe to use under the free-
  threading build.


Núcleo e embutidos
------------------

* gh-119494: Exception text when trying to delete attributes of types
  was clarified.


API C
-----

* gh-139924: Function watchers can now receive a
  PyFunction_PYFUNC_EVENT_MODIFY_QUALNAME event when a watched
  functions qualname is changed.

* gh-111489: Add "PyTuple_FromArray()" to create a "tuple" from an
  array. Patch by Victor Stinner.

* gh-136355: Deprecate "PyConfig.bytes_warning" field and schedule its
  removal in 3.17.

* gh-138886: Remove deprecated "PySys_ResetWarnOptions()" C-API
  function.

* gh-129813: Implement **PEP 782**, the "PyBytesWriter" API. Add
  functions:

  * "PyBytesWriter_Create()"

  * "PyBytesWriter_Discard()"

  * "PyBytesWriter_FinishWithPointer()"

  * "PyBytesWriter_FinishWithSize()"

  * "PyBytesWriter_Finish()"

  * "PyBytesWriter_Format()"

  * "PyBytesWriter_GetData()"

  * "PyBytesWriter_GetSize()"

  * "PyBytesWriter_GrowAndUpdatePointer()"

  * "PyBytesWriter_Grow()"

  * "PyBytesWriter_Resize()"

  * "PyBytesWriter_WriteBytes()"

  Patch por Victor Stinner.

* gh-137956: Display and raise an exception if an extension compiled
  for non-free-threaded Python is loaded in a free-threaded
  interpreter.

* gh-137573: Marca "_PyOptimizer_Optimize" como "Py_NO_INLINE" para
  evitar travamentos de estouro de pilha no macOS.

* gh-128813: Functions "_Py_c_sum()", "_Py_c_diff()", "_Py_c_neg()",
  "_Py_c_prod()", "_Py_c_quot()", "_Py_c_pow()" and previously
  undocumented "_Py_c_abs()" are *soft deprecated*. Deprecate also
  "cval" field of the "PyComplexObject" type. Patch by Sergey B
  Kirpichev.

* gh-137210: Add API for checking an extension module's ABI
  compatibility: "Py_mod_abi", "PyABIInfo_Check()", "PyABIInfo_VAR"
  and "Py_mod_abi".

* gh-136759: Rename "lock.h" to "pylock.h" to avoid potential include
  conflicts.

* gh-112068: Reverte suporte de argumentos anuláveis em
  "PyArg_Parse()".

* gh-136006: On Solaris, the "Py_NAN" macro now expands to a "double"
  instead of a function address. Patch by Bénédikt Tran.

* gh-135075: Make "PyObject_SetAttr()" and "PyObject_SetAttrString()"
  fail if called with "NULL" value and an exception set. Patch by
  Victor Stinner.

* gh-135906: Corrige erros de construção ao compilar os cabeçalhos
  internos com um compilador C++.

* gh-133296: Novas variantes para a API da seção crítica que aceitam
  um ou dois ponteiros "PyMutex" em vez de instâncias "PyObject" agora
  são públicas na API C não limitada.

* gh-133157: Remove the private, undocumented macro
  "_Py_NO_SANITIZE_UNDEFINED".

* gh-134989: Corrige as macros "Py_RETURN_NONE", "Py_RETURN_TRUE" e
  "Py_RETURN_FALSE" na API C limitada 3.11 e anteriores: não trata
  "Py_None", "Py_True" e "Py_False" como imortais. Patch por Victor
  Stinner.

* gh-134989: Implementa "PyObject_DelAttr()" e
  "PyObject_DelAttrString()" como macros na API C limitada 3.12 e
  anteriores. Patch por Victor Stinner.

* gh-134745: Change "PyThread_allocate_lock()" implementation to
  "PyMutex". On Windows, "PyThread_acquire_lock_timed()" now supports
  the *intr_flag* parameter: it can be interrupted. Patch by Victor
  Stinner.

* gh-134891: Add "PyUnstable_Unicode_GET_CACHED_HASH" to get the
  cached hash of a string.

* gh-134009: Expõe "PyMutex_IsLocked()" como parte da API C pública.

* gh-134144: Corrige falha ao chamar "Py_EndInterpreter()" com um
  *estado de thread* que não é a thread inicial do interpretador.

* gh-133968: Adiciona a função "PyUnicodeWriter_WriteASCII()" para
  escrever uma string ASCII em um "PyUnicodeWriter". A função é mais
  rápida que "PyUnicodeWriter_WriteUTF8()", mas tem um comportamento
  indefinido se a string de entrada contiver caracteres não ASCII.
  Patch por Victor Stinner.

* gh-133644: Remove deprecated Python initialization getter functions
  "Py_Get*". Patch by Bénédikt Tran.

* gh-133644: Remove deprecated function "PyWeakref_GetObject()" and
  macro "PyWeakref_GET_OBJECT". Use "PyWeakref_GetRef()" instead.
  Patch by Bénédikt Tran.

* gh-133644: Remove deprecated alias "PyImport_ImportModuleNoBlock()"
  of "PyImport_ImportModule()". Patch by Bénédikt Tran.

* gh-133610: Remove deprecated functions
  "PyUnicode_AsDecodedObject()", "PyUnicode_AsDecodedUnicode()",
  "PyUnicode_AsEncodedObject()", and "PyUnicode_AsEncodedUnicode()".

* gh-132629: For unsigned integer formats in "PyArg_ParseTuple()",
  accepting Python integers with value that is larger than the maximal
  value for the C type or less than the minimal value for the
  corresponding signed integer type of the same size is now
  deprecated.

* gh-131185: "PyGILState_Ensure()" no longer crashes when called after
  interpreter finalization.

* gh-108512: Add functions "PySys_GetAttr()", "PySys_GetAttrString()",
  "PySys_GetOptionalAttr()" and "PySys_GetOptionalAttrString()".


Construção
----------

* gh-138489: Ao fazer compilação cruzada para WASI por "build_wasm" ou
  "build_emscripten", a etapa "build-details.json" agora é incluída no
  processo de construção, assim como nas construções nativas.

  Isso corrige a tarefa "libinstall" que requer o arquivo "build-
  details.json" durante o processo.

* gh-138497: The LLVM version used by the JIT at build time can now be
  modified using the "LLVM_VERSION" environment variable. Use this at
  your own risk, as there is only one officially supported LLVM
  version. For more information, please check "Tools/jit/README.md".

* gh-95952: When cross-compiling for WASI, require that the HOSTRUNNER
  environment variable be explicitly set.

  This was needed as macOS lacks the appropriate CLI tools to set a
  reasonable default.

* gh-138061: Ensure reproducible builds by making JIT stencil header
  generation deterministic.

* gh-128042: "./configure" now warns when "--enable-optimizations" and
  "CFLAGS=-O0" are both set, suggesting removing "-O0" from "CFLAGS"
  for optimal performance.  Patch by Taegyun Kim.

* gh-132339: Adiciona suporte para OpenSSL 3.5.

* gh-135621: O PyREPL não depende mais da biblioteca padrão "curses".
  Contribuição de Łukasz Langa.

* gh-135927: Fix building with MSVC when passing option
  "/std:clatest".

* gh-119132: Remove a tag "experimental" da construção com threads
  livres do CPython.

* gh-135497: Corrige a detecção de "MAXLOGNAME" no script
  "configure.ac".

* gh-134923: As construções do Windows com otimização guiada por
  perfil habilitada agora usam "/GENPROFILE" e "/USEPROFILE" em vez
  das opções descontinuadas "/LTCG:".

* gh-134632: Corrigida a geração de "build-details.json" para usar
  "INCLUDEPY", a fim de referenciar o subdiretório "pythonX.Y" do
  diretório include, conforme exigido em **PEP 739**, em vez do
  diretório include de nível superior.

* gh-134486: The "ctypes" module now performs a more portable test for
  the definition of *alloca(3)*, fixing a compilation failure on
  NetBSD.

* gh-134455: Corrigida a geração de "build-details.json" para usar o
  "c_api.headers" correto, conforme definido em **PEP 739**, em vez de
  "c_api.include".

* gh-134273: Adiciona suporte para configurar sinalizadores do
  compilador para o JIT com "CFLAGS_JIT"

* gh-115119: Removed implicit fallback to the bundled copy of the
  "libmpdec" library. Now this should be explicitly enabled via "--
  with-system-libmpdec" set to "no" or "--without-system-libmpdec".
  Patch by Sergey B Kirpichev.

* gh-131769: Corrige a detecção de quando a construção Python em uma
  construção cruzada é uma construção de pydebug.

* gh-117088: O ligador AIX não oferece suporte à opção -h, portanto,
  evita-a por meio da verificação da plataforma

* gh-123681: Verifica o comportamento de "strftime()" em tempo de
  execução, em vez de em tempo de compilação, para oferecer suporte à
  compilação cruzada. Remove a macro interna "_Py_NORMALIZE_CENTURY".

* gh-127545: Fix crash when building on Linux/m68k.


Python 3.14.0 beta 1
====================

*Data de lançamento: 2025-05-06*


Windows
-------

* gh-132930: Marca o instalador para Windows como descontinuado e
  atualiza a documentação para abranger o novo gerenciador de
  instalação do Python.

* gh-127405: Adiciona "ABIFLAGS" a "sysconfig.get_config_vars()" no
  Windows. Patch por Xuehai Pan.


Ferramentas/Demos
-----------------

* gh-130453: Permite a passagem de múltiplos argumentos nomeados com o
  mesmo nome de função em **pygettext**.

* gh-130195: Adiciona mensagens de aviso quando a opção não
  implementada "-a/--extract-all" do **pygettext** for chamada.


Testes
------

* gh-133131: O ambiente de testes do iOS agora selecionará o
  dispositivo "classe SE" lançado mais recentemente para testes, caso
  um dispositivo não seja especificado explicitamente.

* gh-91048: Adiciona a capacidade de inspecionar externamente todas as
  tarefas asyncio pendentes, mesmo que nenhuma tarefa esteja inserida
  no laço de eventos.

* gh-109981: O auxiliar de teste que conta a lista de descritores de
  arquivo abertos agora usa a abordagem otimizada "/dev/fd" em todas
  as plataformas Apple, não apenas no macOS. Isso evita travamentos
  causados por descritores de arquivo protegidos.

* gh-132678: Adiciona "--prioritize" a "-m test". Esta opção permite
  ao usuário especificar quais testes selecionados devem ser
  executados primeiro, mesmo que a ordem seja aleatória. Isso é
  particularmente útil para testes que demoram mais tempo para serem
  executados.

* gh-131290: Os testes em "Lib/test" agora podem ser executados
  corretamente como scripts independentes.


Segurança
---------

* gh-115322: Os módulos de extensão subjacentes a "readline":,
  "subprocess" e "ctypes" agora levantam eventos de auditoria em
  caminhos de código previamente descobertos, que podem levar ao
  acesso ao sistema de arquivos relacionado à chamada de função C e à
  execução de binários externos. O gancho de auditoria
  "ctypes.call_function" também foi corrigido para usar um valor sem
  sinal para seu "function pointer".


Biblioteca
----------

* gh-133490: Adiciona suporte de cores ao PDB no modo remoto.

* gh-132493: Evita avaliar ansiosamente anotações em funções decoradas
  com "reprlib.recursive_repr()".

* gh-130645: Adiciona cor às CLIs de argparse da stdlib. Patch por
  Hugo van Kemenade.

* gh-119180: Faz com que "annotationlib.get_annotations()" tenha
  sucesso com o formato "FORWARDREF" se a avaliação das anotações
  gerar uma exceção diferente de "NameError" ou "AttributeError".

* gh-133351: Corrige o PDB remoto para solicitar corretamente a
  conclusão de tabulações para expressões Python do servidor ao
  concluir uma linha de continuação de um bloco Python de várias
  linhas.

* gh-133367: Adiciona as opções "--feature-version", "--optimize" e "
  --show-empty" à interface de linha de comando "ast". Patch por
  Semyon Moroz.

* gh-133363: A classe "cmd.Cmd" foi corrigida para chamar de forma
  confiável o método "completedefault" sempre que o método "do_shell"
  não estiver definido e a conclusão da tabulação for solicitada para
  uma linha que começa com "!".

* gh-113081: Realça a sintaxe no código-fonte em "pdb".

* gh-133349: Introduzida a indentação automática na entrada multilinha
  "pdb".

* gh-133306: Usa "\z" em vez de "\Z" em "fnmatch.translate()" e
  "glob.translate()".

* gh-133306: Suporte a "\z" como sinônimo de "\Z" em "expressões
  regulares".

* gh-133300: Torna "suggest_on_error" de "argparse.ArgumentParser" um
  parâmetro somente-nomeado. Patch por Hugo van Kemenade.

* gh-133290: Corrige problema de armazenamento em cache de atributo ao
  definir "ctypes._Pointer._type_" na função não documentada e
  descontinuada "ctypes.SetPointerType()" e no método não documentado
  "set_type()".

* gh-133223: Quando o PDB estiver anexado a um processo remoto, faz um
  trabalho melhor de interceptar Ctrl+C e encaminhá-lo ao processo
  remoto.

* gh-133153: Não conclui os comandos "pdb" no modo "interact" do
  "pdb".

* gh-133139: Adiciona a função "curses.assume_default_colors()", um
  refinamento da função "curses.use_default_colors()" que permite
  alterar o par de cores "0".

* gh-133089: Usa o valor de tempo limite original para
  "subprocess.TimeoutExpired" quando a função "subprocess.run()" for
  chamada com um tempo limite em vez de, às vezes, um valor de tempo
  limite parcial restante confuso usado internamente no "wait()"
  final.

* gh-133036: "codecs.open()" está descontinuada. Em vez disso, use
  "open()". Contribuição de Inada Naoki.

* gh-132987: Muitas funções embutidas e de extensão que aceitam um
  argumento inteiro sem sinal agora usam "__index__()" se disponível.

* gh-124703: Define o código de retorno como "1" ao abortar o processo
  de "pdb".

* gh-133005: Suporte à passagem da opção "preset" para
  "tarfile.open()" ao usar o modo "'w|xz'".

* gh-115032: O suporte para manipuladores de registro personalizados
  com o argumento *strm* foi descontinuado e está programado para ser
  removido no Python 3.16. Em vez disso, defina manipuladores com o
  argumento *stream*. Patch por Mariusz Felisiak.

* gh-132991: Adiciona a constante "socket.IP_FREEBIND" no Linux 2.4 e
  posteriores.

* gh-132995: Aumenta a versão do pip incluído no EnsurePip para a
  versão 25.1.1

* gh-132933: O módulo zipapp agora aplica o filtro ao criar a lista de
  arquivos a serem adicionados, em vez de esperar até que o arquivo
  seja adicionado ao arquivo.

* gh-121249: Sempre suporte os tipos C float complex e double complex
  no módulo "struct". Patch por Sergey B Kirpichev.

* gh-132915: "fcntl.fcntl()" e "fcntl.ioctl()" agora podem detectar um
  estouro de buffer e levantar "SystemError". A pilha e a memória
  podem ser corrompidas nesse caso, portanto, trata esse erro como
  fatal.

* gh-132017: Corrige erro quando "pyrepl" é suspenso e depois retomado
  e encerrado.

* gh-132893: Precisão aprimorada de "statistics.NormalDist.cdf()" para
  entradas menores que a média.

* gh-130328: Aceleração da colagem em "PyREPL" no Windows. Correção
  por Chris Eibl.

* gh-132882: Corrige a cópia de objetos "typing.Union" contendo
  objetos que não oferecem o suporte ao operador "|".

* gh-93696: Corrigido o erro de exibição do ponto de interrupção para
  módulos congelados em "pdb".

* gh-129965: Adiciona tipos MIME para ".7z", ".apk", ".deb", ".glb",
  ".gltf", ".gz", ".m4v", ".php", ".rar", ".rpm", ".stl" e ".wmv".
  Patch por Hugo van Kemenade.

* gh-132742: "fcntl.fcntl()" agora oferece suporte a *objetos bytes ou
  similares* arbitrários, não apenas "bytes". "fcntl.ioctl()" agora
  tenta novamente chamadas de sistema que falham com EINTR e libera a
  GIL durante uma chamada de sistema, mesmo para grandes objetos bytes
  ou similares.

* gh-132451: A CLI do depurador PDB agora aceita o argumento "-p PID"
  para permitir a anexação a um processo em execução. O processo deve
  estar executando a mesma versão do Python que o PDB.

* gh-125618: Adiciona um parâmetro *format* a
  "annotationlib.ForwardRef.evaluate()". A avaliação de anotações no
  formato "FORWARDREF" agora é bem-sucedida em mais casos que antes
  levantavam uma exceção.

* gh-132805: Corrige tratamento incorreto de valores não constantes
  aninhados no formato FORWARDREF em "annotationlib".

* gh-132734: Adiciona novas constantes para Bluetooth "sockets".

* gh-132673: Corrige "AssertionError" levantada em "ctypes.Structure"
  com "_align_ = 0" e "_fields_ = []".

* gh-132578: Renomeia o campo "threading.Thread._handle" para evitar
  sombrear métodos definidos em subclasses de "threading.Thread".

* gh-132561: Corrige o método público "locked" da classe
  "multiprocessing.SemLock". Adiciona também 2 testes para as classes
  derivadas "multiprocessing.Lock" e "multiprocessing.RLock".

* gh-121468: Adiciona a função "pdb.set_trace_async()" para oferece
  suporte a instruções "await" em "pdb".

* gh-132493: "typing.Protocol" agora usa
  "annotationlib.get_annotations()" ao verificar se uma instância
  implementa ou não o protocolo com "isinstance()". Isso habilita o
  suporte para verificações "isinstance" em classes com anotações
  adiadas.

* gh-132536: Não desabilitar o evento "PY_THROW" em "bdb" porque ele
  não pode ser desabilitado.

* gh-132527: Inclui o typecode válido 'w' na mensagem de erro quando
  um typecode inválido for passado para "array.array".

* gh-132099: O soquete Bluetooth com o protocolo "BTPROTO_HCI" no
  Linux agora aceita um endereço no formato de um inteiro "device_id",
  não apenas uma tupla "(device_id,)".

* gh-81793: Corrige "os.link()" em plataformas (como Linux) onde a
  função de sistema "link()" não segue links simbólicos. No Linux,
  agora ela segue links simbólicos por padrão ou se
  "follow_symlinks=True" for especificado. No Windows, agora levanta
  um erro se "follow_symlinks=True" for passado. No macOS, agora
  levanta um erro se "follow_symlinks=False" for passado e a função de
  sistema "linkat()" não estiver disponível em tempo de execução.

* gh-132493: Suporte à criação de classes "typing.Protocol" com
  anotações que não podem ser resolvidas no momento da criação da
  classe.

* gh-132491: Renomeia "annotationlib.value_to_string" para
  "annotationlib.type_repr()" e forneça melhor tratamento para objetos
  função.

* gh-132426: Adiciona
  "annotationlib.get_annotate_from_class_namespace()" como um auxiliar
  para acessar anotações em metaclasses e remova
  "annotationlib.get_annotate_function".

* gh-70145: Adiciona suporte para canais no protocolo Bluetooth HCI
  ("BTPROTO_HCI").

* gh-131913: Adiciona uma função de atalho
  "multiprocessing.Process.interrupt()" junto com as existentes
  "multiprocessing.Process.terminate()" e
  "multiprocessing.Process.kill()" para um controle melhorado sobre o
  término do processo filho.

* gh-132439: Corrigido "PyREPL" no Windows: caracteres inseridos via
  AltGr são engolidos. Patch por Chris Eibl.

* gh-132429: Corrige o suporte a soquetes Bluetooth no NetBSD e no
  DragonFly BSD. Adiciona suporte para *cid* e *bdaddr_type* no
  endereço BTPROTO_L2CAP no FreeBSD. Retorna *cid* em "getsockname()"
  para BTPROTO_L2CAP se for diferente de zero.

* gh-132106: "QueueListener.start" agora levanta uma "RuntimeError" se
  o listener já estiver iniciado.

* gh-132417: Corrige uma desreferência de ponteiro "NULL" quando uma
  função C chamada usando "ctypes" com "restype" "py_object" retorna
  "NULL".

* gh-132385: Corrige sugestões de erro de instância que acionam
  possíveis exceções em "object.__getattr__()" em "traceback".

* gh-125866: Adiciona o argumento opcional *add_scheme* a
  "urllib.request.pathname2url()"; quando definido como verdadeiro,
  uma URL completa é retornada. Da mesma forma, adicione o argumento
  opcional *require_scheme* a "url2pathname()"; quando definido como
  verdadeiro, uma URL completa é aceita.

* gh-132308: Uma exceção "traceback.TracebackException" agora
  renderiza corretamente os atributos "__context__" e "__cause__" da
  "Exception" falsa, e o atributo "exceptions" de falsey
  "ExceptionGroup".

* gh-130645: Adiciona cor à saída de ajuda do "argparse". Patch por
  Hugo van Kemenade.

* gh-127495: No PyREPL, adicione uma nova entrada ao arquivo
  "PYTHON_HISTORY" *após* cada instrução. Isso deve preservar o
  histórico da linha de comando após o encerramento do interpretador.
  Patch por Sergey B Kirpichev.

* gh-129463: A comparação de objetos "annotationlib.ForwardRef" não
  usa mais os atributos internos "__code__" e "__ast_node__", que são
  usados como caches.

* gh-132250: Fixed the "SystemError" in "cProfile" when locating the
  actual C function of a method raises an exception.

* gh-132064: "annotationlib.get_annotations()" agora usa o atributo
  "__annotate__" se estiver presente, mesmo que "__annotations__" não
  esteja presente. Além disso, a função agora levanta uma exceção
  "TypeError" se for passado um objeto que não possui nenhuma
  anotação.

* gh-130664: Suporte ao separador de dígitos "'_'" na formatação da
  parte integral de "Decimal"'s. Patch por Sergey B Kirpichev.

* gh-131952: Adiciona a saída de cor à CLI **json**. Patch por Tomas
  Roun.

* gh-132063: Evita que exceções avaliadas como falsas (ou seja, quando
  o método "__bool__" retorna "False" ou o método "__len__" retorna 0)
  sejam ignoradas por "concurrent.futures.ProcessPoolExecutor" e
  "concurrent.futures.ThreadPoolExecutor".

* gh-132106: "logging.handlers.QueueListener" agora implementa o
  protocolo do gerenciador de contexto, permitindo que ele seja usado
  em uma instrução "with".

* gh-132054: O tipo mime "application/yaml" (**RFC 9512**) agora é
  suportado por "mimetypes". Patch por Sasha "Nelie" Chernykh e Hugo
  van Kemenade.

* gh-119605: Respeita "follow_wrapped" para os métodos "__init__()" e
  "__new__()" ao obter a assinatura de classe para uma classe com
  "inspect.signature()". Preserva a assinatura de classe após o
  encapsulamento com "warnings.deprecated()". Patch por Xuehai Pan.

* gh-118761: Melhora o tempo de importação do módulo "shlex" em até
  33x e o desempenho de "shlex.quote()" em até 12x. Patch por Adam
  Turner.

* gh-85302: Adiciona suporte para "BTPROTO_SCO" em soquetes no
  FreeBSD.

* gh-131757: Faz com que "functools.lru_cache()" chame a função
  destravada em cache para permitir a simultaneidade.

* gh-131423: "ssl" pode exibir descrições de erros adicionados no
  OpenSSL 3.4.1. Patch por Bénédikt Tran.

* gh-131434: Melhora o relatório de erros para formato incorreto em
  "time.strptime()".

* gh-131524: Adicionada mensagem de ajuda à interface de linha de
  comando "platform". Contribuição de Harry Lees.

* gh-100926: Move o cache dos tipos "ctypes.POINTER()" de um cache
  interno global ("_pointer_type_cache") para o atributo
  "ctypes._CData.__pointer_type__" dos tipos "ctypes" correspondentes.
  Isso impedirá que o cache cresça sem limites em algumas situações.

* gh-85702: Se "zoneinfo._common.load_tzdata" receber um pacote sem um
  recurso, uma "ZoneInfoNotFoundError" será levantada em vez de uma
  "IsADirectoryError".

* gh-123471: Torna as iterações simultâneas sobre "itertools.repeat"
  seguras sob threads livres

* gh-131127: Sistemas que usam LibreSSL agora são construídos com
  sucesso.

* gh-89157: Cria a implementação Python pura de
  "datetime.date.fromisoformat()", aceitando apenas strings ASCII para
  consistência com a implementação C.

* gh-130941: Corrige "configparser.ConfigParser" analisando
  interpolação vazia com "allow_no_value" definido como "True".

* gh-110067: Torna públicas as funções max-heap
  "heapq""heapq.heapify_max()", "heapq.heappush_max()",
  "heapq.heappop_max()" e "heapq.heapreplace_max()". A nomenclatura
  sublinhada anterior foi mantida para retrocompatibilidade. Além
  disso, a função ausente "heapq.heappushpop_max()" foi adicionada às
  implementações em C e Python.

* gh-129098: Corrige o relatório de traceback do REPL ao usar
  "compile()" com um arquivo inexistente. Patch por Bénédikt Tran.

* gh-130631: "http.cookiejar.join_header_words()" agora é mais
  semelhante à versão original do Perl. Agora, ele coloca aspas o
  mesmo conjunto de caracteres e sempre coloca aspas em valores que
  terminam com ""\n"".

* gh-130482: Adiciona a capacidade de especificar o nome para
  "tkinter.OptionMenu" e "tkinter.ttk.OptionMenu".

* gh-77065: Adiciona o argumento somente-nomeado opcional *echo_char*
  para "getpass.getpass()" para suporte opcional ao feedback visual do
  teclado. Patch por Semyon Moroz.

* gh-130317: Corrige "PyFloat_Pack2()" e "PyFloat_Unpack2()" para NaNs
  com payload. Isso corrige a idea e volta para "struct.unpack()" e
  "struct.pack()" no caso do tipo IEEE 754 binary16 de "meia
  precisão". Patch por Sergey B Kirpichev.

* gh-130402: A união de threads de daemon em execução durante o
  desligamento do interpretador agora levanta
  "PythonFinalizationError".

* gh-130167: Melhoria na velocidade de "difflib.IS_LINE_JUNK()". Patch
  por Semyon Moroz.

* gh-101410: Adicionadas mensagens mais detalhadas para erros de
  domínio no módulo "math".

* gh-128384: Make "warnings.catch_warnings" use a context variable for
  holding the warning filtering state if the
  "sys.flags.context_aware_warnings" flag is set to true.  This makes
  using the context manager thread-safe in multi-threaded programs.
  The flag is true by default in free-threaded builds and is otherwise
  false. The value of the flag can be overridden by the "-X
  context_aware_warnings" command-line option or by the
  "PYTHON_CONTEXT_AWARE_WARNINGS" environment variable.

* gh-129719: Corrige a constante "socket.CAN_RAW_ERR_FILTER" ausente
  no módulo socket em sistemas Linux. Ela estava ausente desde o
  Python 3.11.

* gh-129027: Levanta "DeprecationWarning" para
  "sys._clear_type_cache()". Esta função foi descontinuada no Python
  3.13, mas não levanta um aviso em tempo de execução.

* gh-128307: Adiciona o argumento nomeado "eager_start" a
  "asyncio.loop.create_task()"

* gh-127604: Adiciona suporte para exibir o stack trace (situação da
  pilha de execução) C em sistemas que oferece suporte a ele via
  "faulthandler.dump_c_stack()" ou via argumento *c_stack* em
  "faulthandler.enable()".

* gh-127385: Adiciona a constante "F_DUPFD_QUERY" ao módulo "fcntl".

* gh-126838: Adiciona o parâmetro somente-nomeado *resolve_host* a
  "urllib.request.url2pathname()" e corrige o tratamento de URLs de
  arquivo com autoridades.

* gh-82129: Corrige "NameError" ao chamar "typing.get_type_hints()" em
  uma "dataclasses.dataclass()" criado por
  "dataclasses.make_dataclass()" com campos não anotados.

* gh-122559: Remove os métodos "__reduce__()" e "__reduce_ex__()" que
  sempre levantam "TypeError" na implementação em C de "io.FileIO",
  "io.BufferedReader", "io.BufferedWriter" e "io.BufferedRandom" e
  substitua-os pelos métodos padrão "__getstate__()" que levantam
  "TypeError". Isso restaura detalhes precisos do comportamento do
  Python 3.11 e versões anteriores.

* gh-122179: "hashlib.file_digest()" agora levanta "BlockingIOError"
  quando não há dados disponíveis durante E/S não bloqueantes. Antes,
  ele adicionava bytes nulos espúrios ao resumo.

* gh-53032: Expõe "decimal.IEEEContext()" para oferecer suporte à
  criação de contextos correspondentes aos formatos de intercâmbio
  decimal do IEEE 754 (2008). Patch por Sergey B Kirpichev.

* gh-120220: Descontinua os métodos "trace_variable()",
  "trace_vdelete()" e "trace_vinfo()" de "tkinter.Variable". Os
  métodos "trace_add()", "trace_remove()" e "trace_info()" podem ser
  usados em seu lugar.

* gh-113539: "webbrowser": Os nomes na variável de ambiente "BROWSER"
  agora podem se referir a navegadores web já registrados, em vez de
  sempre gerar um novo comando do navegador.

  Isso torna possível definir "BROWSER" como o valor de um dos
  navegadores suportados no macOS.

* bpo-44172: Mantém uma referência às janelas originais "curses" nas
  subjanelas para que a janela original não seja excluída antes das
  subjanelas.

* gh-75223: Descontinua extensões sem pontos em
  "mimetypes.MimeTypes.add_type()". Patch por Hugo van Kemenade.


IDLE
----

* gh-112936: corrige IDLE: nenhum item de menu Shell no modo de
  processo único.


Documentação
------------

* gh-107006: Move a documentação e o código de exemplo para
  "threading.local" da docstring para a documentação oficial.

* gh-125142: Como parte do texto de introdução da ajuda embutida,
  mostre os atalhos de teclado para o novo REPL não básico (F1, F2 e
  F3).


Núcleo e embutidos
------------------

* gh-133336: "-J" não está mais reservado para uso do Jython. Patch
  por Adam Turner.

* gh-133261: Corrige um bug em que o ciclo GC não conseguia rastrear
  objetos na lixeira porque eles pareciam imortais. Quando objetos são
  adicionados à lixeira, tomamos cuidado para garantir que eles
  mantenham uma contagem de referências mortal.

* gh-133346: Adicionado suporte experimental para temas de cores ao
  módulo "_colorize".

* gh-132917: Para a construção com threads livres, verifica o aumento
  no uso de memória do processo antes de acionar uma coleta de lixo
  automática completa. Se a memória usada não tiver aumentado 10%
  desde a última coleta, adia-a.

* gh-91048: Adiciona uma nova interface de linha de comando "python -m
  asyncio ps PID" para inspecionar tarefas assíncronas em um processo
  Python em execução. Exibe uma tabela simples de relacionamentos de
  espera. Uma variante que mostra uma visualização em árvore também
  está disponível como "python -m asyncio pstree PID". Ambas são úteis
  para depuração de código assíncrono. Patch por Pablo Galindo, Łukasz
  Langa, Yury Selivanov e Marta Gomez Macias.

* gh-133304: Solução alternativa para a "canonização" do NaN em
  "PyFloat_Pack4()" e "PyFloat_Unpack4()" no RISC-V.

* gh-133197: Melhora as mensagens de erro "SyntaxError" para prefixos
  de strings / bytes incompatíveis.

* gh-133231: Adiciona novos utilitários de observação da compilação
  JIT: "sys._jit.is_available()", "sys._jit.is_enabled()" e
  "sys._jit.is_active()".


Biblioteca
----------

* gh-133194: "ast.parse()" não analisará mais a nova sintaxe **PEP
  758** com a *feature_version* mais antiga passada.


Núcleo e embutidos
------------------

* gh-131798: Divide "CALL_LEN" em vários UOPs, permitindo que o JIT os
  remova durante a otimização. Patch por Diego Russo.

* gh-131798: Usa "sym_new_type" em vez de "sym_new_not_null" para
  _BUILD_STRING, _BUILD_SET

* gh-132942: Corrige duas corridas no cache de pesquisa de tipos. Isso
  afetava a construção com threads livres e podia causar travamentos
  (aparentemente bastante difíceis de acionar).

* gh-131798: Propaga o tipo de retorno de
  "_BINARY_OP_SUBSCR_TUPLE_INT" em JIT. Patch por Tomas Roun

* gh-132952: Acelera a inicialização com o argumento "-S" importando o
  módulo privado "_io" em vez de "io". Isso corrige uma regressão de
  desempenho introduzida anteriormente no desenvolvimento do Python
  3.14 e restaura o desempenho ao nível do Python 3.13.

* gh-131798: Permite que o JIT remova as proteções int após
  "_CALL_LEN" definindo o tipo de retorno como int. Patch por Diego
  Russo

* gh-131798: Divide "CALL_TUPLE_1" em vários UOPs, permitindo que o
  JIT remova alguns deles. Patch por Tomas Roun

* gh-131798: Divide "CALL_STR_1" em vários UOPs, permitindo que o JIT
  remova alguns deles. Patch por Tomas Roun

* gh-132825: Melhorias nas mensagens de erro de chaves/elementos não
  fragmentáveis para "dict" e "set". Patch por Victor Stinner.

* gh-131591: Redefine qualquer chamada pendente de depuração remota
  **PEP 768** em filhos após chamadas "os.fork()".

* gh-132713: Corrige a condição de corrida "repr(list)": mantém uma
  referência forte ao item ao chamar "repr(item)". Patch por Victor
  Stinner.

* gh-132661: Implementa **PEP 750** (Template Strings). Adiciona nova
  sintaxe para t-strings e implementa novos tipos internos
  "string.templatelib.Template" e "string.templatelib.Interpolation".

* gh-132479: Corrige travamento do compilador em determinadas
  circunstâncias em que várias anotações em nível de módulo incluem
  compreensões e outros escopos aninhados.

* gh-132747: Corrige uma falha ao chamar "__get__()" de um *method*
  com um segundo argumento "None".

* gh-132744: Certas chamadas agora verificam a recursão descontrolada
  e respeitam o limite de recursão do sistema.

* gh-132449: Erros de sintaxe que parecem erros de ortografia de
  palavra reservada do Python agora oferecem uma sugestão útil de
  correção. Contribuição de Pablo Galindo Salgado.


Biblioteca
----------

* gh-132737: Suporte a código de criação de perfil que requer
  "__main__", como "pickle".


Núcleo e embutidos
------------------

* gh-132639: Adicionadas "PyLong_AsNativeBytes()",
  "PyLong_FromNativeBytes()" e "PyLong_FromUnsignedNativeBytes()" à
  API C limitada.

* gh-100239: Adiciona especialização para "BINARY_OP/SUBSCR" na lista
  e no fatiamento.

* gh-132508: Utiliza inteiros marcados na pilha de avaliação para
  representar os deslocamentos de instrução ao levantar novamente uma
  exceção. Isso evita a necessidade de encapsular o inteiro, o que
  poderia falhar em condições de pouca memória.

* gh-124476: Corrige decodificação da codificação local no local
  C.UTF-8.

* gh-131927: Avisos do compilador originados do mesmo módulo e número
  de linha agora são emitidos apenas uma vez, correspondendo ao
  comportamento dos avisos emitidos pelo código do usuário. Isso
  também pode ser configurado com filtros "warnings".

* gh-132457: Torna "staticmethod()" e "classmethod()" genéricos.

* gh-131798: Usa "sym_new_type" em vez de "sym_new_not_null" para
  _BUILD_LIST, _BUILD_SET, _BUILD_MAP

* gh-131798: Divide "CALL_TYPE_1" em vários uops, permitindo que o JIT
  remova alguns deles.

* gh-132386: Corrige falha ao passar uma subclasse dict como parâmetro
  "globals" para "exec()".

* gh-127682: Não é mais necessário chamar "__iter__" duas vezes ao
  criar e executar uma expressão geradora. A criação de uma expressão
  geradora a partir de uma expressão não iterável só será levantada
  quando a expressão geradora for executada. Isso alinha o
  comportamento das expressões geradoras com outros geradores.

* gh-132261: O armazenamento interno para anotações e funções de
  anotação em classes agora usa chaves diferentes no dicionário de
  classes. Isso elimina vários casos extremos em que o acesso aos
  atributos "__annotate__" e "__annotations__" se comportaria de forma
  imprevisível.

* gh-132284: Não envolve slots base "PyCFunction" na criação da classe
  se não forem substituídos.

* gh-130415: Melhora a capacidade do JIT de remover cargas constantes
  e variáveis locais não utilizadas e corrige um problema em que a
  desalocação de valores não utilizados poderia fazer com que o código
  JIT travasse ou se comportasse incorretamente.

* gh-126703: Corrige possível uso após free em casos em que a
  definição de um método tem o mesmo tempo de vida que seu "self".

* gh-132286: Corrige que "type.__annotate__" não foi excluído quando
  "type.__annotations__" foi excluído.

* gh-131798: Permite que o JIT remova uma instrução extra
  "_TO_BOOL_BOOL" após "_CONTAINS_OP_DICT" definindo o tipo de retorno
  como bool.

* gh-124715: Evita estouros de pilha ao chamar "Py_DECREF()". Objetos
  de extensão de terceiros não precisam mais usar o mecanismo de
  "lixeira", pois a proteção agora está incorporada à macro
  "Py_DECREF()".

* gh-131798: Permite que o compilador JIT remova algumas verificações
  de tipo para operações em listas, tuplas, dicionários e conjuntos.

* gh-128398: Melhoria na mensagem de erro quando um objeto que ofereça
  suporte ao protocolo de gerenciador de contexto síncrono (ou
  assíncrono) é inserido usando "async with" (ou seja, "with") em vez
  de "with" (ou seja, "async with"). Patch por Bénédikt Tran.

* gh-131798: Permite que o JIT remova as proteções Unicode após
  "_BINARY_OP_SUBSCR_STR_INT" definindo o tipo de retorno como string.

* gh-131878: Trata exceções não capturadas no laço de entrada
  principal para o novo REPL.

* gh-131878: Corrige suporte a caracteres Unicode com dois ou mais
  pontos de código no Windows no novo REPL.

* gh-126835: Move a dobragem de constante para o otimizador de olho
  mágico. Renomeia os arquivos relacionados à otimização AST
  (Python/ast_opt.c -> Python/ast_preprocess.c), structs
  (_PyASTOptimizeState -> _PyASTPreprocessState) e funções
  (_PyAST_Optimize -> _PyAST_Preprocess, _PyCompile_AstOptimize ->
  _PyCompile_AstPreprocess).

* gh-114809: Adiciona suporte para construções multiarquitetura do
  macOS com o JIT habilitado

* gh-131507: O PyREPL agora oferece suporte a realce de sintaxe.
  Contribuição de Łukasz Langa.

* gh-130907: Se as "__annotations__" de um objeto de módulo forem
  acessadas enquanto o módulo estiver em execução, retorne as
  anotações que foram definidas até agora, sem armazená-las em cache.

* gh-130104: "pow()" de três argumentos agora tenta chamar
  "__rpow__()" se necessário. Anteriormente, ele só era chamado em
  "pow()" de dois argumentos e no operador binário de potência.

* gh-130070: Corrigido um erro de asserção para "exec()" passando uma
  string "source" e uma "closure" não "None". Patch por Bartosz
  Sławecki.

* gh-129958: Corrige um bug que permitia quebras de linha
  inconsistentes em especificadores de formato para f-strings entre
  aspas simples. Patch por Pablo Galindo.

* gh-129858: instruções "elif" que seguem um bloco "else" agora têm
  uma mensagem de erro específica.

* gh-69605: Adiciona o módulo autocomplete ao PyREPL.

* gh-128555: Adiciona o sinalizador
  "sys.flags.thread_inherit_context".

  * Este sinalizador é definido como verdadeiro por padrão na
    construção com threads livres e como falso caso contrário. Se o
    sinalizador for verdadeiro, iniciar uma nova thread usando
    "threading.Thread" usará, por padrão, uma cópia de
    "contextvars.Context" do chamador de "threading.Thread.start()" em
    vez de usar um contexto vazio.

  * Adiciona a opção de linha de comando "-X thread_inherit_context" e
    a variável de ambiente "PYTHON_THREAD_INHERIT_CONTEXT", que
    definem o sinalizador "thread_inherit_context".

  * Adiciona o parâmetro nomeado "context" a "Thread". Ele pode ser
    usado para passar explicitamente um valor de contexto a ser usado
    por uma nova thread.

  * Torna o módulo "_contextvars" embutido.

* gh-123539: Melhora a mensagem "SyntaxError" para usar "import ...
  as" e "from ... import ... as" sem um nome.

* gh-102567: "-X importtime" agora aceita o valor "2", que indica que
  uma entrada "importtime" também deve ser impressa se um módulo
  importado já tiver sido carregado. Patch por Noah Kim e Adam Turner.

* gh-116436: Melhora a mensagem de erro quando "TypeError" ocorre
  durante "dict.update()"

* gh-103997: String arguments passed to "-c" are now automatically
  dedented. This allows "python -c" invocations to be indented in
  shell scripts without causing indentation errors. (Patch by Jon
  Crall and Steven Sun)


Biblioteca
----------

* gh-89562: Remove o membro "hostflags" da struct "PySSLContext".


API C
-----

* gh-133166: Corrige regressão onde "PyType_GetModuleByDef()" retorna
  NULL sem definir "TypeError" quando um tipo estático é passado.

* gh-133164: Adicionada a função
  "PyUnstable_Object_IsUniqueReferencedTemporary()" para determinar se
  um objeto existe como uma variável temporária única na pilha do
  interpretador. Esta função substitui alguns casos em que verificar
  se "Py_REFCNT()" é uma variável temporária não é mais suficiente
  para determinar se é seguro modificar um objeto Python no local sem
  efeitos colaterais visíveis.

* gh-133140: Adiciona "PyUnstable_Object_IsUniquelyReferenced()" como
  um substituto para "Py_REFNCT(op) == 1" em construções com *threads
  livres* do Python.

* gh-131747: Em plataformas não Windows, descontinua o uso de
  "ctypes.Structure._pack_" para usar um layout compatível com o
  Windows. O layout deve ser especificado explicitamente definindo
  "ctypes.Structure._layout_" como "'ms'".

* gh-128972: Para construções sem threads livres, o layout de memória
  de "PyASCIIObject" é revertido para corresponder ao Python 3.13.
  (Observe que a estrutura não faz parte da ABI estável e, portanto,
  seu layout de memória tem *garantia* de estabilidade.)

* gh-133079: As APIs não documentadas "Py_C_RECURSION_LIMIT" e
  "PyThreadState.c_recursion_remaining", adicionadas na versão 3.13,
  foram removidas sem um período de descontinuação.

* gh-132987: Os formatos "k" e "K" em "PyArg_Parse()" agora oferecem
  suporte ao método especial "__index__()", como todos os outros
  formatos inteiros.

* gh-132909: Corrige um estouro ao manipular o formato K em
  "Py_BuildValue()". Patch por Bénédikt Tran.

* gh-132798: As funções descontinuadas e não documentadas
  "PyUnicode_AsEncodedObject()", "PyUnicode_AsDecodedObject()",
  "PyUnicode_AsEncodedUnicode()" e "PyUnicode_AsDecodedUnicode()"
  estão programadas para remoção na versão 3.15.

* gh-132470: Cria um "ctypes.CField" com um *byte_size* que não
  corresponde ao tamanho do tipo real agora levanta um "ValueError" em
  vez de travar o interpretador.

* gh-112068: [Revertido em gh-136991] Adicionado suporte a argumentos
  anuláveis em "PyArg_Parse()" e funções similares. Adicionar "?" após
  qualquer unidade de formato faz com que "None" seja aceito como
  valor.

* gh-50333: Sequências não-tuplas estão descontinuadas como argumento
  para a unidade de formato "(items)" em "PyArg_ParseTuple()" e outras
  funções de análise de argumentos se *items* contiver unidades de
  formato que armazenam um buffer emprestado ou uma *referência
  emprestada*.


Construção
----------

* gh-113464: Use o repositório "externals" cpython-bin-deps para o
  gerenciamento de dependências do Windows LLVM. A instalação manual
  do LLVM não é mais necessária para construções JIT do Windows.

* gh-133183: Os shims do compilador iOS agora incluem
  "IPHONEOS_DEPLOYMENT_TARGET" em triplos de destino, garantindo que
  os mínimos da versão do SDK sejam respeitados.

* gh-133167: Corrige o processo de compilação com "--enable-
  optimizations" e "--without-docstrings".

* gh-133171: Como as construções com threads livres não oferecem
  suporte ao compilador JIT experimental, evita que essas
  configurações sejam combinadas.

* gh-132758: Corrige construção com interpretador de chamada de cauda
  e pystats.

* gh-132649: O script "PClayout" agora permite passar "--include-
  tcltk" no Windows ARM64.

* gh-132257: Altera os sinalizadores LTO padrão no GCC para não passar
  "-flto-partition=none" e permitir a paralelização de LTO. Para
  versões GNU mais recentes e GCC, isso representa um aumento de
  velocidade múltiplo nos tempos de construção com LTO, sem perda
  perceptível de desempenho.

* gh-132026: Corrige o uso de identificadores indefinidos na detecção
  de tripletos de plataforma em plataformas MIPS Linux.


Python 3.14.0 alpha 7
=====================

*Data de lançamento: 2025-04-08*


macOS
-----

* gh-124111: Atualiza o instalador do macOS para usar o Tcl/Tk 8.6.16.

* gh-131423: Atualiza o instalador do macOS para usar o OpenSSL
  3.0.16. Patch por Bénédikt Tran.

* gh-131025: Atualiza o instalador do macOS para ser fornecido com o
  SQLite 3.49.1.


Windows
-------

* gh-131423: Atualiza a versão empacotada do OpenSSL para 3.0.16. A
  nova construção também desabilita o suporte a uplink, o que pode ser
  relevante para incorporadores, mas não tem impacto no uso normal.

* gh-131453: Algumas constantes "SND_*" e "MB_*" foram adicionadas ao
  "winsound".

* gh-91349: Substitui nossa cópia de "zlib" por "zlib-ng", para
  melhorias de desempenho em "zlib".

* gh-131025: Atualiza o instalador do Windows para ser fornecido com o
  SQLite 3.49.1.


Ferramentas/Demos
-----------------

* gh-132121: Sempre escapa caracteres Unicode não imprimíveis em
  **pygettext**.

* gh-131852: **msgfmt** não adiciona mais "POT-Creation-Date" aos
  arquivos ".mo" gerados para consistência com GNU "msgfmt".


Testes
------

* gh-131277: Permite remover a configuração de uma ou mais variáveis
  de ambiente simultaneamente via "EnvironmentVarGuard.unset()". Patch
  por Bénédikt Tran.

* gh-131050: "test_ssl.test_dh_params" é ignorado se a biblioteca TLS
  subjacente não oferecer suporte a Diffie-Hellman efêmero de campo
  finito.


Segurança
---------

* gh-131809: Atualiza libexpat empacotado para 2.7.1

* gh-131261: Atualiza para libexpat 2.7.0

* gh-121284: Corrige bug na dobragem (*folding*) de palavras
  codificadas do rfc2047 ao achatar uma mensagem de e-mail usando uma
  política de e-mail moderna. Anteriormente, quando uma palavra
  codificada era muito longa para uma linha, ela era decodificada,
  dividida em linhas e recodificada. Mas vírgulas e outros caracteres
  especiais no texto original podiam ser deixados sem codificação e
  sem aspas. Isso poderia teoricamente ser usado para falsificar
  linhas de cabeçalho usando uma palavra codificada cuidadosamente
  construída se o e-mail renderizado resultante fosse transmitido ou
  reanalisado.


Biblioteca
----------

* gh-132174: Corrige o nome da função na mensagem de erro
  "_interpreters.run_string".

* gh-132171: Corrige falha de "_interpreters.run_string" em subclasses
  de string.

* gh-129204: Introduz o novo botão de variável de ambiente
  "_PYTHON_SUBPROCESS_USE_POSIX_SPAWN" em "subprocess" para controlar
  o uso de "os.posix_spawn()".

* gh-132159: Não oculta argumentos de usuário em "__new__()" gerado
  pelo decorador "warnings.deprecated". Patch por Xuehai Pan.

* gh-132168: O tipo "ctypes.py_object" agora oferece suporte a
  subscrição, tornando-o um *tipo genérico*.

* gh-84481: Adiciona o atributo "zipfile.ZipFile.data_offset", que
  armazena o deslocamento para o início dos dados ZIP em um arquivo,
  quando disponível. Quando o atributo "zipfile.ZipFile" for aberto no
  modo "'w'" ou "'x'" e o arquivo subjacente não oferecer suporte a
  "tell()", o valor será "None".

* gh-132075: Corrige possível uso de estruturas de endereço "socket"
  com membros não inicializados. Agora, todos os membros da estrutura
  são inicializados com zeros por padrão.

* gh-118761: Melhora o tempo de importação em até 27x para o módulo
  "string". Patch por Adam Turner.

* gh-125434: Exibe o nome da thread em "faulthandler". Patch por
  Victor Stinner.

* gh-132002: Corrige falha ao desalocar "contextvars.ContextVar" com
  nomes de strings estranhos e não hasheáveis.

* gh-131938: "xml.etree.ElementTree": Atualiza a mensagem de erro
  quando um elemento a ser removido via "Element.remove" não é
  encontrado. Patch por Bénédikt Tran.

* gh-115942: Adiciona "threading.RLock.locked()",
  "multiprocessing.Lock.locked()", "multiprocessing.RLock.locked()" e
  permite "multiprocessing.managers.SyncManager.Lock()" e
  "multiprocessing.managers.SyncManager.RLock()" intermediar chamada
  de "locked()".

* gh-131974: Corrige vários problemas de segurança de thread em
  "ctypes" na construção com *threads livres*.

* gh-118761: Melhora o tempo de importação do módulo "ast" extraindo a
  função "unparse()" para um módulo auxiliar.

* gh-107369: Melhorado o desempenho de "textwrap.indent()" em uma
  média de ~1,3x. Patch por Adam Turner.

* gh-131792: Melhoramos o desempenho de "textwrap.dedent()" em uma
  média de ~2,4x (com melhorias de até 4x para entradas grandes) e
  corrigimos um bug em que linhas em branco com caracteres de espaço
  em branco diferentes de espaço ou de tabulação horizontal não eram
  normalizadas para quebra de linha. Patch por Adam Turner, Marius
  Juston e Pieter Eendebak.

* gh-131668: "socket": Corrige código que analisa endereços de soquete
  AF_BLUETOOTH.

* gh-60115: suporte a módulos congelados para "linecache.getline()".

* gh-131492: Corrige um vazamento de recursos quando a construção de
  um "gzip.GzipFile" com um nome de arquivo falha, por exemplo, ao
  passar um "compresslevel" inválido.

* gh-131435: Melhoria de desempenho de 10-20% de "random.randint()".

* gh-131461: Corrige "ResourceWarning" ao construir um "gzip.GzipFile"
  no modo de gravação com um objeto de arquivo quebrado.

* gh-125866: Descontinua o módulo "nturl2path". Em vez disso, chame
  "urllib.request.url2pathname()" e "pathname2url()".

* gh-126367: Corrige problema em que "urllib.request.url2pathname()"
  levantava "OSError" ao receber um URI do Windows contendo um
  caractere de dois pontos que não seguia uma letra de unidade, como
  antes de um fluxo de dados alternativo NTFS.

* gh-120144: Desabilita o evento "CALL" em "bdb" no backend
  "monitoring" quando não precisarmos de novos eventos no objeto
  código para obter um melhor desempenho.

* gh-131358: Registra "cseuckr" como um apelido de codificação para
  "euc_kr".

* gh-131325: Corrige implementação de fallback do sendfile para drenar
  dados após gravar no transporte em "asyncio".

* gh-90548: "platform.libc_ver()" agora pode detectar e relatar a
  versão de "musl" no Alpine Linux.

* gh-129843: Corrige passagem de argumento incorreta em
  "warnings.warn_explicit()".

* gh-70647: Ao criar um objeto "datetime" com uma data fora do
  intervalo, um erro mais informativo é levantado.

* gh-130914: Permite que "graphlib.TopologicalSorter.prepare()" seja
  chamado mais de uma vez, desde que a classificação não tenha sido
  iniciada. Patch por Daniel Pope.

* gh-131236: Permite gerar vários UUIDs de uma só vez via "python -m
  uuid --count".

* gh-126895: Corrige "readline" em construção com *threads livres*.

* gh-121468: "$_asynctask" é adicionado como uma variável de
  conveniência "pdb" para acessar a tarefa asyncio atual, se
  aplicável.

* gh-118761: Melhoria no tempo de importação de "locale" usando a
  importação preguiçosa "re". Patch por Semyon Moroz.

* gh-129598: Corrige "ast.unparse()" quando "ast.Interactive" contém
  múltiplas instruções.

* gh-85162: O módulo "http.server" agora inclui suporte embutido para
  servidores HTTPS expostos por "http.server.HTTPSServer". Essa
  funcionalidade é exposta pela interface de linha de comando ("python
  -m http.server") por meio das opções "--tls-cert", "--tls-key" e "--
  tls-password-file". Patch por Semyon Moroz.

* gh-129463: As implementações de igualdade e hash para
  "annotationlib.ForwardRef" agora usam todos os atributos do objeto.
  Dois objetos "ForwardRef" são iguais somente se todos os atributos
  forem iguais.

* gh-128593: Objetos "annotationlib.ForwardRef" não armazenam mais
  seus valores em cache quando são avaliados com sucesso. Chamadas
  sucessivas para "annotationlib.ForwardRef.evaluate()" podem retornar
  valores diferentes.

* gh-117779: Corrigida a leitura de entradas duplicadas em "zipfile"
  por nome. A leitura de entradas duplicadas (exceto a última) por
  "ZipInfo" agora emite um aviso em vez de levantar uma exceção.

* gh-128715: A classe de descritores de campo "Structure"/"Union"
  agora está disponível como "CField" e tem novos atributos para
  auxiliar na depuração e introspecção.

* gh-128055: Corrige "test.test_sysconfig.test_sysconfigdata_json" ao
  executar fora do diretório de construção (por exemplo, após a
  instalação).

* gh-126037: "xml.etree.ElementTree": Corrige uma falha em
  "Element.find", "Element.findtext" e "Element.findall" quando a tag
  a ser encontrada implementa um método "__eq__()" que altera o
  elemento que está sendo consultado. Patch por Bénédikt Tran.

* gh-127794: Quando cabeçalhos são adicionados aos objetos
  "email.message.Message", por meio de
  "email.message.Message.__setitem__()" ou
  "email.message.Message.add_header()", o nome do campo agora é
  validado de acordo com **RFC 5322, Seção 2.2** e uma "ValueError" é
  levantada se o nome do campo contiver caracteres inválidos.

* gh-123599: Descontinua "pathlib.PurePath.as_uri()"; em vez disso,
  use "pathlib.Path.as_uri()".

* gh-126033: "xml.etree.ElementTree": Corrige uma falha em
  "Element.remove" quando o elemento é mutado simultaneamente. Patch
  por Bénédikt Tran.

* gh-120144: Adiciona o backend opcional de "sys.monitoring" a "bdb" e
  usa-o para "pdb".

* gh-74598: Adiciona "fnmatch.filterfalse()" para excluir nomes que
  correspondam a um padrão. Patch por Bénédikt Tran.

* gh-114917: Adiciona suporte para AI_NUMERICSERV na emulação
  getaddrinfo

* bpo-17254: Adicionados apelidos para o idioma tailandês usando o
  Microsoft Code Pages.


Documentação
------------

* gh-131417: Menciona "asyncio.Future" e "asyncio.Task" na lista de
  classes genéricas.


Núcleo e embutidos
------------------

* gh-131798: Permite que o JIT remova uma instrução extra
  "_TO_BOOL_BOOL" após "_CONTAINS_OP_SET" definindo o tipo de retorno
  como bool.

* gh-132011: Corrige falha ao chamar "list.append()" como um método
  não vinculado.

* gh-131998: Corrige uma falha ao usar um objeto de método não
  vinculado *descritor* em uma função onde um descritor de método
  vinculado foi usado.

* gh-131591: Implementa a **PEP 768** (interface de depuração externa
  segura para CPython). Adiciona uma nova função "sys.remote_exec()"
  ao módulo "sys". Esta função agenda a execução de um arquivo Python
  em um processo separado. Patch por Pablo Galindo, Matt Wozniski e
  Ivona Stojanovic.

* gh-131798: Permite que o JIT omita a proteção str no teste de
  veracidade quando o tipo str for conhecido.

* gh-131833: Adiciona suporte para a remoção opcional de parênteses de
  agrupamento ao usar vários tipos de exceção, conforme a **PEP 758**.
  Patch por Pablo Galindo.

* gh-130924: O uso de um nome em uma anotação de escopo de função não
  aciona mais a criação de uma célula para essa variável. Isso corrige
  uma regressão em versões alfa anteriores do Python 3.14.

* gh-131800: Melhora a capacidade do JIT experimental de remover
  verificações de tipo para determinadas operações de subscrição.

* gh-131738: O compilador emite código otimizado para chamadas
  any/all/tuple embutidas sobre uma expressão geradora.

* gh-131719: Corrige a falta de verificação de NULL em
  "_PyMem_FreeDelayed" na construção com *threads livres*.

* gh-131670: Corrige falha em "anext()" na sincronização "__anext__()"
  levantando uma exceção.

* gh-131666: Correção da assinatura dos objetos
  "anext_awaitable.close". Patch por Bénédikt Tran.

* gh-130415: Otimiza a comparação de duas constantes em construções
  JIT

* gh-129149: Adiciona um atalho para inteiros pequenos e médios em
  "PyLong_FromInt32()", "PyLong_FromUInt32()", "PyLong_FromInt64()" e
  "PyLong_FromUInt64()". Patch por Chris Eibl.

* gh-130887: Otimiza a geração de código AArch64 para o JIT. Patch por
  Diego Russo

* gh-130956: Otimiza a geração de código AArch64 para o JIT. Patch por
  Diego Russo

* gh-130928: Corrige mensagem de erro ao formatar bytes usando o
  sinalizador "'i'". Patch por Maxim Ageev.

* gh-130935: Anotações em nível de classe e módulo definidas
  condicionalmente agora só são refletidas em "__annotations__" se o
  bloco em que se encontram for executado. Patch por Jelle Zijlstra.

* gh-130775: Não falha em "column" negativo e "end_column" em locais
  "ast".

* gh-130704: Otimize "LOAD_FAST" e sua forma de superinstrução para
  reduzir a sobrecarga na contagem de referências. Essas instruções
  são substituídas por variantes mais rápidas que carregam referências
  emprestadas na pilha de operandos quando podemos provar que a
  referência no quadro sobrevive à referência carregada na pilha.

* gh-88887: Corrigindo vazamento do processo de multiprocessamento
  Resource Tracker, geralmente observado ao executar Python como PID
  1.

* gh-130115: Corrige um problema com identificadores de thread sendo
  estendidos por sinal em algumas plataformas.


Biblioteca
----------

* gh-99108: Adiciona suporte para implementação embutida de HMAC
  (**RFC 2104**) com base em HACL*. Patch por Bénédikt Tran.


Núcleo e embutidos
------------------

* gh-130080: Implementa a PEP 765: Não permitir return/break/continue
  que saiam de um bloco finally.

* gh-129900: Corrige códigos de retorno dentro de "SystemExit" que não
  estão sendo retornados pelo REPL.

* gh-128632: Não mais permite "__classdict__" como nome de um
  parâmetro de tipo. Usar esse nome anteriormente travava o
  interpretador em algumas circunstâncias.

* gh-126703: Melhora o desempenho dos métodos embutidos usando uma
  freelist.

* gh-126703: Melhora o desempenho de "range" usando uma freelist.


API C
-----

* gh-131740: Atualiza PyUnstable_GC_VisitObjects para percorrer a
  geração permanente.

* gh-131525: O PyTupleObject agora armazena em cache o valor de hash
  calculado no novo campo ob_hash.


Construção
----------

* gh-131865: A construção do DTrace agora passa corretamente as
  variáveis "CC" e "CFLAGS" para o comando "dtrace" ao utilizar o
  SystemTap no Linux.

* gh-131675: Corrige construções da biblioteca mimalloc para alvos ARM
  de 32 bits.

* gh-131691: O clang-cl no Windows precisa da opção "/EHa" para
  oferecer suporte a SEH (gerenciamento de exceções estruturadas)
  corretamente. Correção por Chris Eibl.

* gh-131278: Adiciona o sinalizador de otimização
  "WITH_COMPUTED_GOTOS" às construções do Windows para quando usar um
  compilador compatível (atualmente clang-cl). Patch por Chris Eibl.

* gh-130213: Atualiza a biblioteca HACL* fornecida para corrigir
  problemas de construção com compiladores clang mais antigos.

* gh-130673: Corrige possível erro "KeyError" ao manipular seções de
  objetos durante o processo de construção JIT.


Python 3.14.0 alpha 6
=====================

*Data de lançamento: 2025-03-14*


macOS
-----

* gh-128540: Garante que o navegador da web seja iniciado por
  "webbrowser.open()" no macOS, mesmo para URLs "file://".


Windows
-------

* gh-131020: pylauncher detecta corretamente um BOM ao procurar pelo
  shebang. Correção por Chris Eibl.


Ferramentas/Demos
-----------------

* gh-130453: Torna possível substituir palavra reservada padrão em
  **pygettext**.

* gh-85012: Redefine corretamente "msgctxt" ao compilar mensagens em
  **msgfmt**.

* gh-130453: Estende o suporte para especificar palavras reservadas
  personalizadas em **pygettext**.

* gh-130195: Adiciona mensagens de aviso quando a opção "-a/--extract-
  all" não implementada "pygettext" for chamada.

* gh-130057: Adiciona suporte para comentários do tradutor em
  **pygettext.py**.

* gh-130025: O ambiente de teste do iOS agora manipula corretamente
  links simbólicos usados como referências de framework Python.

* gh-129911: Corrige a entrada de palavra reservada na saída de ajuda
  de **pygettext**.


Testes
------

* gh-129200: Agora, vários executores do ambiente de testes do iOS
  podem ser iniciados ao mesmo tempo sem gerar ambiguidade sobre a
  propriedade do simulador.

* gh-130292: O banco de testes do iOS agora será executado com sucesso
  em uma máquina que não executou testes do Xcode anteriormente (como
  configurações de CI).

* gh-130293: Os testes de colorização terminal não são mais sensíveis
  ao valor da variável "TERM" no ambiente de teste.

* gh-129401: Corrige um teste instável em "test_repr_rlock" que
  verifica a representação de "multiprocessing.RLock".

* gh-126332: Adiciona testes de unidade para pyrepl.


Segurança
---------

* gh-127371: Evita buffering ilimitado para
  "tempfile.SpooledTemporaryFile.writelines()". Anteriormente, o
  spillover de disco era verificado somente após o iterador de linhas
  ter sido esgotado. Agora, isso é feito após cada linha ser escrita.


Biblioteca
----------

* gh-131204: Usa a fonte monoespaçada do System Font Stack para
  suporte multiplataforma em "difflib.HtmlDiff".

* gh-131196: Melhora o desempenho de "uuid.UUID.hex" e
  "uuid.UUID.__str__".

* gh-130940: O comportamento de "PyConfig.use_system_logger" foi
  modificado para ser habilitado por padrão no iOS. Ele permanece
  desabilitado por padrão no macOS.

* gh-131123: Complementações suportadas para atributos de variáveis de
  conveniência em "pdb".

* gh-93096: Removida CLI não documentado "python -m difflib". Em vez
  disso, use "python -m doctest Lib/difflib.py -v". Patch por Semyon
  Moroz.

* gh-93096: Removidos os argumentos não documentados "-t" e "-v" de
  "python -m pickle". Use "python -m doctest Lib/pickle.py -v" em seu
  lugar. Patch por Semyon Moroz.

* gh-81267: Corrige a mensagem de erro "time.sleep()" quando um objeto
  que não pode ser interpretado como um inteiro ou float é fornecido.

* gh-93096: Removidos os argumentos não documentados "-t" e "-v" de
  "python -m pickletools". Em vez disso, use "python -m doctest
  Lib/pickletools.py -v". Patch por Semyon Moroz.

* gh-131045: Corrige problema com "__contains__", valores e
  pseudomembros para "enum.Flag".

* gh-130959: Corrige implementação puro Python de
  "datetime.time.fromisoformat()" para rejeitar horários com espaços
  na parte fracionária (por exemplo, "12:34:56.400 +02:00"),
  correspondendo à implementação C. Patch por Michał Gorny.

* gh-130806: Exclui "gzip.GzipFile" antes de ser fechado agora emite
  uma "ResourceWarning".

